proc Cal { pw w } {
    global CAL CAL_DATA MAIN
    Unset CAL
    set CAL(year) $MAIN(year)
    pack [frame $w.y -bd 2 -relief groove] -pady 2 -padx 3
    pack [SpinBox $w.y.sb -label " " -helptext "     " \
                  -range { 2000 2032 1 } -textvariable CAL(year) -width 6 \
                  -justify center -editable no -modifycmd Cal:Sel] -pady 3 -padx 5
    
    pack [frame $w.c -bd 1 -relief sunken] -pady 2 -padx 3
    pack [table $w.c.tbl -width 4 -height 14 -cols 4 -rows 14 -relief flat \
        -browsecommand { Cal:Tbl:Browsecommand %W } \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable CAL_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0]
        
    TkTableInitTag $w.c.tbl
    TkTableInitBind $w.c.tbl
    
    $w.c.tbl width 0 12  1 6  2 6 3 7
    $w.c.tbl tag col TitleCol 0
    $w.c.tbl tag col AnchorE 1 2 3
    $w.c.tbl spans -2,0 1,0 -2,1 0,1 -2,3 1,0
    
    bind $w.c.tbl <KeyPress-Down>       {}
    
    bind $w        <FocusIn>       "Rn:Activate:TF $pw"
    bind $w        <FocusOut>      "Rn:DeActivate:TF $pw"
    bind $w.c.tbl  <F8>            "Cal:Del $w.c.tbl {}"
    
    DynamicHelp::register $w.c.tbl balloon "     "
    set CAL(tblwindow) $w.c.tbl
}

proc Cal:Tbl:Browsecommand { w } {
    global CAL CAL_DATA
    set active [$w index active]
    if ![IsBe CAL(oldactive)] { set CAL(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $CAL(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        Cal:Write $w $idxwrt
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set CAL(oldactive) $active
    
}

