proc Cal:Init:CAL_DATA {} {
    global CAL_DATA CAL_OLDDATA
    Unset CAL_DATA CAL_OLDDATA
    set m { " " " " " " " " " " " " " "
            " " " " " " " " " " }
    set i 0
    foreach idx $m {
        set CAL_DATA($i,0) $idx
        incr i
    }
    set CAL_DATA(-2,0) 
    set CAL_DATA(-2,1) 
    set CAL_DATA(-1,1) .
    set CAL_DATA(-1,2) .
    set CAL_DATA(-2,3) 
}

proc Cal:Sel {} {
    global CAL_DATA RN CAL MAIN CAL_OLDDATA
    Cal:Init:CAL_DATA 
    set w $CAL(tblwindow)
    BeforeQuery RN "    ... "
    set i 0
    set query "select cod, date_part('month',dat) as m, dk, d, h from cal \
                where rn_cod = '$RN(cod)' and \
                      date_part('year',dat) = '$CAL(year)' \
                order by 2"
    dpg_select .rn $MAIN(iddbs) $query A {
        set row [expr $A(m) - 1]
        set CAL_DATA($row,cod) $A(cod)
        set CAL_DATA($row,1)   $A(dk)
        set CAL_DATA($row,2)   $A(d)
        set CAL_DATA($row,3)   $A(h)
        ProgressIncr RN(progress) [incr i] 4
    }
    array set CAL_OLDDATA [array get CAL_DATA]
    TkTableRowTagErrorNull $w
    AfterQuery RN
}

proc Cal:Write { w row } {
    global CAL_DATA CAL_OLDDATA
    if [info exist CAL_DATA($row,cod)] {
        if { ( $CAL_DATA($row,1) != $CAL_OLDDATA($row,1) ||
               $CAL_DATA($row,2) != $CAL_OLDDATA($row,2) ||
               $CAL_DATA($row,3) != $CAL_OLDDATA($row,3) ) && 
             [IsBe CAL_DATA($row,1)] && 
             [IsBe CAL_DATA($row,2)] && 
             [IsBe CAL_DATA($row,3)] } { 
            Cal:Upd $w $row
        } elseif { ![IsBe CAL_DATA($row,1)] && 
                   ![IsBe CAL_DATA($row,2)] &&
                   ![IsBe CAL_DATA($row,3)] &&
                   [IsBe CAL_OLDDATA($row,1)] && 
                   [IsBe CAL_OLDDATA($row,2)] && 
                   [IsBe CAL_OLDDATA($row,3)] } { 
            Cal:Del $w $row
        }
    } else {
        if { [IsBe CAL_DATA($row,1)] && 
             [IsBe CAL_DATA($row,2)] && 
             [IsBe CAL_DATA($row,3)] } {
            Cal:Ins $w $row
        }
    }
}

proc Cal:Ins { w row } {
    global RN CAL_DATA CAL MAIN CAL_OLDDATA
    BeforeQuery RN "   $row ... "
    set query "select cal_ins('$RN(cod)',  '$CAL(year)', '[expr $row + 1]', \
                      '$CAL_DATA($row,1)', '$CAL_DATA($row,2)', '$CAL_DATA($row,3)') as cod"
    set err [dpg_select .rn $MAIN(iddbs) $query A {
        set CAL_DATA($row,cod) $A(cod)
        incr RN(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        set CAL_OLDDATA($row,cod) $CAL_DATA($row,cod)
        set CAL_OLDDATA($row,1)   $CAL_DATA($row,1)
        set CAL_OLDDATA($row,2)   $CAL_DATA($row,2)
        set CAL_OLDDATA($row,3)   $CAL_DATA($row,3)
        $w tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery RN
}

proc Cal:Upd { w row } {
    global RN CAL_DATA CAL MAIN CAL_OLDDATA
    BeforeQuery RN "   $row ... "
    set query "select cal_upd('$CAL_DATA($row,cod)', '$CAL_DATA($row,1)', \
                      '$CAL_DATA($row,2)', '$CAL_DATA($row,3)')"
    set err [dpg_select .rn $MAIN(iddbs) $query A {
        incr RN(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        set CAL_OLDDATA($row,1)   $CAL_DATA($row,1)
        set CAL_OLDDATA($row,2)   $CAL_DATA($row,2)
        set CAL_OLDDATA($row,3)   $CAL_DATA($row,3)
        $w tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery RN
}

proc Cal:Del { w row } {
    global RN CAL_DATA CAL MAIN CAL_OLDDATA
    if ![IsBe row] { set row [$w index active row] }
    if [IsBe CAL_DATA($row,cod)] {
        if ![MessageDlg .rn.dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery RN "   $row ... "
            set query "select cal_del('$CAL_DATA($row,cod)')"
            set err [dpg_select .rn $MAIN(iddbs) $query A {
                incr RN(progress)
            }]
            if { $err == -1 } {
                $w tag row Error $row
            } else {
                foreach i { cod 1 2 } {
                    set CAL_DATA($row,$i) ""
                    Unset CAL_DATA($row,$i) CAL_OLDDATA($row,$i)
                }
                $w tag row CurrentRow $row
            }
            AfterQuery RN
        }
    }
}
