proc Dol { pw w } {
    global DOL DOL_DATA
    Unset DOL
    pack [frame $w.f -bd 1 -relief sunken] -anchor sw  -pady 2 -padx 3
    pack [scrollbar $w.f.sby -command "$w.f.tbl yview"] -side right -fill y
    pack [table $w.f.tbl -width 6 -height 12 -cols 6 -rows 12 -relief flat \
        -yscrollcommand "$w.f.sby set" \
        -browsecommand { Dol:Tbl:Browsecommand %W } \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable DOL_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0] -side left
        
    TkTableInitTag $w.f.tbl
    TkTableInitBind $w.f.tbl
    $w.f.tbl width 0 30  1 25  2 5  3 9  4 9  5 9
    $w.f.tbl tag col AnchorE 2 3 4 5
    $w.f.tbl spans -2,0 1,0  -2,1 1,0  -2,2 1,0  -2,3 1,0  -2,4 1,0 -2,5 1,0
    
    bind $w       <FocusIn>       "Strorg:Activate:TF $pw"
    bind $w       <FocusOut>      "Strorg:DeActivate:TF $pw"
    bind $w.f.tbl <F8>            "Dol:Del $w.f.tbl"
    DynamicHelp::register $w.f.tbl balloon "   "
    set DOL(tblwindow) $w.f.tbl
}

proc Dol:Tbl:Browsecommand { w } {
    global DOL DOL_DATA STRORG DOL_OLDDATA
    set active [$w index active]
    if ![IsBe DOL(oldactive)] { set DOL(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $DOL(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    # after rn_nam
    if { $oldcol == 1 && [info exists DOL_DATA($oldrow,1)] } {
        if { ![info exists DOL_OLDDATA($oldrow,1)] ||
             $DOL_DATA($oldrow,1) != $DOL_OLDDATA($oldrow,1) } {
            set heret [He STRORG $w -width 30 -find $DOL_DATA($oldrow,1) -side top \
                             -deltay [expr 35 + 17 * $oldrow] -deltax 244 \
                             -title "   " \
                             -query "select a.nam, a.cod from rn a \
                                        where \[Construct a.nam \${wdd}HE(find)\] \
                                        order by a.nam"]
            set DOL_DATA($oldrow,1)      [lindex $heret 0]
            set DOL_DATA($oldrow,rn_cod) [lindex $heret 1]
        }
    }

    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        Dol:Write $w $idxwrt
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set DOL(oldactive) $active
}

