proc Dol:Init:DOL_DATA {} {
    global DOL_DATA DOL_OLDDATA
    Unset DOL_DATA DOL_OLDDATA
    set i 0
    foreach str { " " "  " "" "" "" "% -\n" } {
        set DOL_DATA(-2,$i) $str
        incr i
    }
}

proc Dol:Sel {} {
    global DOL_DATA STRORG DOL MAIN DOL_OLDDATA
    Dol:Init:DOL_DATA 
    set w       $DOL(tblwindow)
    set titrows [$w cget -titlerows]
    BeforeQuery STRORG "    ... "
    set i 0
    
    set query "select a.cod, a.rn_cod, a.nam as dolnam, b.nam as rnnam, a.kold, a.oklad, a.tarif, a.kom \
                   from dol a, rn b \
                   where a.rn_cod = b.cod and \
                         a.cod in (select dol_cod from strorgdollink \
                                       where strorg_cod = '$STRORG(cod)') \
                   order by a.nam"
    
    dpg_select .strorg $MAIN(iddbs) $query A {
        foreach { j k } { cod   cod  rn_cod rn_cod  kold 2  \
                          oklad 3    tarif  4       kom  5 } {
            set DOL_DATA($i,$k) $A($j)
        }
        foreach { j k } { dolnam 0  rnnam 1 } {
            set DOL_DATA($i,$k) [cnvs $A($j)]
        }
        ProgressIncr STRORG(progress) [incr i] 4
    }
    
    array set DOL_OLDDATA [array get DOL_DATA]
    if { $i > [expr [$w cget -rows] - $titrows] } {
        $w configure -rows [expr $i + $titrows]
    } else {
        $w configure -rows [$w cget -height]
    }
    TkTableRowTagErrorNull $w
    AfterQuery STRORG
}

proc Dol:Write { w row } {
    global DOL_DATA DOL_OLDDATA
    if [info exist DOL_DATA($row,cod)] {
        if { $DOL_DATA($row,0) != $DOL_OLDDATA($row,0) ||
             $DOL_DATA($row,1) != $DOL_OLDDATA($row,1) ||
             $DOL_DATA($row,2) != $DOL_OLDDATA($row,2) ||
             $DOL_DATA($row,3) != $DOL_OLDDATA($row,3) ||
             $DOL_DATA($row,4) != $DOL_OLDDATA($row,4) ||
             $DOL_DATA($row,5) != $DOL_OLDDATA($row,5) } {
            Dol:Upd $w $row
        }
    } else {
        if { [IsBe DOL_DATA($row,0)] && [IsBe DOL_DATA($row,rn_cod)] &&
             [IsBe DOL_DATA($row,2)] && [IsBe DOL_DATA($row,3)] &&
             [IsBe DOL_DATA($row,4)] && [IsBe DOL_DATA($row,5)] } {
            Dol:Ins $w $row
        }
    }
}

proc Dol:Ins { w row } {
    global STRORG DOL_DATA DOL MAIN DOL_OLDDATA
    BeforeQuery STRORG "   $row ... "
    set query "select dol_ins('$STRORG(cod)', '$DOL_DATA($row,rn_cod)', \
                              '[cnvi $DOL_DATA($row,0)]', '$DOL_DATA($row,2)', \
                              '$DOL_DATA($row,3)', '$DOL_DATA($row,4)', \
                              '$DOL_DATA($row,5)') as cod"
    set err [dpg_select .strorg $MAIN(iddbs) $query A {
        set DOL_DATA($row,cod) $A(cod)
        incr STRORG(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        foreach j { cod rn_cod 0 1 2 3 4 5 } {
            set DOL_OLDDATA($row,$j) $DOL_DATA($row,$j)
        }
        $w tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery STRORG
}

proc Dol:Upd { w row } {
    global STRORG DOL_DATA DOL MAIN DOL_OLDDATA
    BeforeQuery STRORG "   $row ... "
    set query "select dol_upd('$DOL_DATA($row,cod)', '$DOL_DATA($row,rn_cod)', \
                              '[cnvi $DOL_DATA($row,0)]', '$DOL_DATA($row,2)', \
                              '$DOL_DATA($row,3)', '$DOL_DATA($row,4)', \
                              '$DOL_DATA($row,5)') as cod"
    set err [dpg_select .strorg $MAIN(iddbs) $query A {
        incr STRORG(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        set DOL_OLDDATA($row,rn_cod) $DOL_DATA($row,rn_cod)
        set DOL_OLDDATA($row,0)      $DOL_DATA($row,0)
        set DOL_OLDDATA($row,1)      $DOL_DATA($row,1)
        set DOL_OLDDATA($row,2)      $DOL_DATA($row,2)
        set DOL_OLDDATA($row,3)      $DOL_DATA($row,3)
        set DOL_OLDDATA($row,4)      $DOL_DATA($row,4)
        set DOL_OLDDATA($row,5)      $DOL_DATA($row,5)
        $w tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery STRORG
}

proc Dol:Del { w } {
    global STRORG DOL_DATA DOL MAIN DOL_OLDDATA
    set row [$w index active row]
    if [IsBe DOL_DATA($row,cod)] {
        if ![MessageDlg .strorg.dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery STRORG "   $row ... "
            set query "select dol_del('$DOL_DATA($row,cod)')"
            set err [dpg_select .strorg $MAIN(iddbs) $query A {
                incr STRORG(progress)
            }]
            if { $err == -1 } {
                $w tag row Error $row
            } else {
                $w tag row CurrentRow $row
                Dol:Sel
            }
            AfterQuery STRORG
        }
    }
}
