proc F8dr:Execute { tpl } {
    F8dr:Report $tpl
}

proc F8dr:Report { tpl } {
    global MAIN F8DR
    
    set kv $F8DR(head_kvartal)
    set y  $F8DR(head_year)
    
    set m1 [expr $kv * 3 - 2]
    set m2 [expr $kv * 3]
    
    if ![MessageDlg $tpl.dlg -buttons { } -icon question -type user -message "  \n  $kv  $y  ?" -default 0] {
        BeforeQuery F8DR "   ... "
        report start f8dr
        set kmd_cod [Stat:Get:Cod 4]

        dpg_select $tpl $MAIN(iddbs) \
            "select count(distinct cod) as cnt
                from sotdoldtdukd
                where (du is null or du >= '01.$m1.$y') and
                      kd = '01'" A {
            set kolsotp [NullZero $A(cnt)]
        }
        
        dpg_select $tpl $MAIN(iddbs) \
            "select count(distinct cod) as cnt
                from sotdoldtdukd
                where (du is null or du >= '01.$m1.$y') and
                      kd = '02'" A {
            set kolsots [NullZero $A(cnt)]
        }

        set query "select a.cod, a.inn,
                    date_part('month',b.datvidano) as vm,
                    date_part('year',b.datvidano) as vy,
                    case when c.kod is null then a.kd else c.kod end as nkod,
                    sum(b.summa) as sumvidano,
                    (select sum(x1.summa) from oper x1
                        where date_part('month',b.datperiod) = date_part('month',x1.datvidano) and
                              date_part('year',b.datperiod) = date_part('year',x1.datvidano) and
                              x1.sot_cod = a.cod and
                              x1.un_tip = 1 and
                              x1.un_cod != $kmd_cod) as sumnach,
                    sum(x2.summa) as sumpodnal,
                    x2.un_kod as ukod,
                    (select sum(x3.summa) from oper x3
                        where date_part('month',b.datperiod) = date_part('month',x3.datvidano) and
                              date_part('year',b.datperiod)  = date_part('year',x3.datvidano) and
                              x3.sot_cod = a.cod and
                              x3.un_tip = -1 and
                              x3.un_vid not in ('v','b')) as sumallud,
                    a.dt, a.du,
                    sum(x4.summa) as sumolu,
                    x4.un_kod as otherlukod
                from sotdoldtdukd a
                     left outer join vidano as b on
                        a.cod = b.sot_cod and
                        date_part('month',b.datvidano) between $m1 and $m2 and
                        date_part('year',b.datvidano) = $y
                     left outer join un as c on
                        b.un_cod = c.cod   
                     left outer join oper as x2 on
                        a.cod = x2.sot_cod and
                        date_part('month',b.datperiod) = date_part('month',x2.datvidano) and
                        date_part('year',b.datperiod)  = date_part('year',x2.datvidano) and
                        x2.un_tip = -1 and
                        x2.un_vid = 'n'
                     left outer join oper as x4 on
                        a.cod = x4.sot_cod and
                        date_part('month',b.datperiod) = date_part('month',x4.datvidano) and
                        date_part('year',b.datperiod)  = date_part('year',x4.datvidano) and
                        x4.un_tip = -1 and
                        x4.un_vid = 'k' and
                        x4.un_kod is not null
                group by a.cod, a.inn, b.datvidano, b.datperiod, a.kd, c.kod, 
                         x2.un_kod, a.dt, a.du, x4.un_kod
                order by inn, nkod, ukod"

        set i 0
        set oldinn -1
        set oldnkod -1
        set oldukod -1
        set sgraf3 0
        set sgraf4 0
        set cntline 0
        set oldflglud -1
        pg_select $MAIN(iddbs) $query A {
            
            set A(sumnach)   [NullZero $A(sumnach)]
            set A(sumvidano) [NullZero $A(sumvidano)]
            set A(sumpodnal) [NullZero $A(sumpodnal)]
            set A(sumallud)  [NullZero $A(sumallud)]
            
            set flglud "$A(inn):$A(sumvidano):$A(nkod):$A(sumnach):$A(sumpodnal):$A(ukod):$A(sumallud)"
            
            if { $flglud != $oldflglud } {
                set sumkvidache [expr $A(sumnach) - $A(sumallud)]
                if { $A(sumnach) > 0 && $sumkvidache > 0 } {
                    set graf3 [format %8.2f [expr $A(sumnach) * $A(sumvidano) / $sumkvidache]]
                    set graf4 [format %8.2f [expr $A(sumvidano) * $A(sumpodnal) / $sumkvidache]]
                } else {
                    set graf3 $A(sumvidano)
                    set graf4 0
                }
                if { ($oldinn != $A(inn) || $oldnkod != $A(nkod) || 
                      $oldukod != $A(ukod) ) &&
                     $oldinn != -1 && $oldnkod != -1 && $oldukod != -1 } {
                    
                    if [IsBe oldukod] {
                        report output $kv $y $kolsotp $kolsots \
                            [incr cntline] $oldinn $sgraf3 $sgraf4 $oldnkod $dt $du \
                            $oldukod 0 0
                        if [IsBe A(otherlukod)] {
                            report output $kv $y $kolsotp $kolsots \
                                [incr cntline] $oldinn "" "" $oldnkod "" "" \
                                $A(otherlukod) 0 0
                        }
                    } else {
                        report output $kv $y $kolsotp $kolsots \
                            [incr cntline] $oldinn $sgraf3 $sgraf4 $oldnkod $dt $du \
                            $A(otherlukod) 0 0
                    }
                    set sgraf3 0
                    set sgraf4 0
                }
                set sgraf3 [expr $sgraf3 + $graf3]
                set sgraf4 [expr $sgraf4 + $graf4]
            } else {
                lappend lshortline "$kv $y $kolsotp $kolsots \
                    \[incr cntline] $oldinn {} {} $oldnkod {} {} $A(otherlukod) \
                    \$cntline \[expr $kolsotp + $kolsots]"
            }
            
            if { $oldinn != $A(inn) && [IsBe lshortline] } {
                for { set lii 0 } { $lii < [llength $lshortline] } { incr lii } {
                    #puts "[subst \t[lindex $lshortline $lii]]"
                    eval report output [lindex $lshortline $lii]
                }
                set lshortline {}
            }
            
            set oldinn     $A(inn)
            set oldnkod    $A(nkod)
            set oldukod    $A(ukod)
            set otherlukod $A(otherlukod)

            if { [Date $A(du)] >= [Date 01.$m1.$y] && [Date $A(du)] < [Date [GetFirstDayNextMonth $m2 $y]] } {
                set du $A(du)
            } else { set du "" }
            if { [Date $A(dt)] >= [Date 01.$m1.$y] && [Date $A(dt)] < [Date [GetFirstDayNextMonth $m2 $y]] } {
                set dt $A(dt)
            } else { set dt "" }
            
            #puts [list $oldinn $A(sumvidano) $A(sumnach) $A(sumpodnal) $oldnkod $dt $du $A(ukod) $A(otherlukod)]
            
            ProgressIncr F8DR(progress) [incr i] 5
            set oldflglud    $flglud
        }
        
        report output $kv $y $kolsotp $kolsots \
            [incr cntline] $oldinn $sgraf3 $sgraf4 $oldnkod $dt $du $otherlukod \
            $cntline [expr $kolsotp + $kolsots]
        
        if [IsBe lshortline] {
            for { set lii 0 } { $lii < [llength $lshortline] } { incr lii } {
                #puts "\t[subst [lindex $lshortline $lii]]"
                eval report output [subst [lindex $lshortline $lii]]
            }
        }
        
        PrintDoc $tpl " 8" [report stop]
        AfterQuery F8DR
    }
}
