proc Face {} {
    global FACE MAIN
    if [winfo exists .face] { destroy .face }
    Unset FACE
    set FACE(gowork) Ins
    toplevel .face
    wm withdraw .face
    wm title .face ""
    
    LoadWhileCreateWindow .face
    
    menu .face.menu
    .face.menu add command -label "  " -command "Face:Print 1"
    .face.menu add command -label " "        -command "Face:Print 0"
    .face.menu add separator
    .face.menu add command -label ""
    bind .face.menu <Unmap> { focus [focus -lastfor .face] }
    
    # MainFrame ####################################################################
    set mf [MainFrame .face.mf -textvariable FACE(status) -progressvar FACE(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "Face:WPrint" } {
        set FACE(button,$i) [$tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k]
    }
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .face FACE" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    packef [set top [frame $mff.top]]
    pack   [set bot [frame $mff.bot]]
    
    # PanedWindow ##################################################################
    packef [PanedWindow $top.pw]
    set pw1 [$top.pw add -minsize 100]
    set pw2 [$top.pw add -minsize 100 -weight 0]

    # Head #########################################################################
    
    Pdr:Sel FACE
    set FACE(head_tmonth_year) $MAIN(tmonthyear)

    pack [set hf1 [frame $pw1.f1]]
    pack [label $hf1.l1 -text  -font [option get $hf1 bigFont Frame] \
        -fg black] -side left
    pack [ComboBox $hf1.monthyear -editable 0 -label "  " -width 13 -height 13 \
        -values [YearAmongMonth $FACE(head_tmonth_year)] -modifycmd Face:Sel \
        -textvariable FACE(head_tmonth_year) \
        -helptext "   "] -side left
    pack [ComboBox $pw1.pdr -editable 0 -label "  " -width 30 \
        -values $FACE(lpdr_nam) -modifycmd Face:Sel \
        -textvariable FACE(head_pdr_nam) \
        -helptext "   "]

    set FACE(monthyearwindow) $hf1.monthyear
    set FACE(pdrwindow)       $pw1.pdr

    pack [Separator $pw1.sep -orient horizontal] -fill x -pady 4

    # MAIN #########################################################################
    packef [TitleFrame $pw1.main -text " "]
    set main [$pw1.main getframe]
    pack [scrollbar $main.sby -command "$main.mcl yview"] -side right -fill y
    pack [scrollbar $main.sbx -command "$main.mcl xview" -orient hor] \
        -side bottom -fill x
    packef [mclistbox $main.mcl -width 50 -height 20 \
                -xscrollcommand "$main.sbx set" \
                -yscrollcommand "$main.sby set"]

    set FACE(mclwindow) $main.mcl
    
    $main.mcl column add tn         -label ".N" -width 5 -foreground magenta4
    $main.mcl column add fio        -label "" -width 50
    $main.mcl column add cod        -visible no
    $main.mcl column add saldo      -visible no
    
    $main.mcl label bind tn  <ButtonPress-1> "Face:Sort %W tn"
    $main.mcl label bind fio <ButtonPress-1> "Face:Sort %W fio"
    
    bind $main.mcl  <ButtonRelease-1> "focus $main.mcl; Face:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Up>   "Face:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Down> "Face:Import:Attr $main.mcl"
    bind $main      <FocusIn>         "Face:Activate:TF $pw1.main"
    bind $main      <FocusOut>        "Face:DeActivate:TF $pw1.main"


    # Attr ########################################################################
    
    set FACE(saldob) [format %8.2f 0]
    pack [LabelEntry $pw2.saldob -textvariable FACE(saldob) -editable 0 \
        -label "    " -width 8 -highlightthickness 0\
        -entrybg lavenderblush1 ] \
        -padx 19 -pady 0 -anchor e
    
    pack [Separator $pw2.sep3 -orient horizontal] -fill x -pady 4
    
    packef [TitleFrame $pw2.tf -text ", , "]
    set tf [$pw2.tf getframe]
    bind $tf <FocusIn>  "Face:Activate:TF   $pw2.tf"
    bind $tf <FocusOut> "Face:DeActivate:TF $pw2.tf"
    
    packef [frame $tf.nach]
    set FACE(tbl,nach,height) 5
    set FACE(tbl,nach,l1)     ""
    Face:Tbl $tf.nach nach
    
    packef [frame $tf.ud]
    set FACE(tbl,ud,height) 8
    set FACE(tbl,ud,l1)     ""
    Face:Tbl $tf.ud ud
    
    packef [frame $tf.vidano]
    set FACE(tbl,vidano,height) 4
    set FACE(tbl,vidano,l1)     ""
    Face:Tbl $tf.vidano vidano

    pack [Separator $pw2.sep4 -orient horizontal] -fill x -pady 4

    pack [LabelEntry $pw2.saldoe -textvariable FACE(saldoe) -editable 0 \
        -label "    " -width 8 -highlightthickness 0 \
        -entrybg lightyellow1 ] \
        -padx 19 -pady 0 -anchor e



    ###############################################################################
    
    bind .face <Escape> "$tb.bb2 invoke 0"
    bind .face <F4>     "$tb.bb1 invoke 0"

    BWidget::place .face 0 0 center
    wm deiconify .face
    
    Face:Sel
}

proc Face:Import:Attr { w } {
    global FACE nachFACE udFACE vidanoFACE
    if { [set idx [$FACE(mclwindow) curselection]] >= 0 } { 
        set FACE(saldob) [format %8.2f [lindex [$FACE(mclwindow) get $idx] 3]]
    }
    Faceunv:Sel
    set FACE(saldoe) [format %8.2f [expr $FACE(saldob) + $nachFACE(itog) - \
                                         $udFACE(itog) - $vidanoFACE(itog)]]
}

proc Face:Sort { w fld } {
    Mclistbox:Sort $w $fld
    Face:Import:Attr $w
}

proc Face:Activate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state normal
            }
        }
    }
}

proc Face:DeActivate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}

proc Face:WPrint {} {
    global FACE
    set w $FACE(button,printer)
    .face.menu post [expr [winfo rootx $w] + 3] \
                    [expr [winfo rooty $w] + [winfo height $w]]
    focus .face.menu
    .face.menu activate 0
}
