proc He { gv win args } {
    set lastfocus [focus]
    set tpl [winfo toplevel $win]
    set w $tpl.hewindowhe
    set wdd [DelDot $w]
    global ${wdd}HE $gv
    Unset ${wdd}HE
    set ${gv}(status) "   ..."
    update
    
    #   
    foreach { i j } { Opt(side) bottom  Opt(anchor) w  Opt(title) " "
                      Opt(width) 30  Opt(height) 10  Opt(labels) {"" 30} 
                      Opt(deltax) 0  Opt(deltay) 0 } {
        set $i $j
    }
    
    #  
    foreach { i j } $args {
        regsub -all -- "-" $i "" i
        set Opt($i) $j
    }
    set cols [expr [llength $Opt(labels)] / 2]

    #  
    if ![VarIn Opt(side) bottom left right top] {
        return -code error "invalid option \"$Opt(side)\" for -side, must be bottom, left, right, top"
    }
    if ![VarIn Opt(anchor) n s e w center] {
        return -code error "invalid option \"$Opt(side)\" for -side, must be n, s, e, w, center"
    }
    
    if [winfo exists $w] { destroy $w }
    toplevel $w
    #wm transient $w $tpl
    wm withdraw $w
    wm overrideredirect $w 1
    set winx [winfo rootx $win]
    set winy [winfo rooty $win]
    set winh [winfo height $win]
    set winw [winfo width $win]
    
    #  
    pack [frame $w.f -bg green4]
    pack [TitleFrame $w.f.tf -text $Opt(title) -fg green4 -relief ridge]
    set tf [$w.f.tf getframe]
    pack [frame $tf.f]
    set ${wdd}HE(find) {}
    set ${wdd}HE(nam) $Opt(find)
    if [IsBe Opt(find)] {
        set ${wdd}HE(find) %$Opt(find)%
    }
    pack [LabelEntry $tf.f.nam -helptext "    " -side top \
            -label "  " -textvariable ${wdd}HE(nam) -width $Opt(width)]
    pack [scrollbar $tf.sby -command "$tf.mcl yview"] -side right -fill y
    pack [scrollbar $tf.sbx -command "$tf.mcl xview" -orient hor] -side bottom -fill x
    pack [mclistbox $tf.mcl -width $Opt(width) -height $Opt(height) \
                    -yscrollcommand "$tf.sby set" \
                    -xscrollcommand "$tf.sbx set"] -side left
    set k 0
    foreach { i j } $Opt(labels) {
        $tf.mcl column add lbl$k -label $i -width $j
        incr k
    }
    
    update
    
    set wh [winfo reqheight $w]
    set ww [winfo reqwidth $w]
    
    #    
    switch $Opt(side) {
        bottom { set wy [expr $winy + $winh] }
        top    { set wy [expr $winy - $wh] }
        right  { set wx [expr $winx + $winw] }
        left   { set wx [expr $winx - $ww] }
        
    }
    if [VarIn Opt(side) bottom top] {
        switch $Opt(anchor) {
            w      { set wx $winx }
            center { set wx [expr $winx + $winw/2 -$ww/2] }
            e      { set wx [expr $winx + $winw - $ww] }
        }
    } else {
        switch $Opt(anchor) {
            n      { set wy $winy }
            center { set wy [expr $winy + $winh/2 -$wh/2] }
            s      { set wy [expr $winy + $winh - $wh] }
        }
    }
    
    bind $win       <Destroy>     +[list destroy $w]
    bind $w         <Escape>      "Escape $w $gv"
    bind $tf.mcl    <F5>          "focus $tf.f.nam"
    bind $tf.mcl    <KeyRelease-Return>      "He:Bind:Mcl $w $wdd $tf.mcl"
    bind $tf.mcl    <KeyRelease-KP_Enter>    "He:Bind:Mcl $w $wdd $tf.mcl"
    bind $tf.mcl    <Double-Button-1>        "He:Bind:Mcl $w $wdd $tf.mcl"
    bind $tf.mcl    <Button-3>               "destroy $w"
    set ${wdd}HE(query) $Opt(query)
    $tf.f.nam bind  <KeyRelease-Return>      "He:Bind:Find $gv $wdd $tf.mcl $cols"
    $tf.f.nam bind  <KeyRelease-KP_Enter>    "He:Bind:Find $gv $wdd $tf.mcl $cols"
    
    
    incr ${gv}(progress)
    set selret [He:Sel $gv $wdd $tf.mcl $cols]
    if { $selret == 1 } {
        He:Bind:Mcl $w $wdd $tf.mcl
    } else {
        wm geometry $w +[expr $wx + $Opt(deltax)]+[expr $wy + $Opt(deltay)]
        wm deiconify $w
        grab -global $w
        tkwait window $w
    }
    focus -force $lastfocus
    if [IsBe ${wdd}HE(return)] { return [subst $${wdd}HE(return)] }
}

proc He:Bind:Mcl { w wdd mcl } {
    global ${wdd}HE ${wdd}HE_DATA
    if { [set idx [$mcl curselection]] >= 0 } { 
        set ${wdd}HE(return) [$mcl get $idx]
        if [IsBe ${wdd}HE_DATA($idx,return)] {
            lappend ${wdd}HE(return) [subst $${wdd}HE_DATA($idx,return)]
        }
        destroy $w
    }
}

proc He:Bind:Find { gv wdd w cols } {
    global ${wdd}HE
    if [IsBe ${wdd}HE(nam)] {
        set ${wdd}HE(find) %[subst $${wdd}HE(nam)]%
    } else {
        set ${wdd}HE(find) {}
    }
    He:Sel $gv $wdd $w $cols
}

proc He:Sel { gv wdd w cols } {
    global MAIN ${wdd}HE_DATA ${wdd}HE $gv
    BeforeQuery $gv "   ..."
    Unset ${wdd}HE_DATA
    $w delete 0 end
    set query [subst $${wdd}HE(query)]
    regsub -all "(^select)|(from.*$)" $query "" fld
    regsub -all "(\[^\\.,]*\\.)|(\[^\\.,]*as)" $fld "" fld
    regsub -all "," $fld " " fld
    set query [cnvi [subst $query]]
    
    set idx 0
    dpg_select . $MAIN(iddbs) $query A {
        set lst {}
        for { set i 0 } { $i < $cols } { incr i } {
            lappend lst $A([lindex $fld $i])
        }
        for { set i $i } { $i < [llength $fld] } { incr i } {
            set fldname [lindex $fld $i]
            lappend ${wdd}HE_DATA($idx,return) $A($fldname)
        }
        $w insert end [cnvs $lst]
        ProgressIncr ${gv}(progress) [incr idx] 2
    } 

    SelectionActivateSee $w 0
    focus $w
    AfterQuery $gv
    return $idx
}
