#   #######################################################

#  
proc InitWidgets {} {
    global MAIN
    set MAIN(alltmonth)         {             }
    set MAIN(today)             [clock format [clock seconds] -format %d.%m.%Y]
    regsub -all -- "\\..*" $MAIN(today) "" MAIN(day)
    regsub -all -- "^0" $MAIN(day) "" MAIN(day)
    set MAIN(month)             [clock format [clock seconds] -format %m]
    set MAIN(pmonth)            [clock format [clock scan "-1 month" -base [clock seconds]] -format %m]
    set MAIN(year)              [clock format [clock seconds] -format %Y]
    set MAIN(pyear)             [clock format [clock scan "-1 month" -base [clock seconds]] -format %Y]
    set MAIN(tmonth)            [GetMonthText $MAIN(month)]
    set MAIN(ptmonth)           [GetMonthText $MAIN(pmonth)]
    set MAIN(tmonthyear)        [format "%-8.8s %-4.4s" $MAIN(tmonth) $MAIN(year)]
    set MAIN(ptmonthyear)       [format "%-8.8s %-4.4s" $MAIN(ptmonth) $MAIN(pyear)]
    set MAIN(firstdaynextmonth) [GetFirstDayNextMonth $MAIN(month) $MAIN(year)]
    
    bind Entry <FocusIn> {
        %W configure -background [option get %W activeBackground Entry]
    }
    bind Entry <FocusOut> {
        %W configure -background [option get %W background Entry]
    }
    
    bind TableInit <KeyRelease-comma> {
        regsub -all "\\," [%W curvalue] "." str
        catch [%W set active $str]
    }
    bind TableInit <FocusIn> {
        if { [%W curselection] == "" } { TkTableNotActiveDisabled %W beg beg }
    }
}

#   table 
proc TkTableInitTag { w } {
    $w tag config Error  -bg red3 -fg white
    $w tag config BG     -bg [option get $w Background Table]
    $w tag config AnchorE -anchor e
    $w tag config AnchorW -anchor w
    $w tag config Disabled -state disabled
    $w tag config CurrentCells -bg [option get $w currentBackground2 Table] \
                        -fg [option get $w currentForeground2 Table]
    $w tag config CurrentRow -bg [option get $w currentBackground Table] \
                        -fg [option get $w currentForeground Table]
    $w tag config TitleCol -fg [option get $w titleForeground Table] \
                        -bg [$w tag cget title -bg] \
                        -anchor [option get $w titlecolAnchor Table] \
                        -wrap [option get $w titleWrap Table] \
                        -bd 0 -state disabled
    $w tag config TitleCol2 -fg [option get $w titleForeground Table] \
                        -bg [$w tag cget title -bg] \
                        -anchor w -wrap 0 -bd 0 -state disabled
    $w tag config sel -bg [option get $w Background Table] -relief flat \
                        -fg [option get $w currentForeground Table]
    $w tag config title -fg [option get $w titleForeground Table] \
                        -anchor [option get $w titleAnchor Table] \
                        -wrap [option get $w titleWrap Table] \
                        -bd [option get $w titleBorder Table] \
                        -relief [option get $w titleRelief Table]
    $w tag config active -bg [option get $w activeBackground Table] \
                         -fg [option get $w activeForeground Table]
    $w tag config rowOne -bg [option get $w rowOne Table]
    $w tag config rowTwo -bg [option get $w rowTwo Table]
}

proc TkTableInitBind { w } {
    bind $w <KeyRelease-Return> {
        TkTable:Bind:EnterKpEnter %W
    }
    bind $w <KeyRelease-KP_Enter> {
        TkTable:Bind:EnterKpEnter %W
    }
    bind $w <KeyPress-Down> {
        set rows [%W cget -rows]
        if { [%W index active row] == [expr $rows - 1 + [%W cget -roworigin]] } {
            %W configure -rows [incr rows]
        }
    }
    bindtags $w "[bindtags $w] TableInit"
}

proc TkTable:Bind:EnterKpEnter { w } {
    regsub -all "\n|\r" [$w curvalue] "" str
    catch [$w set active $str]
    set endcol [$w index end col]
    set endrow [$w index end row]
    set acol   [$w index active col]
    set arow   [$w index active row]
    if { $acol == $endcol } {
        if { $arow == $endrow } {
            event generate $w <KeyPress-Up>
        } else {
            event generate $w <KeyPress-Down>
        }
        for { set i 0 } { $i < $endcol } { incr i } {
            event generate $w <KeyPress-Left>
        }
    } else {
        event generate $w <KeyPress-Right>
    }
}

proc TkTableNotActiveDisabled { w oldactive active } {
    for { set i [set colorigin [$w cget -colorigin]] } \
        { $i <= [expr [$w cget -cols] - 1 + $colorigin] } { incr i } { 
            lappend lall $i 
    }
    set len [list_eor [$w tag col Disabled] $lall]
    set len [list_eor [$w tag col TitleCol2] $len]
    set len [lsort -integer [list_eor [$w tag col TitleCol] $len]]

    if { $oldactive == "beg" && $active == "beg" } {
        set row 0              
        set oldrow 0
        set col [lindex $len 0]
        set oldcol $col
        set active $row,$col
        set oldactive $active
        $w activate $row,$col
    } else {    
        scan $oldactive "%\[^,]%*c%s" oldrow oldcol
        scan $active    "%\[^,]%*c%s" row col
        if { $row < 0 || $col < 0 } {
            #    title   
            set active $oldactive
            set row $oldrow
            set col $oldcol
        } else {
            if { $oldcol < $col } {
                #   disabled    
                set col [lindex $len [expr [lsearch $len $oldcol] + 1]]
                if { $col == "" } { set col $oldcol }
                set active $row,$col
            }
            if { $oldcol > $col } {
                #   disabled    
                set col [lindex $len [expr [lsearch $len $oldcol] - 1]]
                if { $col == "" } { set col $oldcol }
                set active $row,$col
            }
        }
    }
    $w activate $row,$col
    $w see $row,$col
    return [list $oldactive $active $oldrow $row $oldcol $col]
}
#   n    row,col   0-n  row
#  0 2 4  0,0 0,1 0,2 0,3
#  0 7 4  0,4 0,5 0,6 0,7
proc TkTableAmongCellsRow { row col n } {
    set celij [expr $col / $n]
    for { set i [expr $celij * $n] } { $i < [expr $celij * $n + $n] } { incr i } {
        lappend ret $row,$i
    }
    return $ret
}
proc TkTableRowTagCmd { row } {
    if { [expr $row % 2] == 0 } {
        return rowOne
    }
    return rowTwo
}
proc TkTableRowTagErrorNull { w } {
    if { [set rows [$w tag row Error]] != "" } {
        foreach row $rows {
            $w tag row null $row
            $w tag row [TkTableRowTagCmd $row] $row
        }
    }
}
proc TkTableCellTagErrorNull { w } {
    if { [set cells [$w tag cell Error]] != "" } {
        foreach cell $cells {
            $w tag cell null $cell
            scan $cell "%\[^,]%*c%s" row col
            $w tag row [TkTableRowTagCmd $row] $row
        }
    }
}

#     return 1
proc IsBe { var } {
    upvar $var vr
    if { [info exists vr] && [string trim $vr] != "" } {
        return 1
    }
    return 0
}

#   progressbar Mainframe
#  incr var  n   i
proc ProgressIncr { var i n } {
    upvar $var vr
    if { [expr $i % $n] == 0 } { uplevel 1 incr $var }
}

#
proc packef { w args } {
    eval pack $w -expand yes -fill both $args
}

#     w
proc ChildrenWindow { w } {
    set lw ""
    foreach i [winfo children $w] {
        append lw " $i"
        set lw2 [ChildrenWindow $i]
        if { $lw2 != "" } { append lw " $lw2" }
    }
    return $lw
}

#     w
proc ParentWindow { w } {
    set lw ""
    foreach i [winfo parent $w] {
        append lw " $i"
        set lw2 [ParentWindow $i]
        if { $lw2 != "" } { append lw " $lw2" }
    }
    return $lw
}

#     
proc cnvs { str } {
    return [string trimright [encoding convertfrom $str]]
}

#     
proc cnvi { str } {
    set str [string trimright [encoding convertfrom identity [encoding convertto $str]]]
    return $str
}

proc BeforeQuery { glvar msg } {
    upvar $glvar gl
    set gl(status) $msg
    set gl(progress) 1
}

proc AfterQuery { glvar } {
    upvar $glvar gl
    set gl(progress) -1
    set gl(status) ""
}

proc SelectionActivateSee { w idx } {
    $w selection clear 0 end
    $w selection set $idx
    $w activate $idx
    $w see $idx
}

proc dpg_select { w args } {
    if [catch { uplevel pg_select $args } err] {
        MessageDlg .dlg -parent $w -icon error -type ok -message $err
        return -1
    }
    return 0
}

proc dopen { w args } {
    if [catch { set fd [uplevel open $args] } err] {
        MessageDlg .dlg -parent $w -icon error -type ok -message $err
        return -1
    }
    return $fd
}

proc dpg_exec { w args } {
    set hdl [eval pg_exec $args]
    if { [set err [pg_result $hdl -error]] != "" } {
        MessageDlg .dlg -parent $w -icon error -type ok -message $err
        return -1
    }
    return 0
}

proc dpg_connect { w args } {
    if [catch { set iddbs [uplevel pg_connect $args] } err] {
        MessageDlg .dlg -parent $w -icon error -type ok -message $err
        return -1
    }
    return $iddbs
}

proc tonull { args } {
    foreach i $args {
        uplevel [list set $i ""]
    }
}

#     where select'a
proc Construct { args } {
    set tw [expr [llength $args] / 2]
    for { set i 0 } { $i < $tw } { incr i } {
        set field [lindex $args $i]
        set var   [lindex $args [expr $i + $tw]]
        upvar $var c_vr
        if { $c_vr != "" } {
            append ret " and $field [ConstructElm $c_vr]"
        }
    }
    if ![info exists ret] {
        set ret 1=1
    } else {
        regsub " and " $ret "" ret
    }
    return $ret
}
proc ConstructElm { str } {
    set str [string trim $str]
    if { [regexp \[\%\?\] $str] == 1} {
        set str "ilike '$str'"
        return $str
    }
    if { [string first ":" $str] != -1 } {
        scan $str "%\[^:]%*c%\[^:]" s1 s2
        set str "between '$s1' and '$s2'"
        return $str
    }
    if { [string first "|" $str] != -1 } {
        set sn "${str}"
        set str "in ("
        set ln [string length $sn]
        set i 1
        while { $ln > 0 } {
            scan $sn "%\[^|]%*c%s" s1 s2
            if { $i > 1 } {
                set str "$str,"
            }
            set str "$str'$s1'"
            set sn $s2
            set ln [expr $ln - [string length $s1] - 1]
            set i [incr i]
        }
        set str "${str})"
        return $str
    }
    if { [regexp \[><=\] $str] == 1 } {
        regsub ">=|<=|>|<|=" $str "&'" str2
        return ${str2}'
    }
    if { $str == "null" || $str == "NULL" } {
        return "is null"
    }
    if { $str == "not null" || $str == "NOT NULL" } {
        return "is not null"
    }
    return "='$str'"
}

proc Case { var args } {
    upvar $var vr
    set tw [expr [llength $args] / 2]
    for { set i 0 } { $i < $tw } { incr i } {
        set el [lindex $args $i]
        set zn [lindex $args [expr $i + $tw]]
        if { $vr == $el } { return $zn }
    }
}

proc Unset { args } {
    foreach i $args {
        upvar $i vr
        catch [unset vr]
    }
}

proc DelDot { str } {
    regsub -all "\\." $str "" str
    return $str
}

#  sql in ( 1, 2, 3 )
proc VarIn { var args } {
    foreach i $args {
        upvar $var vr
        if { $vr == $i } { return 1 }
    }
    return 0
}

#    node   Tree
proc Tree:AllNodes { w node } {
    set lw ""
    foreach i [$w nodes $node] {
        append lw " $i"
        set lw2 [Tree:AllNodes $w $i]
        if { $lw2 != "" } { append lw " $lw2" }
    }
    return $lw
}

#  (    w)
proc LoadWhileCreateWindow { w } {
    global LWCR
    set clr lightcyan4
    toplevel $w.prgdlg -bd 4 -relief groove -cursor watch -bg $clr
    wm withdraw $w.prgdlg
    wm title $w.prgdlg ""
    wm overrideredirect $w.prgdlg 1

    set LWCR 1
    pack [label $w.prgdlg.l1 -image [Bitmap::get hourglass] \
            -cursor watch -bg $clr ] -fill y -side left
    pack [label $w.prgdlg.l2 -text "" -bg $clr -fg white \
            -cursor watch] -fill x
    pack [ProgressBar $w.prgdlg.p -variable LWCR -maximum 5000 -width 150 \
            -bg $clr -fg green2 -type infinite -height 6] -padx 10 -pady 5
    BWidget::place $w.prgdlg 0 0 center
    wm deiconify $w.prgdlg
    
    bind $w <Map> "LoadWhileCreateWindow:Bind1 $w $w.prgdlg"
    grab $w.prgdlg
}

proc LoadWhileCreateWindow:Bind1 { win w  } {
    global LWCR
    bind $win <Map> {}
    catch [destroy $w]
}

#    " "   (+ - 6 ) 
#  " "

proc YearAmongMonth { str } {
    set month [GetMonthInt [lindex $str 0]]
    set year  [lindex $str 1]
    for { set i -6 } { $i <= 6 } { incr i } {
        set my [clock format [clock scan "$i month" -base [clock scan "$year-$month-01"]] -format "%m %Y"]
        set tm [GetMonthText [lindex $my 0]]
        set y  [lindex $my 1]
        lappend lmy [format "%-8.8s %-4.4s" $tm $y]
    }
    return $lmy
}
proc GetMonthText { m } {
    global MAIN
    regsub "^0" $m "" m
    return [lindex $MAIN(alltmonth) [incr m -1]]
}
proc GetMonthInt { m } {
    global MAIN
    return [expr [lsearch -exact $MAIN(alltmonth) $m] + 1]
}
proc GetFirstDayNextMonth { m y } {
    return [clock format [clock scan "+1 month" -base [clock scan "$y-$m-01"]] -format %d.%m.%Y]
}

proc Mclistbox:Sort { w id } {
    foreach i [$w column names] {
        $w column configure $i -foreground black
    }
    $w column configure $id -foreground magenta4
    set data [$w get 0 end]
    set index [lsearch -exact [$w column names] $id]
    set result [lsort -dictionary -index $index $data]
    $w delete 0 end
    eval $w insert end $result
    SelectionActivateSee $w 0
}

#       
# Lindexes 1 2 3 a s d
# a=1 s=2 d=3
proc Lindexes { args } {
    foreach i $args {
        append la " $i"
    }
    set tw [expr [llength $la] / 2]
    for { set i 0 } { $i < $tw } { incr i } {
        set idx [lindex $la $i]
        set var [lindex $la [expr $i + $tw]]
        upvar $var vr
        set vr $idx
    }
}

#  
proc Escape { w var } {
    upvar $var vr
    if ![IsBe vr(status)] { destroy $w }
}

proc Waiting { win str } {
    set w $win.waiting
    if { $str != "close" } {
        if [winfo exists $w] { destroy $w }
        toplevel $w
        wm transient $w $win
        wm withdraw $w
        
        pack [frame $w.f -bd 2 -relief groove -cursor watch] -padx 3 -pady 3
        pack [label $w.f.l -image waiting -cursor watch] -side left -padx 5 -pady 5
        pack [message $w.f.msg -text $str -fg red3 -width 200 -justify center \
            -cursor watch] -side right
        
        BWidget::place $w 0 0 center
        wm deiconify $w
        update
        grab $w
    } else {
        catch [destroy $w]
    }
}

proc NullZero { v } {
    if ![IsBe v] { return 0 }
    return $v
}

#  dd.mm.yyyy  yyyy.mm.dd (    )
proc Date { dat } {
    if [IsBe dat] {
        scan $dat "%\[^\\.]%*c%\[^\\.]%*c%s" d m y
        if { [string length $d] == 1 } { set d "0$d" }
        if { [string length $m] == 1 } { set m "0$m" }
        return "$y.$m.$d"
    } else {
        return ""
    }
}
