proc Naznach:Word { Word1 Word2 } {
    set word1 [string tolower $Word1]
    set word2 [string tolower $Word2]
    set WORD1 [string toupper $Word1]
    set WORD2 [string toupper $Word2]
    return "$word1 $word2 $WORD1 $WORD2"
}

proc Naznach { Word1 Word2 } {
    Lindexes [Naznach:Word $Word1 $Word2] word1 word2 WORD1 WORD2
    global $WORD1${WORD2}ZK
    set tpl .$word1${word2}zk
    if [winfo exists $tpl] { destroy $tpl }
    Unset $WORD1${WORD2}ZK
    set $WORD1${WORD2}ZK(tpl) $tpl
    
    toplevel $tpl
    wm withdraw $tpl
    wm title $tpl ""

    LoadWhileCreateWindow $tpl
    
    # MainFrame ####################################################################
    set mf [MainFrame $tpl.mf -textvariable $WORD1${WORD2}ZK(status) \
        -progressvar $WORD1${WORD2}ZK(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "" } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } [list  quit "  <Esc> " "Escape $tpl $WORD1${WORD2}ZK"] {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # NoteBook #####################################################################
    pack [NoteBook $mff.nb] -expand yes -fill both
    foreach { i j } {  konkr  zavis  } {
        $mff.nb insert end $j -text $i
        Naznach:Naznach $Word1 $Word2 [$mff.nb getframe $j] \
            [Case i   z k]
    }
    $mff.nb compute_size
    $mff.nb raise konkr
    $tb.bb1 itemconfigure 0 -command "Naznach:Print $Word1 $Word2 $mff.nb"
    bind $tpl <Escape>   "$tb.bb2 invoke 0"
    bind $tpl <F4>       "$tb.bb1 invoke 0"
    
    BWidget::place $tpl 0 0 center
    wm deiconify $tpl
}

proc Naznach:Naznach { Word1 Word2 w vid } {
    Lindexes [Naznach:Word $Word1 $Word2] word1 word2 WORD1 WORD2
    set wdd [DelDot $w]
    global ${wdd}${WORD1}${WORD2}ZK MAIN $WORD1${WORD2}ZK
    Unset ${wdd}${WORD1}${WORD2}ZK
    
    set $WORD1${WORD2}ZK(wdd$vid) $wdd

    Pdr:Sel ${wdd}${WORD1}${WORD2}ZK
    set ${wdd}${WORD1}${WORD2}ZK(head_tmonth_year) $MAIN(tmonthyear)
    pack [frame $w.f1]
    pack [label $w.f1.l1 -text "" \
        -font [option get $w.f1 bigFont Frame] -fg black] -side left
    pack [ComboBox $w.f1.monthyear -editable 0 -label "  " -width 13 -height 13 \
        -values [YearAmongMonth [subst $${wdd}${WORD1}${WORD2}ZK(head_tmonth_year)]] \
        -modifycmd "Naznach:Sel $Word1 $Word2 $wdd $vid" \
        -textvariable ${wdd}${WORD1}${WORD2}ZK(head_tmonth_year) \
        -helptext "   "] -side left
    set ${wdd}$WORD1${WORD2}ZK(monthyearwindow) $w.f1.monthyear

    pack [ComboBox $w.f1.pdr -editable 0 -label "   " -width 30 \
        -values [subst $${wdd}${WORD1}${WORD2}ZK(lpdr_nam)] -modifycmd "Naznach:Sel $Word1 $Word2 $wdd $vid" \
        -textvariable ${wdd}${WORD1}${WORD2}ZK(head_pdr_nam) \
        -helptext "   "] -side left

    set ${wdd}${WORD1}${WORD2}ZK(pdrwindow) $w.f1.pdr

    ${Word1}${Word2}zk $w $wdd $vid
}

proc Naznach:Activate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state normal
            }
        }
    }
}

proc Naznach:DeActivate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}

proc Naznach:Sel { Word1 Word2 wdd vid } {
    ${Word1}${Word2}zk:${Word1}Sel $wdd $vid
    ${Word1}${Word2}${vid}:${Word2}Sel $wdd
}

proc Naznach:Print { Word1 Word2 nb } {
    switch -exact [$nb raise] {
        konkr ${Word1}${Word2}k:Print
        zavis ${Word1}${Word2}z:Print
    }
}
