proc PrintDoc { tpl msg lst } {
    global PRINTDOC
    set w $tpl.printdoc
    if [winfo exists $w] { destroy $w }
    Unset PRINTDOC
    toplevel $w
    wm transient $w $tpl
    wm withdraw $w
    wm title $w $msg
    
    # MainFrame ####################################################################
    set mf [MainFrame $w.mf -textvariable PRINTDOC(status) -progressvar PRINTDOC(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    $tb.bb1 add -image printer -helptext "  <F4> " -relief link -takefocus 0 \
        -highlightthickness 0 -command [list PrintDoc:Print $w $lst]
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    $tb.bb2 add -image quit -helptext "  <Esc> " -relief link -takefocus 0 \
        -highlightthickness 0 -command "Escape $w PRINTDOC"

    # text #########################################################################
    pack [label $mff.l -text " $msg " -bg grey60 -fg yellow] -expand yes -fill x
    pack [frame $mff.f] -expand yes -fill both
    pack [scrollbar $mff.f.sbx -orient horizontal -command "$mff.f.txt xview"] \
        -side bottom -fill x
    pack [scrollbar $mff.f.sby -command "$mff.f.txt yview"] -side right -fill y
    pack [text $mff.f.txt -wrap no -yscrollcommand "$mff.f.sby set" \
            -xscrollcommand "$mff.f.sbx set"] -expand yes -fill both -side left
    
    
    set lnglast [string length " $msg "]
    set row 1
    foreach l $lst {
        set lng [string length $l]
        if { $lng > $lnglast } { set lnglast $lng }
        $mff.f.txt insert end "$l\n"
        incr row
    }
    
    if { $row > 31 }     { set row 31 }
    if { $lnglast > 90 } { set lnglast 90 }
    $mff.f.txt configure -width $lnglast -height $row
 
    BWidget::place $w 0 0 center
    wm deiconify $w
    
    bind $w <Escape> "$tb.bb2 invoke 0"
    bind $w <F4>     "$tb.bb1 invoke 0"
    focus $mff.f.txt
    $mff.f.txt mark set insert 0.0
}

proc PrintDoc:Print { w lst } {
    global PRINTDOC MAIN
    if ![MessageDlg $w.dlg -buttons { } -icon question -type user -message "    $MAIN(Printer) ?" -default 0] {
        BeforeQuery PRINTDOC "   ... "
        set i 0
        set fd [open "|$MAIN(Printcmd) -L$MAIN(Printer)" w]
        foreach l $lst {
            puts $fd $l
            ProgressIncr PRINTDOC(progress) [incr i] 4    
        }
        close $fd
        AfterQuery PRINTDOC
    }
}
