proc Raschet {} {
    global RASCHET MAIN
    Unset RASCHET
    if [winfo exists .raschet] { destroy .raschet }
    toplevel .raschet
    wm withdraw .raschet
    wm title .raschet ""

    LoadWhileCreateWindow .raschet

    # MainFrame ####################################################################
    set mf [MainFrame .raschet.mf -textvariable RASCHET(status) \
            -progressvar RASCHET(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [Separator $tb.sep1 -orient vertical] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .raschet RASCHET" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # Head #########################################################################
    pack [frame $mff.head]
    
    Pdr:Sel RASCHET
    set RASCHET(head_tmonth_year) $MAIN(tmonthyear)
    
    pack [set hf1 [frame $mff.head.f1]]
    pack [label $hf1.l1 -text " " -font [option get $hf1 bigFont Frame] \
        -fg black] -side left
    pack [ComboBox $hf1.monthyear -editable 0 -label "  " -width 13 -height 13 \
        -values [YearAmongMonth $RASCHET(head_tmonth_year)] -modifycmd Raschet:Dat \
        -textvariable RASCHET(head_tmonth_year) \
        -helptext "   "] -side left
    
    set RASCHET(radio) 0
    pack [set hf2 [frame $mff.head.f2 -bd 2 -relief groove]]
    pack [radiobutton $hf2.rb1 -text " " \
        -command "Raschet:AcDeactivate $hf2.rb1 {}" \
        -value 0 -variable RASCHET(radio)] -anchor w -padx 2
    
    pack [set hf3 [frame $hf2.f3]] -anchor w -padx 2
    pack [radiobutton $hf3.rb1 -text " " \
        -command "Raschet:AcDeactivate $hf3.rb1 $hf3.pdr"\
        -value 1 -variable RASCHET(radio)] -side left
    pack [ComboBox $hf3.pdr -editable 0 -width 30 \
        -values $RASCHET(lpdr_nam)  -modifycmd Raschet:Pdr \
        -textvariable RASCHET(head_pdr_nam) \
        -helptext "   "] -side left
        
    pack [set hf4 [frame $hf2.f4]] -anchor w -padx 2
    pack [radiobutton $hf4.rb1 -text "    " \
        -command "Raschet:AcDeactivate $hf4.rb1 $hf4.sot" \
        -value 2 -variable RASCHET(radio)] -side left
    pack [Entry $hf4.sot -width 50 \
        -command "Raschet:HeSot .raschet" \
        -textvariable RASCHET(head_sot_fio) \
        -helptext "    "] -side left

    pack [set hf5 [frame $hf2.f5 -bd 2 -relief groove]] -pady 2
    pack [Button $hf5.b -text " " \
        -command "Raschet:Execute .raschet"] -padx 5 -pady 2
    
    set RASCHET(monthyearwindow) $hf1.monthyear
    set RASCHET(pdrwindow)       $hf3.pdr
    set RASCHET(sotwindow)       $hf4.sot

    bind .raschet <Escape> "$tb.bb2 invoke 0"
    
    Raschet:AcDeactivate {} {}
    BWidget::place .raschet 0 0 center
    wm deiconify .raschet
}

proc Raschet:Get:YMPdr { } {
    global RASCHET
    set m [GetMonthInt [lindex $RASCHET(head_tmonth_year) 0]]
    set y [lindex $RASCHET(head_tmonth_year) 1]
    if { [set idx [$RASCHET(pdrwindow) getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex $RASCHET(lpdr_cod) $idx]
    }
    return "$y $m $pdr_cod"
}

proc Raschet:HeSot { w } {
    global RASCHET
    Lindexes [Raschet:Get:YMPdr] y m pdr_cod
    set heret [He RASCHET $RASCHET(sotwindow) -width 50 -find $RASCHET(head_sot_fio) \
                   -side top -anchor w \
                   -title " " \
                   -labels {  50 } \
                   -query "select distinct a.fio as sot_fio, a.cod as sot_cod \
                               from sot a join sotdol as b on a.cod = sot_cod and \
                                               b.dt < '[GetFirstDayNextMonth $m $y]' and \
                                               ( b.du is null or b.du > '01.$m.$y' ) \
                                          join dol as c on b.dol_cod = c.cod and \
                                               c.pdr_cod = $pdr_cod \
                               where \[Construct a.fio \${wdd}HE(find)\] \
                               order by a.fio"]
     Lindexes $heret RASCHET(head_sot_fio) RASCHET(head_sot_cod)
}

proc Raschet:AcDeactivate { wm wcfg } {
    global RASCHET
    if [IsBe wm] { focus $wm }
    $RASCHET(pdrwindow) configure -state disabled
    $RASCHET(sotwindow) configure -state disabled
    if [IsBe wcfg] { $wcfg configure -state normal }
}

proc Raschet:Dat {} {
    global RASCHET
    $RASCHET(monthyearwindow) configure \
        -values [YearAmongMonth $RASCHET(head_tmonth_year)]
    set RASCHET(head_sot_cod) ""
    set RASCHET(head_sot_fio) ""
}

proc Raschet:Pdr {} {
    global RASCHET
    set RASCHET(head_sot_cod) ""
    set RASCHET(head_sot_fio) ""
}

