proc Raschet:Execute { tpl } {
    global RASCHET
    Lindexes [Wreport:Get:YMPdr RASCHET] y m pdr_cod
    switch -exact -- $RASCHET(radio) {
        0 {
            set where "b.dt < '[GetFirstDayNextMonth $m $y]' and
                       ( b.du is null or b.du > '01.$m.$y' )"
        }
        1 {
            set where "c.pdr_cod = $pdr_cod and
                      b.dt < '[GetFirstDayNextMonth $m $y]' and
                      ( b.du is null or b.du > '01.$m.$y' )"
        }
        2 {
            if { ![IsBe RASCHET(head_sot_fio)] || ![IsBe RASCHET(head_sot_cod)] ||
                 $RASCHET(head_sot_cod) <= 0 } {
                MessageDlg $tpl.dlg  -icon warning -type ok -message "  .   !"
                return
            }
            set where "a.cod = $RASCHET(head_sot_cod) and
                      b.dt < '[GetFirstDayNextMonth $m $y]' and
                      ( b.du is null or b.du > '01.$m.$y' )"
        }
    }
    Raschet:Raschet RASCHET $tpl $y $m $where
}

proc Raschet:Raschet { glb tpl y m where } {
    global $glb MAIN errorInfo
    
    set rewhere "a.dt <= vinterval('01.$m.$y', e.c1 + 1, 'month') and
                 ( a.du is null or a.du >= vinterval('01.$m.$y', e.c2, 'month'))"
    regsub "b\\.dt.*" $where $rewhere where2
    regsub "c\\.pdr_cod" $where2 "a.pdr_cod" where2

    BeforeQuery $glb "   ... "
    Waiting $tpl "  ..."
    
    pg_exec $MAIN(iddbs) "begin work"
    
    set sotquery "select distinct a.cod from sot a, sotdol b, dol c
                      where a.cod = b.sot_cod and
                            b.dol_cod = c.cod and
                            $where"
    
    #      
    set err [dpg_exec $tpl $MAIN(iddbs) "delete from raschet 
                                            where dat = '01.$m.$y' and
                                                  sot_cod in ($sotquery)"]
    Raschet:TransactionError $tpl curr $err $glb
    
    #      
    set lstlvlnach {}
    set err [dpg_select $tpl $MAIN(iddbs) \
                "select distinct lvl from un where tip = 1 order by lvl" A {
        lappend lstlvlnach $A(lvl)
    }]
    Raschet:TransactionError $tpl curr $err $glb
    
    #      
    set lstlvlud {}
    set err [dpg_select $tpl $MAIN(iddbs) \
                "select distinct lvl from un where tip = -1 order by lvl" A {
        lappend lstlvlud $A(lvl)
    }]
    Raschet:TransactionError $tpl curr $err $glb
    
    #   
    foreach lvl $lstlvlnach {
        set ${glb}(status) "    $lvl ... "
        incr ${glb}(progress)
        set err [dpg_exec $tpl $MAIN(iddbs) \
                    "insert into raschet(pdr_cod, sot_cod, un_cod, dat, summa)
                     select a.pdr_cod, a.sot_cod, d.un_cod, '01.$m.$y',
                            ((sum(f.summa) - g.c1) * g.c4 / 100 + g.c3)::numeric(6,2) as summa
                        from (select distinct a.cod as sot_cod, c.pdr_cod 
                                from sot a, sotdol b, dol c
                                where a.cod = b.sot_cod and
                                      b.dol_cod = c.cod and
                                      $where) a,
                             sotunz d, unz e, oper f, unr g
                        where a.sot_cod = d.sot_cod and  
                              d.un_cod = e.m_cod and
                              e.m_tip = 1 and
                              e.m_vid = 'z' and
                              e.m_lvl = $lvl and
                              a.sot_cod = f.sot_cod and
                              a.pdr_cod = f.pdr_cod and
                              e.s_cod = f.un_cod and
                              f.datvidano = '01.$m.$y' and
                              d.un_cod = g.un_cod
                        group by a.pdr_cod, a.sot_cod, d.un_cod, g.c1, g.c2, g.c3, 
                                 g.c4
                        having g.c2 >= sum(f.summa) and
                               g.c1 <  sum(f.summa)"]
        Raschet:TransactionError $tpl curr $err $glb
    }
    
    #   
    set ${glb}(status) "   ... "
    incr ${glb}(progress)
    set err [dpg_exec $tpl $MAIN(iddbs) \
                "insert into raschet(pdr_cod, sot_cod, un_cod, dat, summa)
                 select a.pdr_cod, a.cod, b.un_cod, '01.$m.$y',
                        (sum(d.summa) * e.c4 / 100 + e.c3)::numeric(6,2) as summa
                    from (select distinct on (a.cod, c.pdr_cod) 
                                a.cod, b.dt, b.du, c.pdr_cod
                              from sot a, sotdol b, dol c
                              where a.cod = b.sot_cod and
                                    b.dol_cod = c.cod) a,
                         sotunz b, unz c, oper d, unr e
                    where $where2 and
                          a.cod = b.sot_cod and
                          b.un_cod = c.m_cod and
                          c.m_tip = 1 and
                          c.m_vid = 'p' and
                          a.cod = d.sot_cod and
                          a.pdr_cod = d.pdr_cod and
                          c.s_cod = d.un_cod and
                          d.datvidano >= vinterval('01.$m.$y', e.c2, 'month') and
                          d.datvidano <= vinterval('01.$m.$y', e.c1, 'month') and
                          b.un_cod = e.un_cod
                    group by a.pdr_cod, a.cod, b.un_cod, e.c4, e.c3"]
    Raschet:TransactionError $tpl curr $err $glb

    #   
    set ${glb}(status) "   ... "
    incr ${glb}(progress)
    set err [dpg_exec $tpl $MAIN(iddbs) \
                "insert into raschet(pdr_cod, sot_cod, un_cod, dat, summa)
                 select a.pdr_cod, a.sot_cod, b.un_cod, '01.$m.$y',
                        (sum(e.summa) * f.c4 / 100)::numeric(6,2) as summa
                    from (select distinct a.cod as sot_cod, c.pdr_cod,
                                 (select min(dt) from sotdol x 
                                     where x.sot_cod = a.cod) as mindt,
                                 a.sto, a.stn, a.stnf, a.sts, a.stsf
                              from sot a, sotdol b, dol c
                              where a.cod = b.sot_cod and
                                    b.dol_cod = c.cod and
                                    $where) a,
                         sotunz b, unz d, oper e, unr f
                    where a.sot_cod = b.sot_cod and
                          b.un_cod = d.m_cod and
                          d.m_tip = 1 and
                          d.m_vid = 's' and
                          a.sot_cod = e.sot_cod and
                          a.pdr_cod = e.pdr_cod and
                          d.s_cod = e.un_cod and
                          e.datvidano = '01.$m.$y' and
                          b.un_cod = f.un_cod and
                          1000000*f.c1 + 1000*f.c2 + f.c3 = 
                            (select max(1000000*x.c1 + 1000*x.c2 + x.c3)
                                from unr as x 
                                where x.un_cod = b.un_cod and
                                      x.c1 <= sotstag(a.sto, 1::bool, a.mindt, '01.$m.$y') and
                                      x.c2 <= sotstag(a.stn, a.stnf,  a.mindt, '01.$m.$y') and
                                      x.c3 <= sotstag(a.sts, a.stsf,  a.mindt, '01.$m.$y')
                                )
                    group by a.pdr_cod, a.sot_cod, b.un_cod, a.mindt, 
                             f.c1,  f.c2,  f.c3,   f.c4, 
                             a.sto, a.stn, a.stnf, a.sts, a.stsf"]
    Raschet:TransactionError $tpl curr $err $glb
    
    #  
    set ${glb}(status) "  ... "
    incr ${glb}(progress)
    set err [dpg_exec $tpl $MAIN(iddbs) \
                "insert into raschet(sot_cod, un_cod, dat, summa)
                 select a.sot_cod, b.un_cod, '01.$m.$y',
                        ((sum(e.summa * d.s_tip) - f.c1) * f.c4 / 100 + f.c3)::numeric(6,2) as summa
                    from (select distinct a.cod as sot_cod
                            from sot a, sotdol b, dol c
                            where a.cod = b.sot_cod and
                                  b.dol_cod = c.cod and
                                  $where) a,
                         sotunz b, un c, unz d, oper e, unr f
                    where a.sot_cod = b.sot_cod and
                          b.un_cod = c.cod and
                          c.tip = -1 and
                          c.vid = 'n' and
                          b.un_cod = d.m_cod and
                          b.sot_cod = e.sot_cod and
                          d.s_cod = e.un_cod and
                          e.datvidano = '01.$m.$y' and
                          b.un_cod = f.un_cod
                    group by a.sot_cod, b.un_cod, f.c1, f.c2, f.c3, f.c4
                    having f.c2 >= sum(e.summa) and
                           f.c1 <  sum(e.summa)"]
    Raschet:TransactionError $tpl curr $err $glb
    
    #   
    foreach lvl $lstlvlud {
        set ${glb}(status) "    $lvl ... "
        incr ${glb}(progress)
        set err [dpg_exec $tpl $MAIN(iddbs) \
                    "insert into raschet(sot_cod, un_cod, dat, summa)
                     select a.sot_cod, b.un_cod, '01.$m.$y',
                            ((sum(e.summa * d.s_tip) - f.c1) * f.c4 / 100 + f.c3)::numeric(6,2) as summa
                        from (select distinct a.cod as sot_cod
                                from sot a, sotdol b, dol c
                                where a.cod = b.sot_cod and
                                      b.dol_cod = c.cod and
                                      $where) a,
                             sotunz b, un c, unz d, oper e, unr f
                        where a.sot_cod = b.sot_cod and
                              b.un_cod = c.cod and
                              c.tip = -1 and
                              c.vid = 'z' and
                              c.lvl = $lvl and
                              b.un_cod = d.m_cod and
                              b.sot_cod = e.sot_cod and
                              d.s_cod = e.un_cod and
                              e.datvidano = '01.$m.$y' and
                              b.un_cod = f.un_cod
                        group by a.sot_cod, b.un_cod, f.c1, f.c2, f.c3, f.c4
                        having f.c2 >= sum(e.summa) and
                               f.c1 <  sum(e.summa)"]
        Raschet:TransactionError $tpl curr $err $glb
    }
    
    Raschet:TransactionError $tpl end $err $glb
    AfterQuery $glb
    Waiting $tpl close
}

proc Raschet:TransactionError { tpl cmd err var } {
    global MAIN $var
    if { $cmd == "curr" } {
        if { $err == -1 } {
            pg_exec $MAIN(iddbs) "rollback work"
            Waiting $tpl close
            AfterQuery $var
            return -code return
        }
    }
    if { $cmd == "end" } {
        if { $err != -1 } {
            pg_exec $MAIN(iddbs) "commit work"
        } else {
            pg_exec $MAIN(iddbs) "rollback work"
            Waiting $tpl close
            AfterQuery $var
            return -code return
        }
    }
}
