namespace eval Report {
namespace export report

proc isintdec { str } { # return 1  str 
    if [regexp "^\[0-9]*\\.\[0-9]*$" $str] { return 1 }
    if [regexp "^\[0-9]*,\[0-9]*$" $str] { return 1 }
    if [regexp "^\[1-9]\[0-9]*$" $str] { 
        if { [string length $str] > 9 } { return 0 }
        return 1 
    }
    return 0
}

proc gfs { str } { # generate format sub
    #   
    # <<<< to %-5s
    # >>>> to %5s
    # @@@.@@ to %+5.2f
    # ###.## to %5.2f
    # @@@@@ to %+5i
    # ##### to %5i
    
    set ret $str
    switch -regexp -- $str {
        ^<+$ { set lng [string length $str]; set ret "%-$lng.${lng}s" }
        ^>+$ { set lng [string length $str]; set ret "%$lng.${lng}s" }
        ^@+$ { set lng [string length $str]; set ret "%+${lng}i" }
        ^#+$ { set lng [string length $str]; set ret "%${lng}i" }
        ^@+\\.@+$ { 
            scan $str "%\[^.]%*c%s" s1 s2
            set lng2 [string length $s2]
            set lng1 [expr [string length $s1] + $lng2 + 1]
            set ret "%+$lng1.${lng2}f" 
        }
        ^#+\\.#+$ { 
            scan $str "%\[^.]%*c%s" s1 s2
            set lng2 [string length $s2]
            set lng1 [expr [string length $s1] + $lng2 + 1]
            set ret "%$lng1.${lng2}f" 
        }
    }
    return $ret
}

proc cfs { str } { # create format string
#   {  ----  % ->   ->  %+4i  \% }
    #     
    #    (#) 
    regsub -all -- "%" $str "%%" str
    regsub -all -- "(\\+)|(\{)|(\})|(\\\\)|(\")" $str "\\\\&" str
    #       gfs
    regsub -all -- " " $str " \{ \} " str
    set ret ""
    foreach i $str { set ret "$ret[gfs $i]" }
    return $ret
}

proc prnstr { str args } { #    
# str -    ,    
# args -  
    #  
    variable REPORT
    set fstr {}
    set varn {}
    scan $str "%\[^~]%*c%\[^\n]" fstr varn
    regsub -all -- "(&.\[0-9]*)|(&page)" $varn "\[lindex \$args &\]" varn
    regsub -all -- "&" $varn "" varn
    regsub -all -- "(.*-.*)|(.*\\*.*)|(.*\\+.*)|(.*%.*)|(.*/.*)" $varn "\[expr &\]" varn
    #    format
    set fstr "[cfs $fstr]"
    
    #     null   
    regsub -all -- "%" "{$fstr}" "\} \{%" p1
    regsub -all -- "\\\[" $varn "\{\[" p2
    regsub -all -- "\\\]" $p2 "\]\}" p2
    set idx 0
    set newfstr {}
    foreach i $p1 {
        if [regexp "^%" $i] {
            if { [subst [lindex $p2 $idx]] == "" } {
                regsub "(i )|(f )" $i "s " i
            }
            incr idx
        }
        append newfstr $i
    }
    set fstr "format {$newfstr}"
    set strprint [eval $fstr $varn]
    regsub -all -- " " $strprint "" strprnif
    set lstrprnif  [string length $strprnif]
    set ltstrprnif [string length [string trim $strprnif]]
    if { $lstrprnif == $ltstrprnif && $lstrprnif != 0 && $lstrprnif <= 2 } {
    } else {
        lappend REPORT(listrep) $strprint
    }
}

proc report { cmd args } { #  
# cmd - start, stop, output
    switch -exact $cmd {
        start  { eval rep:start $args }
        stop   { eval rep:stop $args }
        output { eval rep:output $args }
    }
}

proc rep:start { fl args } { #  
    variable VAR "" 
    variable REPORT
    variable AGREGATES
    variable NameVarTriggerOn ""
    variable NameVarTriggerOf ""
    variable NameVarBeforeGroupOf ""
    variable NameVarBeforeGroupOfOnly ""
    variable NameVarAfterGroupOf ""
    variable ElementVarTriggerOn
    variable ElementVarTriggerOf
    variable ElementVarBeforeGroupOf
    variable ElementVarBeforeGroupOfOnly
    variable ElementVarAfterGroupOf

    foreach i { VAR REPORT AGREGATES 
                ElementVarTriggerOn     ElementVarTriggerOf
                ElementVarBeforeGroupOf ElementVarBeforeGroupOfOnly 
                ElementVarAfterGroupOf  on_last_row
                page_trailer            after_group_of 
                on_every_row            page_header 
                forst_page_header } {
        catch [unset $i]
    }
    
    #        
    set REPORT(countline) 0
    set REPORT(countpage) 0
    set REPORT(all_args) ""
    #  - 
    set fd [open $fl.mac "r"]
    while 1 {
        if [eof $fd] break
        gets $fd str
        if [regexp -- "^~.*~.*" $str] { 
            #      
            regsub -all -- "~" [lindex $str 0] "" secname
            variable $secname ""
            #   ( )  VAR
            lappend VAR $secname
            if { $secname == "trigger_on" } {
                set secname "$secname[lindex $str 1]"
                variable $secname ""
                lappend VAR $secname
                lappend NameVarTriggerOn [lindex $str 1]
            }
            if { $secname == "trigger_of" } {
                set secname "$secname[lindex $str 1]"
                variable $secname ""
                lappend VAR $secname
                lappend NameVarTriggerOf [lindex $str 1]
            }
            if { $secname == "before_group_of" } {
                set secname "$secname[lindex $str 1]"
                variable $secname ""
                lappend VAR $secname
                lappend NameVarBeforeGroupOf [lindex $str 1]
            }
            if { $secname == "before_group_of_only" } {
                set secname "$secname[lindex $str 1]"
                variable $secname ""
                lappend VAR $secname
                lappend NameVarBeforeGroupOfOnly [lindex $str 1]
            }
            if { $secname == "after_group_of" } {
                set secname "$secname[lindex $str 1]"
                variable $secname ""
                lappend VAR $secname
                lappend NameVarAfterGroupOf [lindex $str 1]
            }
        } else {
            #       
            lappend $secname $str
        }
    }
    close $fd
    #    
    scan $define "%s%\[^\}]" fuf REPORT(page_length)
    #        page_trailer
    if [info exist page_trailer] {
        set REPORT(page_length) [expr $REPORT(page_length) - [llength $page_trailer]]
    }
    #    
    set REPORT(flg_print_first_page_header) 1
    
}

proc rep:output { args } { #     
    variable VAR
    variable REPORT
    variable AGREGATES

    set REPORT(all_args) $args
    #   
    for { set i 0 } { $i < [llength $args] } { incr i } {
        for { set j 0 } { $j < [llength $args] } { incr j } {
            foreach k { sum max cnt } {
                if ![info exists AGREGATES(${k}_${j}:${i})] { 
                    set AGREGATES(${k}_${j}:${i}) 0 
                }
            }
        }
        foreach k { sum max cnt } {
            if ![info exists AGREGATES(${k}_pagetrailer:${i})] { 
                set AGREGATES(${k}_pagetrailer:${i}) 0 
            }
            if ![info exists AGREGATES(${k}_onlastrow:${i})] { 
                set AGREGATES(${k}_onlastrow:${i}) 0 
            }
        }
    }

    foreach i $VAR { variable $i }
    eval rep:output:first_page_header $args
    set REPORT(flg_print_first_page_header) 0
    eval rep:output:page_header $args
    eval rep:output:page_trailer $args
    if ![info exists REPORT(old_args)] { set REPORT(old_args) $args }
    if [info exists trigger_of] {
        eval rep:output:trigger_of $args
    }
    if [info exists trigger_on] {
        eval rep:output:trigger_on $args
    }
    if [info exists after_group_of] {
        eval rep:output:after_group_of $args
    }
    if [info exists before_group_of] {
        eval rep:output:before_group_of $args
    }
    if [info exists before_group_of_only] {
        eval rep:output:before_group_of_only $args
    }
    
    if [info exist on_every_row] {
        eval rep:output:page_header $args
        eval rep:output:on_every_row $args
        eval rep:output:page_trailer $args
    }
    
    #   
    if [array exists AGREGATES] {
        #   sum
        foreach { el fuf } [array get AGREGATES sum*] {
            scan $el "%\[^_]%*c%\[^:]%*c%s" fuf fuf idx
            set elop [lindex $args $idx]
            if { [isintdec $elop] && [string length $elop] > 0 } {
                set AGREGATES($el) [expr $AGREGATES($el) + $elop]
            }
        }
        #   max
        foreach { el fuf } [array get AGREGATES max*] {
            scan $el "%\[^_]%*c%\[^:]%*c%s" fuf fuf idx
            if [isintdec [lindex $args $idx]] {
                set vvr [lindex $args $idx]
                if { $vvr > $AGREGATES($el) } {
                    set AGREGATES($el) $vvr
                }
            }
        }
        #   cnt
        foreach { el fuf } [array get AGREGATES cnt*] {
            incr AGREGATES($el)
        }
    }
    set REPORT(old_args) $args
}

proc rep:output:first_page_header { args } {
    variable REPORT
    variable first_page_header
    
    if { [info exist first_page_header] && $REPORT(flg_print_first_page_header) } {
        for { set i 0 } { $i < [llength $first_page_header] } { incr i } {
            eval prnstr {[lindex $first_page_header $i]} $args
            incr REPORT(countline)
        }
    }
}

proc rep:output:page_header { args } {
    variable REPORT
    variable page_header

    if { [info exist page_header] && ![info exist REPORT(flg_page_header)] } {
        set REPORT(flg_page_header) ""
        incr REPORT(countpage)
        for { set i 0 } { $i < [llength $page_header] } { incr i } {
            eval prnstr {[lindex $page_header $i]} $args
            set REPORT(flg_page_trailer) 1
            incr REPORT(countline)
        }
    }
}

proc rep:output:on_every_row { args } {
    variable REPORT 
    variable on_every_row

    for { set i 0 } { $i < [llength $on_every_row] } { incr i } {
        eval prnstr {[lindex $on_every_row $i]} $args
        set REPORT(flg_page_trailer) 1
        incr REPORT(countline)
    }
}

proc rep:output:trigger_on { args } {
    variable REPORT 
    variable NameVarTriggerOn
    variable ElementVarTriggerOn

    foreach i $NameVarTriggerOn {
        variable trigger_on$i
        set ElementVarTriggerOn($i) [lindex $args $i]
        if { ![info exists ElementVarTriggerOn(old_$i)] && 
             $ElementVarTriggerOn($i) != 0 || 
             [info exists ElementVarTriggerOn(old_$i)] &&
             $ElementVarTriggerOn(old_$i) == 0 &&
             $ElementVarTriggerOn($i) != 0 } {
            for { set j 0 } { $j < [llength [subst $[subst trigger_on$i]]] } { incr j } {
                eval rep:output:page_header $args
                eval prnstr {[lindex [subst $[subst trigger_on$i]] $j]} $args
                set REPORT(flg_page_trailer) 1
                incr REPORT(countline)
                eval rep:output:page_trailer $args
            }
        }
        set ElementVarTriggerOn(old_$i) $ElementVarTriggerOn($i)
    }
}

proc rep:output:trigger_of { args } {
    variable REPORT 
    variable NameVarTriggerOf
    variable ElementVarTriggerOf

    foreach i $NameVarTriggerOf {
        variable trigger_of$i
        set ElementVarTriggerOf($i) [lindex $args $i]
        if { [info exists ElementVarTriggerOf(old_$i)] &&
             $ElementVarTriggerOf(old_$i) != 0 &&
             $ElementVarTriggerOf($i) == 0 } {
            for { set j 0 } { $j < [llength [subst $[subst trigger_of$i]]] } { incr j } {
                eval rep:output:page_header $args
                eval prnstr {[lindex [subst $[subst trigger_of$i]] $j]} $args
                set REPORT(flg_page_trailer) 1
                incr REPORT(countline)
                eval rep:output:page_trailer $args
            }
        }
        set ElementVarTriggerOf(old_$i) $ElementVarTriggerOf($i)
    }
}

proc rep:output:before_group_of { args } {
    variable REPORT 
    variable NameVarBeforeGroupOf
    variable ElementVarBeforeGroupOf

    set idx 1
    foreach i $NameVarBeforeGroupOf {
        variable before_group_of$i
        set ElementVarBeforeGroupOf($i)     [lindex $args $i]
        if { ![info exists ElementVarBeforeGroupOf(old_$i)] || \
             $ElementVarBeforeGroupOf($i) != $ElementVarBeforeGroupOf(old_$i) } {
            foreach k [lrange $NameVarBeforeGroupOf $idx end] {
                set ElementVarBeforeGroupOf(old_$k) ""
            }
            for { set j 0 } { $j < [llength [subst $[subst before_group_of$i]]] } { incr j } {
                eval rep:output:page_header $args
                eval prnstr {[lindex [subst $[subst before_group_of$i]] $j]} $args
                set REPORT(flg_page_trailer) 1
                incr REPORT(countline)
                eval rep:output:page_trailer $args
            }
        }
        set ElementVarBeforeGroupOf(old_$i) $ElementVarBeforeGroupOf($i)
        incr idx
    }
}

proc rep:output:before_group_of_only { args } {
    variable REPORT 
    variable NameVarBeforeGroupOfOnly
    variable ElementVarBeforeGroupOfOnly

    foreach i $NameVarBeforeGroupOfOnly {
        variable before_group_of_only$i
        set ElementVarBeforeGroupOfOnly($i)     [lindex $args $i]
        if ![info exists ElementVarBeforeGroupOfOnly(old_$i)] {
            set ElementVarBeforeGroupOfOnly(old_$i) $ElementVarBeforeGroupOfOnly($i)
        } else {
            if { $ElementVarBeforeGroupOfOnly(old_$i) != $ElementVarBeforeGroupOfOnly($i) } {
                for { set j 0 } { $j < [llength [subst $[subst before_group_of_only$i]]] } { incr j } {
                    eval rep:output:page_header $args
                    eval prnstr {[lindex [subst $[subst before_group_of_only$i]] $j]} $args
                    set REPORT(flg_page_trailer) 1
                    incr REPORT(countline)
                    eval rep:output:page_trailer $args
                }
                unset ElementVarBeforeGroupOfOnly(old_$i)
            }
        }
        set ElementVarBeforeGroupOfOnly(old_$i) $ElementVarBeforeGroupOfOnly($i)
    }
}

proc rep:replace_agregates { grn elem vars } {
    variable AGREGATES

    #puts \ngrn=$grn
    #puts elem=$elem
    #puts vars=$vars
    
    if { [regexp "(sum&)|(max&)|(cnt&)" $elem] && 
         $grn == "onlastrow" && $vars == 0 } {
        return "{} {}"
    } else {
        #   
        regsub "&page" $elem "\\&[expr [llength $vars] - 1]" elem
        scan $elem "%\[^~]%*c%\[^\n]" onlystr nelem
        if [info exists nelem] {
            foreach i $nelem {
                set flg 0
                if [regsub "sum&" $i "" idx] {
                    lappend vars $AGREGATES(sum_${grn}:${idx})
                    lappend genelem "&[expr [llength $vars] - 1]"
                    set AGREGATES(sum_${grn}:${idx}) 0
                    set flg 1
                }
                if [regsub "max&" $i "" idx] {
                    lappend vars $AGREGATES(max_${grn}:${idx})
                    lappend genelem "&[expr [llength $vars] - 1]"
                    set AGREGATES(max_${grn}:${idx}) 0
                    set flg 1
                }
                if [regsub "cnt&" $i "" idx] {
                    lappend vars $AGREGATES(cnt_${grn}:${idx})
                    lappend genelem "&[expr [llength $vars] - 1]"
                    set AGREGATES(cnt_${grn}:${idx}) 0
                    set flg 1
                }
                if !$flg { lappend genelem $i }
            }
            set elem "${onlystr}~ $genelem"
        }
        return [subst {{$elem} $vars}]
    }
}

proc rep:output:after_group_of { args } {
    variable REPORT 
    variable after_group_of
    variable NameVarAfterGroupOf
    variable ElementVarAfterGroupOf

    set idx -1
    if [info exists after_group_of] {
        foreach i $NameVarAfterGroupOf {
            set ElementVarAfterGroupOf($i)     [lindex $args $i]
            if { [info exists ElementVarAfterGroupOf(old_$i)] && \
                 $ElementVarAfterGroupOf($i) != $ElementVarAfterGroupOf(old_$i) } {
                foreach k [lrange $NameVarAfterGroupOf 0 $idx] {
                    set ElementVarAfterGroupOf(old_$k) " "
                }
            }
            incr idx
        }
        set idx 0
        foreach i $NameVarAfterGroupOf {
            variable after_group_of$i
            if { [info exists ElementVarAfterGroupOf(old_$i)] && \
                 $ElementVarAfterGroupOf($i) != $ElementVarAfterGroupOf(old_$i) } {
                for { set j 0 } { $j < [llength [subst $[subst after_group_of$i]]] } { incr j } {
                    eval rep:output:page_header $args
                    set outstr [lindex [subst $[subst after_group_of$i]] $j]
                    eval prnstr [rep:replace_agregates $i $outstr $REPORT(old_args)]
                    set REPORT(flg_page_trailer) 1
                    incr REPORT(countline)
                    eval rep:output:page_trailer $args
                }
            }
            set ElementVarAfterGroupOf(old_$i) $ElementVarAfterGroupOf($i)
            incr idx
        }
    }
}

proc rep:output:page_trailer { args } {
    variable REPORT
    variable page_trailer
    
    set args $REPORT(all_args)
    if { [info exists page_trailer] && [info exists REPORT(flg_page_trailer)] } {
        if $REPORT(flg_page_trailer) {
            if { $REPORT(countline) >= $REPORT(page_length) } {
                catch [unset REPORT(flg_page_header)]
                set REPORT(countline) 0
                lappend args $REPORT(countpage)
                for { set i 0 } { $i < [llength $page_trailer] } { incr i } {
                    set outstr [lindex $page_trailer $i]
                    eval prnstr [rep:replace_agregates pagetrailer $outstr $args]
                }
                set REPORT(flg_page_trailer) 0
            }
        }
    }
}


proc rep:stop { args } { #  
    variable VAR 
    variable REPORT
    variable AGREGATES
    variable on_last_row
    
    eval rep:output:after_group_of $args
    set REPORT(countline) $REPORT(page_length)
    eval rep:output:page_trailer $args
    set args $REPORT(all_args)
    if [info exist on_last_row] {
        lappend args $REPORT(countpage)
        for { set i 0 } { $i < [llength $on_last_row] } { incr i } {
            set outstr [lindex $on_last_row $i]
            eval prnstr [rep:replace_agregates onlastrow $outstr $args]
        }
    }
    if [info exists REPORT(listrep)] { return $REPORT(listrep) }
}
}
