proc Rn {} {
    global RN
    if [winfo exists .rn] { destroy .rn }
    Unset RN
    set RN(gowork) Ins
    toplevel .rn
    wm withdraw .rn
    wm title .rn "  "

    LoadWhileCreateWindow .rn
    
    # MainFrame ####################################################################
    set mf [MainFrame .rn.mf -textvariable RN(status) -progressvar RN(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    pack [set tb [$mf addtoolbar]] -fill x
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "" } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .rn RN" help "  <F1> " "Help .rn \"  \" rn" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # PanedWindow ##################################################################
    packef [PanedWindow $mff.pw]
    set pw1 [$mff.pw add -minsize 100]
    set pw2 [$mff.pw add -minsize 100 -weight 0]

    # MAIN #########################################################################
    packef [TitleFrame $pw1.main -text "  "]
    set main [$pw1.main getframe]
    pack [scrollbar $main.sby -command "$main.mcl yview"] -side right -fill y
    packef [mclistbox $main.mcl -width 30 -height 25 -yscrollcommand "$main.sby set"]
    $main.mcl column add nam -label "  " -width 30
    $main.mcl column add cod -visible no
    
    bind $main.mcl  <ButtonRelease-1> "focus $main.mcl; Rn:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Up>   "Rn:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Down> "Rn:Import:Attr $main.mcl"
    bind $main      <FocusIn>         "Rn:Activate:TF $pw1.main"
    bind $main      <FocusOut>        "Rn:DeActivate:TF $pw1.main"

    $tb.bb1 itemconfigure 0 -command "Rn:Print $main.mcl"

    # ATTRIBUTE ####################################################################
    pack [TitleFrame $pw2.attr -text "  "] -side top
    set attr [$pw2.attr getframe]
    pack [LabelEntry $attr.nam -helptext "     " \
            -label "  " -textvariable RN(nam) -width 30]
    
    set RN(find) [Construct a.nam RN(nam)]
    
    $attr.nam bind  <Return>    "Rn:Attr:Bind $main.mcl"
    bind $attr      <FocusIn>   "Rn:Activate:TF $pw2.attr"
    bind $attr      <FocusOut>  "Rn:DeActivate:TF $pw2.attr"
    
    pack [frame $attr.fr -bd 2 -relief groove] -pady 2
    foreach { i j k } { Ins  F7   Upd  F6   Del  F8  Find  F5 } {
        pack [radiobutton $attr.fr.rb$i -value $i -variable RN(gowork) -takefocus 0 \
                          -width 0 -state disabled] -side left -pady 5
        bind $attr.fr.rb$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.rb$i balloon " $j,     <ENTER> "
        pack [button $attr.fr.b$i -text "$j" -takefocus 0 -command "Rn:$i $main.mcl" \
                     -state disabled] -side left
        bind $attr.fr.b$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.b$i balloon " $j   <$k> "
        $attr.nam bind <$k> "Rn:$i $main.mcl"
        
    }
    
    bind $main.mcl <Return> "focus $attr.nam"
    
    # CHAILD #######################################################################
    pack [TitleFrame $pw2.chaild -text "  "] -side bottom
    set chaild [$pw2.chaild getframe]
    
    Cal $pw2.chaild $chaild

    bind .rn <Escape> "$tb.bb2 invoke 0"
    bind .rn <F1>     "$tb.bb2 invoke 1"
    bind .rn <F4>     "$tb.bb1 invoke 0"
    
    BWidget::place .rn 0 0 center
    wm deiconify .rn
    
    Rn:Sel $main.mcl
}

proc Rn:Import:Attr { w } {
    global RN
    tonull RN(nam) RN(cod)
    if { [set idx [$w curselection]] >= 0 } { 
        $w activate $idx
        set RN(nam) [lindex [$w get $idx] 0]
        set RN(cod) [lindex [$w get $idx] 1]
    }
    Cal:Sel    
}

proc Rn:Attr:Bind { w } {
    global RN
    Rn:$RN(gowork) $w
}

proc Rn:Activate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state normal
            }
        }
    }
}

proc Rn:DeActivate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}
