proc Shablonunz:Create { win } {
    global SHABLONUNZ_DATA SHABLONUNZ
    set w $win.shablonunz
    if [winfo exists $w] { destroy $w }
    Unset SHABLONUBK_DATA
    toplevel $w
    wm transient $w $win
    wm withdraw $w
    wm title $w " "

    LoadWhileCreateWindow $w
    set SHABLONUNZ(radio) 1

    # MainFrame ####################################################################
    set mf [MainFrame $w.mf -textvariable SHABLONUNZ(status) \
        -progressvar SHABLONUNZ(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    $tb.bb2 add -image quit -helptext "  <Esc> " -relief link -takefocus 0 \
        -highlightthickness 0 -command "Escape $w SHABLONUNZ"

    pack [label $mff.l1 -text "   " \
        -font [option get $w bigFont Toplevel] \
        -fg black]
    
    pack [frame $mff.f]
    pack [scrollbar $mff.f.sby -command "$mff.f.tbl yview"] -side right -fill y
    pack [table $mff.f.tbl -width 2 -height 14 -cols 2 -rows 2 -relief flat \
        -yscrollcommand "$mff.f.sby set" \
        -browsecommand "Shablonunz:Tbl:Browsecommand %W" \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable SHABLONUNZ_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -colorigin 0]

    TkTableInitTag $mff.f.tbl
    
    $mff.f.tbl width 0 30  1 11
    $mff.f.tbl tag col Disabled 0
    $mff.f.tbl spans -2,0 1,0 -2,1 1,0
    
    bind $w          <Escape>   "$tb.bb2 invoke 0"
    bind $mff.f.tbl  <KeyPress-Down> {}
    bind $mff.f.tbl  <Return>   "Shablonunz:Tbl:Bind:Return $mff.f.tbl"
    bind $mff.f.tbl  <KP_Enter> "Shablonunz:Tbl:Bind:Return $mff.f.tbl"
    bind $mff.f.tbl  <FocusIn>  {
        if { [set row [%W tag row CurrentRow]] == "" } {
            set row 0
        }
        %W activate $row,1
        %W see $row,1
        %W.b$row configure -bg [option get %W currentBackground Table]
    }
    set SHABLONUNZ(tblwindow) $mff.f.tbl
    
    pack [frame $mff.f2 -bd 2 -relief groove] -padx 2 -pady 2
    pack [radiobutton $mff.f2.rb1 -text "  " \
        -value 1 -variable SHABLONUNZ(radio) \
        -command "Shablonunz:Radio $win.shablonunz"] -anchor w -padx 2
    pack [radiobutton $mff.f2.rb2 -text "   " \
        -value 0 -variable SHABLONUNZ(radio) \
        -command "Shablonunz:Radio $win.shablonunz"] -anchor w -padx 2
    
    Shablonunz:Sel $win.shablonunz
    BWidget::place $w 0 0 center
    wm deiconify $w
}

proc Shablonunz:Tbl:Bind:Return { w } {
    Shablonunz:Tbl:Bind:Lbl $w [$w index active row]
}

proc Shablonunz:Tbl:Browsecommand { w } {
    global SHABLONUNZ SHABLONUNZ_DATA
    set active [$w index active]
    if ![IsBe SHABLONUNZ(oldactive)] { set SHABLONUNZ(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $SHABLONUNZ(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    $w tag row CurrentRow $row
    $w.b$row configure -bg [option get $w currentBackground Table]
    if { $oldrow != $row } {
        $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
    }
    set SHABLONUNZ(oldactive) $active
}

