proc Shablonunz:Query {} {
    return "select a.nam, a.cod as un_cod, b.un_cod as s_cod, a.tip, 
                   b.un_cod/b.un_cod as sort, b.summa
                from un a left outer join shablon as b on a.cod = b.un_cod
                where a.vid in ('z','p','s','n')
                order by sort, a.tip desc, a.nam"
}

proc Shablonunz:Init:SHABLONUNZ_DATA {} {
    global SHABLONUNZ_DATA SHABLONUNZ
    Unset SHABLONUNZ_DATA
    set SHABLONUNZ_DATA(-2,0) "/"
    set SHABLONUNZ_DATA(-2,1) "+  - "
    for { set i 0 } { $i <= [$SHABLONUNZ(tblwindow) index end row] } { incr i } {
        destroy $SHABLONUNZ(tblwindow).b$i
    }
}

proc Shablonunz:Sel { w } {
    global MAIN SHABLONUNZ SHABLONUNZ_DATA SHABLONUNZ_OLDDATA
    Shablonunz:Init:SHABLONUNZ_DATA
    
    set wtbl $SHABLONUNZ(tblwindow)
    set titrows [$wtbl cget -titlerows]
    BeforeQuery SHABLONUNZ "   ... "
    set i 0
    set color1 [option get $wtbl rowOne Table]
    set color2 [option get $wtbl rowTwo Table]
    dpg_select $w $MAIN(iddbs) [Shablonunz:Query] A {
        set SHABLONUNZ_DATA($i,un_cod) $A(un_cod)
        set SHABLONUNZ_DATA($i,tip)    $A(tip)
        set SHABLONUNZ_DATA($i,s_cod)  $A(s_cod)
        set SHABLONUNZ_DATA($i,0)      [cnvs $A(nam)]
        if [VarIn A(summa) 0 1] { set SHABLONUNZ(radio) [expr int($A(summa))] }
        $wtbl configure -rows [expr $i + $titrows + 1]
        catch [destroy $wtbl.b$i]
        label $wtbl.b$i -image [Shablonunz:ImgPlusMinus $A(s_cod) $A(tip)] -bd 0 \
                   -bg [Shablonunz:Tbl:RowColor $color1 $color2 $i]
        bind $wtbl.b$i <1> "Shablonunz:Tbl:Bind:Lbl $wtbl $i"
        $wtbl window configure $i,1 -window $wtbl.b$i -sticky wens
        ProgressIncr SHABLONUNZ(progress) [incr i] 20
    }
        
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [expr $i + $titrows]
    }
    AfterQuery SHABLONUNZ
    focus $wtbl
}

proc Shablonunz:Tbl:RowColor { color1 color2 row } {
    if { [expr $row % 2] == 0 } {
        return $color1
    }
    return $color2
}

proc Shablonunz:Tbl:Bind:Lbl { w row } {
    global SHABLONUNZ_DATA
    if ![IsBe SHABLONUNZ(WaitReturn)] {
        set SHABLONUNZ(WaitReturn) 1
        set oldrow [$w tag row CurrentRow]
        $w tag row CurrentRow $row
        $w.b$row configure -bg [option get $w currentBackground Table]
        $w activate $row,1
        if [IsBe oldrow] {
            if { $oldrow != $row } {
                $w tag row [TkTableRowTagCmd $oldrow] $oldrow
                $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
            }
        }
        if [IsBe SHABLONUNZ_DATA($row,s_cod)] {
            Shablonunz:Del $w $row
        } else {
            Shablonunz:Ins $w $row
        }
        set SHABLONUNZ(WaitReturn) {}
    }
}

proc Shablonunz:Ins { w row } {
    global SHABLONUNZ_DATA MAIN SHABLONUNZ
    BeforeQuery SHABLONUNZ "  ... "
    set query "select shablon_ins($SHABLONUNZ_DATA($row,un_cod), 
                                  $SHABLONUNZ(radio)) as cod"
    set err [dpg_select $w $MAIN(iddbs) $query A {
        set SHABLONUNZ_DATA($row,s_cod) $SHABLONUNZ_DATA($row,un_cod)
        incr SHABLONUNZ(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [Shablonunz:ImgPlusMinus 1 $SHABLONUNZ_DATA($row,tip)]
        $w tag row CurrentRow $row
    }
    AfterQuery SHABLONUNZ
}

proc Shablonunz:Del { w row } {
    global SHABLONUNZ_DATA MAIN SHABLONUNZ
    BeforeQuery SHABLONUNZ "  ... "
    set query "select shablon_del('$SHABLONUNZ_DATA($row,un_cod)') as cod"
    set err [dpg_select $w $MAIN(iddbs) $query A {
        set SHABLONUNZ_DATA($row,s_cod) {}
        incr SHABLONUNZ(progress)
    }]
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [Shablonunz:ImgPlusMinus 0 $SHABLONUNZ_DATA($row,tip)]
        $w tag row CurrentRow $row
    }
    AfterQuery SHABLONUNZ
}

proc Shablonunz:ImgPlusMinus { cod tip } {
    set img minus
    set clr R
    if { $cod > 0 }  { set img plus }
    if { $tip == 1 } { set clr G }
    return $img$clr
}

proc Shablonunz:Get { tpl } {
    global MAIN SHABLONUNZ
    set ret {}
    dpg_select $tpl $MAIN(iddbs) [Shablonunz:Query] A {
        lappend ret [list $A(un_cod) $A(s_cod) $SHABLONUNZ(radio)]
    }
    return $ret
}

proc Shablonunz:Radio { tpl } {
    global SHABLONUNZ SHABLONUNZ_DATA MAIN
    BeforeQuery SHABLONUNZ "  ... "
    set wtbl $SHABLONUNZ(tblwindow)
    pg_exec $MAIN(iddbs) "begin work"
    set err 0
    for { set i 0 } { $i < [expr [$wtbl cget -rows] - [$wtbl cget -titlerows]] } { incr i } {
        set query "select shablon_upd($SHABLONUNZ_DATA($i,un_cod), 
                                      $SHABLONUNZ(radio)) as cod"
        set err [dpg_select $tpl $MAIN(iddbs) $query A {
            ProgressIncr SHABLONUNZ(progress) $i 20
        }]
        if { $err == -1 } break
    }
    if { $err != -1 } {
        pg_exec $MAIN(iddbs) "commit work"
    } else {
        pg_exec $MAIN(iddbs) "rollback work"
    }
    AfterQuery SHABLONUNZ
}
