proc Sot {} {
    global SOT
    if [winfo exists .sot] { destroy .sot }
    Unset SOT
    set SOT(gowork) Ins
    toplevel .sot
    wm withdraw .sot
    wm title .sot ""
    
    LoadWhileCreateWindow .sot
    
    # MainFrame ####################################################################
    set mf [MainFrame .sot.mf -textvariable SOT(status) -progressvar SOT(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "" } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .sot SOT" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # PanedWindow ##################################################################
    packef [PanedWindow $mff.pw]
    set pw1 [$mff.pw add -minsize 100]
    set pw2 [$mff.pw add -minsize 100 -weight 0]

    # MAIN #########################################################################
    packef [TitleFrame $pw1.main -text " "]
    set main [$pw1.main getframe]
    pack [scrollbar $main.sby -command "$main.mcl yview"] -side right -fill y
    pack [scrollbar $main.sbx -command "$main.mcl xview" -orient hor] \
        -side bottom -fill x
    packef [mclistbox $main.mcl -width 35 -height 25 \
                -xscrollcommand "$main.sbx set" \
                -yscrollcommand "$main.sby set"]

    set SOT(mclwindow) $main.mcl
    
    $main.mcl column add tn         -label ".N" -width 5 -foreground magenta4
    $main.mcl column add fio        -label "" -width 50
    $main.mcl column add cod        -visible no
    $main.mcl column add bank_schet -visible no
    $main.mcl column add inn        -visible no
    $main.mcl column add sto        -visible no
    $main.mcl column add stn        -visible no
    $main.mcl column add stnf       -visible no
    $main.mcl column add sts        -visible no
    $main.mcl column add stsf       -visible no
    
    $main.mcl label bind tn  <ButtonPress-1> "Sot:Sort %W tn"
    $main.mcl label bind fio <ButtonPress-1> "Sot:Sort %W fio"
    
    bind $main.mcl  <ButtonRelease-1> "focus $main.mcl; Sot:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Up>   "Sot:Import:Attr $main.mcl"
    bind $main.mcl  <KeyRelease-Down> "Sot:Import:Attr $main.mcl"
    bind $main      <FocusIn>         "Sot:Activate:TF $pw1.main"
    bind $main      <FocusOut>        "Sot:DeActivate:TF $pw1.main"

    $tb.bb1 itemconfigure 0 -command "Sot:Print $main.mcl"
    
    # ATTRIBUTE ####################################################################
    pack [TitleFrame $pw2.attr -text " "] -side top
    set attr [$pw2.attr getframe]
    
    foreach { i j k w } { tn         "     N" " " 5  
                          fio        "            " ", , " 30  
                          bank_schet " " " " 14 
                          inn        " " "  " 10 } {
        pack [LabelEntry $attr.$i -helptext "  $k " \
                -label " $j " -textvariable SOT($i) -width $w] -anchor w
        $attr.$i bind <Return> { focus [Widget::focusNext %W] }
    }
    
    pack [frame $attr.frs] -anchor w
    foreach { i j k w } { sto        ": " "  ( )" 3
                          stn        "" "  ( )" 3
                          sts        "" "( ) \n  ( )" 3 } {
        pack [LabelEntry $attr.frs.$i -helptext "  $k " \
                -label " $j " -textvariable SOT($i) -width $w] -side left -padx 0
        if { $i != "sto" } {
            pack [checkbutton $attr.frs.cb$i -variable SOT(${i}f) \
                          -onvalue t -offvalue f -width 0] -side left -padx 0
            DynamicHelp::register $attr.frs.cb$i balloon " ( )   \n    [Case i stn sts  ]  "
        }
        if { $i != "sts" } {
            $attr.frs.$i bind <Return> { focus [Widget::focusNext %W] }
        }
    }
    
    set SOT(find) [Construct a.tn a.fio a.bank_schet a.inn a.sto a.stn a.sts \
                    SOT(tn) SOT(fio) SOT(bank_schet) SOT(inn) SOT(sto) SOT(stn) SOT(sts)]
    
    $attr.frs.sts bind  <Return>    "Sot:Attr:Bind $main.mcl $attr"
    bind $attr          <FocusIn>   "Sot:Activate:TF $pw2.attr"
    bind $attr          <FocusOut>  "Sot:DeActivate:TF $pw2.attr"
    
    pack [frame $attr.fr -bd 2 -relief groove] -pady 2
    foreach { i j k } { Ins  F7   Upd  F6   Del  F8  Find  F5 } {
        pack [radiobutton $attr.fr.rb$i -value $i -variable SOT(gowork) -takefocus 0 \
                          -width 0 -state disabled] -side left -pady 5
        bind $attr.fr.rb$i <1> "focus $attr.tn"
        DynamicHelp::register $attr.fr.rb$i balloon " $j,     <ENTER> "
        pack [button $attr.fr.b$i -text "$j" -takefocus 0 -command "Sot:$i $main.mcl $attr" \
                     -state disabled] -side left
        bind $attr.fr.b$i <1> "focus $attr.tn"
        DynamicHelp::register $attr.fr.b$i balloon " $j  <$k> "
        foreach l { tn fio bank_schet inn frs.sto frs.stn frs.sts } {
            $attr.$l bind <$k> "Sot:$i $main.mcl $attr"
        }
    }
    
    bind $main.mcl <Return> "focus $attr.tn"
    
    # CHAILD #######################################################################

    pack [TitleFrame $pw2.chaild -text ""] -side bottom
    set chaild [$pw2.chaild getframe]
    
    pack [NoteBook $chaild.nb]
    set SOT(notebook) $chaild.nb
    foreach { i j } {  SotT  SotP  SotU  SotI } {
        $chaild.nb insert end $j -text $i
        set wfrm [$chaild.nb getframe $j]
        $j $tb.bb1 $pw2.chaild $wfrm
        set SOT(frame_$j) $wfrm
    }
    $chaild.nb bindtabs <1> "Sot:NoteBook:Tabs $chaild.nb"
    $chaild.nb compute_size
    $chaild.nb raise SotT
    
    ##############################################################################
    
    bind .sot <Escape> "$tb.bb2 invoke 0"
    bind .sot <F4>     "$tb.bb1 invoke 0"

    BWidget::place .sot 0 0 center
    wm deiconify .sot
    
    Sot:Sel $main.mcl
}

proc Sot:Sort { w fld } {
    Mclistbox:Sort $w $fld
    Sot:Import:Attr $w
}

proc Sot:NoteBook:Tabs { w page } {
    $page:Sel
}

proc Sot:Import:Attr { w } {
    global SOT
    tonull SOT(tn) SOT(fio) SOT(bank_schet) SOT(inn) SOT(sto) SOT(stn) SOT(sts) SOT(stnf) SOT(stsf)
    if { [set idx [$w curselection]] >= 0 } { 
        $w activate $idx
        Lindexes [$w get $idx] SOT(tn) SOT(fio) SOT(cod) SOT(bank_schet) SOT(inn) \
            SOT(sto) SOT(stn) SOT(stnf) SOT(sts) SOT(stsf)
    }
    [$SOT(notebook) raise]:Sel
}

proc Sot:Attr:Bind { w attr } {
    global SOT
    Sot:$SOT(gowork) $w $attr
}

proc Sot:Activate:TF { w } {
    global SOTT SOTP SOTU
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                if { ([IsBe SOTT(flgbutton)] || [IsBe SOTP(flgbutton)] ||
                    [IsBe SOTU(flgbutton)]) && [regexp chaild $i] } {
                    $i configure -state normal
                } elseif ![regexp chaild $i] {
                    $i configure -state normal
                }
            }
        }
    }
}

proc Sot:DeActivate:TF { w } {
    if [winfo exists $w ] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}
