proc SotP { bb chaild w } {
    global SOTP
    Unset SOTP
    
    pack [frame $w.f0] -anchor w
    pack [LabelEntry $w.f0.dol1 -helptext "   " \
            -label "     " -editable 0 \
            -textvariable SOTP(dol1_nam) -width 28 -bg grey70] -side left
    
    pack [frame $w.f1 -bd 0] -anchor w
    pack [LabelEntry $w.f1.dol2 -helptext "   " \
            -label "    " \
            -textvariable SOTP(dol2_nam) -width 28 \
            -command "SotP:He $w.f0.dol1" ] -side left
    $w.f1.dol2 bind <Return> { focus [Widget::focusNext %W] }
    pack [ArrowButton $w.f1.ab -dir bottom -command "SotP:He $w.f0.dol1" \
        -helptext "     " ] -side right -fill y

    pack [LabelEntry $w.dt -helptext "    " \
            -label "            " \
            -textvariable SOTP(dt) -width 10] -anchor w
    $w.dt bind <Return> { focus [Widget::focusNext %W] }
    $w.dt bind <FocusIn> { if ![IsBe SOTP(dt)] { set SOTP(dt) $MAIN(today) } }
    
    pack [LabelEntry $w.kd -helptext "    (01) - , (02) -  " \
            -label "               " \
            -textvariable SOTP(kd) -width 2] -anchor w
    $w.kd bind <Return>   "SotP:Ins $w"
    $w.kd bind <KP_Enter> "SotP:Ins $w"
    $w.kd bind <FocusIn> { if ![IsBe SOTP(kd)] { set SOTP(kd) "01" } }
    bind $w    <FocusIn>  "Sot:Activate:TF   $chaild"
    bind $w    <FocusOut> "Sot:DeActivate:TF $chaild"    

    #################################################################################

    pack [frame $w.f2] -anchor e
    foreach { i j k } { pdr_nam "   " 28
                        rn_nam  "   " 28
                        oklad   "           " 8 } {
        pack [LabelEntry $w.f2.$i -label $j -textvariable SOTP($i) -width $k \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    }
    pack [frame $w.f2.f1 -bd 0] -anchor w -fill x
    pack [frame $w.f2.f1.frb -bd 2 -relief groove] -side right -anchor s
    pack [button $w.f2.f1.frb.ins -text  -takefocus 0 -command "SotP:Ins $w" \
                 -state disabled] -padx 2 -pady 2
    DynamicHelp::register $w.f2.f1.frb.ins balloon "   "
    foreach { i j k } { tarif   "           " 8
                        kom     "    " 6 } {
        pack [LabelEntry $w.f2.f1.$i -label $j -textvariable SOTP($i) -width $k \
                -editable 0 -takefocus 0 -bg grey70] -anchor w
    }

    #################################################################################
    
    pack [frame $w.f3 -bd 2 -relief groove] -pady 5
    pack [ArrowButton $w.f3.ab1 -dir left -helptext "    " \
            -command "SotP:NextPrev - 1" -width 15 -height 25] -side left -pady 2 -padx 2
    pack [scale $w.f3.sc -length 200 -orient hor -width 7 \
            -command "SotP:NextPrev =" -variable SOTP(varscale)] -side left
    DynamicHelp::register $w.f3.sc balloon "      "
    set SOTP(window_scale) $w.f3.sc
    pack [ArrowButton $w.f3.ab2 -dir right -helptext "    " \
            -command "SotP:NextPrev + 1" -width 15 -height 25] -side right -pady 2 -padx 2
}

proc SotP:NextPrev { zn cn } {
    global SOTP SOTP_DATA SOT
    if { $zn == "=" } {
        set idx [expr $cn - 1]
    } else {
        set idx [expr $SOTP(varscale) $zn $cn - 1]
        set SOTP(varscale) [expr $idx + 1]
    }
    if { $idx >= 0 && $idx < [$SOTP(window_scale) cget -to] } {
        if [IsBe SOTP_DATA(cod)] {
            foreach i { cod dol1_nam } {
                set SOTP($i) [lindex $SOTP_DATA($i) $idx]
            }
        }
    }
}

proc SotP:He { w } {
    global SOTP
    set heret [He SOT $w -width 60 -find $SOTP(dol2_nam) -side top -anchor e \
                         -title " " -deltax 15 \
                         -labels {  31 . 5  8  8 . 8  31 " " 30} \
                         -query "select a.nam as dol_nam, a.kolv, a.oklad, a.tarif, \
                                        a.kom, b.nam as pdr_nam, c.nam as rn_nam, \
                                        a.cod as dol_cod, b.cod as pdr_cod \
                                     from dol a, strorg b, rn c \
                                     where a.pdr_cod = b.cod and \
                                           a.rn_cod = c.cod and \
                                           a.kolv > 0 and \
                                           \[Construct a.nam \${wdd}HE(find)\] \
                                     order by a.nam"]
    set SOTP(dol2_nam) [lindex $heret 0]
    set SOTP(oklad)   [lindex $heret 2]
    set SOTP(tarif)   [lindex $heret 3]
    set SOTP(kom)     [lindex $heret 4]
    set SOTP(pdr_nam) [lindex $heret 5]
    set SOTP(rn_nam)  [lindex $heret 6]
    set SOTP(dol2_cod) [lindex [lindex $heret 7] 0]
    set SOTP(pdr_cod) [lindex [lindex $heret 7] 1]
}

proc SotP:Editable { flg w } {
    global SOTP
    if [winfo exists $w] {
        set ad disabled
        if $flg { set ad normal }
        foreach i { f1.dol2 dt kd } {
            $w.$i configure -editable $flg
        }
        $w.f1.ab configure -state $ad
        $w.f2.f1.frb.ins configure -state $ad
        if $flg {
            set SOTP(flgbutton) 1
        } else {
            Unset SOTP(flgbutton)
        }
    }
}

