proc SotUnk:Get:YMPdrSot { wdd } {
    global ${wdd}SOTUNZK ${wdd}SOTUNK
    set m [GetMonthInt [lindex [subst $${wdd}SOTUNZK(head_tmonth_year)] 0]]
    set y [lindex [subst $${wdd}SOTUNZK(head_tmonth_year)] 1]
    if { [set idx [[subst $${wdd}SOTUNZK(pdrwindow)] getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex [subst $${wdd}SOTUNZK(lpdr_cod)] $idx]
    }
    if { [set idx [[subst $${wdd}SOTUNK(mclwindow)] curselection]] >= 0 } { 
        set sot_cod [lindex [[subst $${wdd}SOTUNK(mclwindow)] get $idx] 2]
    } else {
        set sot_cod -1
    }
    return "$y $m $pdr_cod $sot_cod"
}

proc SotUnk:UnSel { wdd } {
    global MAIN ${wdd}SOTUNK ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA
    global ${wdd}SOTUNZK SOTUNZK
    
    BeforeQuery SOTUNZK "    ... "

    Unset ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA
    
    set ${wdd}SOTUNK_DATA(-1,0) "/"
    set ${wdd}SOTUNK_DATA(-1,1)  ""
    set wtbl [subst $${wdd}SOTUNK(tblwindow)]
    
    Lindexes [SotUnk:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    
    set titrows [$wtbl cget -titlerows]
    set i 0
    set query "select a.cod as un_cod, a.nam as un_nam,
                      b.cod as sotunk_cod, b.summa
                   from un a left outer join sotunk as b on b.un_cod = a.cod and
                                 b.dat = '01.$m.$y' and
                                 b.sot_cod = $sot_cod
                   where a.vid in ('k','b')
                   order by a.tip desc, a.nam"
    
    dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}SOTUNK_DATA($i,un_cod)     $A(un_cod)
        set ${wdd}SOTUNK_DATA($i,0)          [cnvs $A(un_nam)]
        set ${wdd}SOTUNK_DATA($i,sotunk_cod) $A(sotunk_cod)
        set ${wdd}SOTUNK_DATA($i,1)          $A(summa)
        ProgressIncr SOTUNZK(progress) [incr i] 4
    }
    
    array set ${wdd}SOTUNK_OLDDATA [array get ${wdd}SOTUNK_DATA]
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [$wtbl cget -height]
    }
    TkTableRowTagErrorNull $wtbl
    AfterQuery SOTUNZK
}

proc SotUnk:Write { wdd row } {
    global ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA
    if [IsBe ${wdd}SOTUNK_DATA($row,sotunk_cod)] {
        if { [IsBe ${wdd}SOTUNK_DATA($row,1)] && [IsBe ${wdd}SOTUNK_OLDDATA($row,1)] &&
             [subst $${wdd}SOTUNK_DATA($row,1)] != [subst $${wdd}SOTUNK_OLDDATA($row,1)] } {
            SotUnk:Upd $wdd $row
        } elseif { ![IsBe ${wdd}SOTUNK_DATA($row,1)] && [IsBe ${wdd}SOTUNK_OLDDATA($row,1)] } {
            SotUnk:Del $wdd $row
        }
    } else {
        if [IsBe ${wdd}SOTUNK_DATA($row,1)] {
            SotUnk:Ins $wdd $row
        }
    }
}

proc SotUnk:Ins { wdd row } {
    global SOTUNZK ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA MAIN 
    global ${wdd}SOTUNK ${wdd}SOTUNZK
    
    set wtbl [subst $${wdd}SOTUNK(tblwindow)]
    Lindexes [SotUnk:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    if { [IsBe ${wdd}SOTUNK_DATA($row,un_cod)] && $sot_cod > 0 } {
        BeforeQuery SOTUNZK "   $row ... "
        set query "select sotunk_ins('$sot_cod','[subst $${wdd}SOTUNK_DATA($row,un_cod)]',
                                     '$y','$m','[subst $${wdd}SOTUNK_DATA($row,1)]') as cod"
        set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
            set ${wdd}SOTUNK_DATA($row,sotunk_cod) $A(cod)
            incr SOTUNZK(progress)
        }]
        if { $err == -1 } {
            $wtbl tag row Error $row
        } else {
            set ${wdd}SOTUNK_OLDDATA($row,sotunk_cod) [subst $${wdd}SOTUNK_DATA($row,sotunk_cod)]
            set ${wdd}SOTUNK_OLDDATA($row,1)          [subst $${wdd}SOTUNK_DATA($row,1)]
            $wtbl tag row [TkTableRowTagCmd $row] $row
        }
        AfterQuery SOTUNZK
    }
}

proc SotUnk:Upd { wdd row } {
    global SOTUNZK ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA MAIN 
    global ${wdd}SOTUNK ${wdd}SOTUNZK
    
    set wtbl [subst $${wdd}SOTUNK(tblwindow)]
    BeforeQuery SOTUNZK "   $row ... "
    set query "select sotunk_upd('[subst $${wdd}SOTUNK_DATA($row,sotunk_cod)]',
                                 '[subst $${wdd}SOTUNK_DATA($row,1)]') as cod"
    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
        incr SOTUNZK(progress)
    }]
    if { $err == -1 } {
        $wtbl tag row Error $row
    } else {
        set ${wdd}SOTUNK_OLDDATA($row,1) [subst $${wdd}SOTUNK_DATA($row,1)]
        $wtbl tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery SOTUNZK
}

proc SotUnk:Del { wdd row } {
    global SOTUNZK ${wdd}SOTUNK_DATA ${wdd}SOTUNK_OLDDATA MAIN 
    global ${wdd}SOTUNK ${wdd}SOTUNZK
    
    set wtbl [subst $${wdd}SOTUNK(tblwindow)]
    if ![IsBe row] { set row [$wtbl index active row] }

    if [IsBe ${wdd}SOTUNK_DATA($row,sotunk_cod)] {
        if ![MessageDlg $SOTUNZK(tpl).dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            
            BeforeQuery SOTUNZK "   $row ... "
            set query "select sotunk_del('[subst $${wdd}SOTUNK_DATA($row,sotunk_cod)]') as cod"
            set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
                incr SOTUNZK(progress)
            }]
            if { $err == -1 } {
                $wtbl tag row Error $row
            } else {
                set ${wdd}SOTUNK_DATA($row,1) ""
                Unset ${wdd}SOTUNK_DATA($row,sotunk_cod) ${wdd}SOTUNK_DATA($row,1)
                $wtbl tag row CurrentRow $row
            }
            AfterQuery SOTUNZK
        }
    }
}

proc SotUnk:Shablon { tpl wdd } {
    global ${wdd}SOTUNK MAIN SOTUNZK
    if ![MessageDlg $SOTUNZK(tpl).dlg -buttons { } -icon question -type user \
            -message "      ?" -default 0] {
        BeforeQuery SOTUNZK "     ... "
        set wmcl [subst $${wdd}SOTUNK(mclwindow)]
        Lindexes [SotUnk:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
        pg_exec $MAIN(iddbs) "begin work"
        set err 0
        for { set i 0 } { $i < [$wmcl index end] } { incr i } {
            set sot_cod [lindex [$wmcl get $i] 2]    
            foreach j [Shablonunk:Get $tpl] {
                Lindexes $j un_cod summa
                if { $summa > 0 } {
                    set query "select sotunk_shabins('$sot_cod', '$un_cod', '$y', 
                                                     '$m', '$summa') as cod"
                    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
                    }]
                    ProgressIncr SOTUNZK(progress) $i 20
                    if { $err == -1 } break
                } elseif { $summa == 0 } {
                    set query "select sotunk_shabdel('$sot_cod', '$un_cod', '$y', 
                                                     '$m') as cod"
                    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
                    }]
                    ProgressIncr SOTUNZK(progress) $i 20
                    if { $err == -1 } break
                    
                }
            }
            if { $err == -1 } break
        }
        if { $err != -1 } {
            pg_exec $MAIN(iddbs) "commit work"
        } else {
            pg_exec $MAIN(iddbs) "rollback work"
        }
        SotUnk:UnSel $wdd
        AfterQuery SOTUNZK
    }
}

proc SotUnk:Print { } {
    global MAIN SOTUNZK
    set wdd $SOTUNZK(wddk)
    global ${wdd}SOTUNZK ${wdd}SOTUNK
    Lindexes [SotUnk:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    set wmcl [subst $${wdd}SOTUNK(mclwindow)]
    foreach i [$wmcl column names] {
        if { [$wmcl column cget $i -foreground] == "magenta4" } { set sort $i }
    }
    if ![MessageDlg $SOTUNZK(tpl).dlg -buttons { } -icon question -type user -message "    \n [subst $${wdd}SOTUNZK(head_pdr_nam)] ?" -default 0] {
        BeforeQuery SOTUNZK "   ... "
        report start sotunk
        set i 0
        set query "select distinct a.tn, a.fio, e.nam as un_nam, d.summa
                       from sot a, sotdol b, dol c, sotunk d, un e
                       where a.cod = b.sot_cod and
                             b.dol_cod = c.cod and
                             c.pdr_cod = $pdr_cod and
                             a.cod = d.sot_cod and
                             d.un_cod = e.cod and
                             b.dt < '[GetFirstDayNextMonth $m $y]' and
                             ( b.du is null or b.du > '01.$m.$y' )
                       order by a.$sort"
        dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
            report output [subst $${wdd}SOTUNZK(head_tmonth_year)] \
                   [subst $${wdd}SOTUNZK(head_pdr_nam)] \
                   $A(tn) [cnvs $A(fio)] [cnvs $A(un_nam)] $A(summa)
            ProgressIncr SOTUNZK(progress) [incr i] 20
        }
        PrintDoc $SOTUNZK(tpl) " " [report stop]
        AfterQuery SOTUNZK
    }
}
