proc SotUnz:Get:YMPdrSot { wdd } {
    global ${wdd}SOTUNZK ${wdd}SOTUNZ
    set m [GetMonthInt [lindex [subst $${wdd}SOTUNZK(head_tmonth_year)] 0]]
    set y [lindex [subst $${wdd}SOTUNZK(head_tmonth_year)] 1]
    if { [set idx [[subst $${wdd}SOTUNZK(pdrwindow)] getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex [subst $${wdd}SOTUNZK(lpdr_cod)] $idx]
    }
    if { [set idx [[subst $${wdd}SOTUNZ(mclwindow)] curselection]] >= 0 } { 
        set sot_cod [lindex [[subst $${wdd}SOTUNZ(mclwindow)] get $idx] 2]
    } else {
        set sot_cod -1
    }
    return "$y $m $pdr_cod $sot_cod"
}

proc SotUnz:Init:SOTUNZ_DATA { wdd } {
    global ${wdd}SOTUNZ_DATA ${wdd}SOTUNZ
    Unset ${wdd}SOTUNZ_DATA
    set ${wdd}SOTUNZ_DATA(-2,0) "/"
    set ${wdd}SOTUNZ_DATA(-2,1) "+  - "
    eval destroy [ChildrenWindow [subst $${wdd}SOTUNZ(tblwindow)]]
}

proc SotUnz:UnSel { wdd } {
    global ${wdd}SOTUNZ_DATA SOTUNZK ${wdd}SOTUNZ MAIN
    SotUnz:Init:SOTUNZ_DATA $wdd
    
    set wtbl [subst $${wdd}SOTUNZ(tblwindow)]
    Lindexes [SotUnz:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    set titrows [$wtbl cget -titlerows]
    BeforeQuery SOTUNZK "   ... "
    set i 0
    if { $sot_cod > 0 } {
        set color1 [option get $wtbl rowOne Table]
        set color2 [option get $wtbl rowTwo Table]
        set query "select a.nam, a.cod as un_cod, b.un_cod as s_cod, a.tip, b.un_cod/b.un_cod as sort
                    from un a left outer join sotunz as b on a.cod = b.un_cod and
                              b.sot_cod = $sot_cod
                    where a.vid in  ( 'z', 's', 'p', 'n' )
                    order by sort, a.tip desc, a.nam"
        
        dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
            set ${wdd}SOTUNZ_DATA($i,un_cod) $A(un_cod)
            set ${wdd}SOTUNZ_DATA($i,tip)    $A(tip)
            set ${wdd}SOTUNZ_DATA($i,s_cod)  $A(s_cod)
            set ${wdd}SOTUNZ_DATA($i,0)      [cnvs $A(nam)]
            $wtbl configure -rows [expr $i + $titrows + 1]
            catch [destroy $wtbl.b$i]
            label $wtbl.b$i -image [SotUnz:ImgPlusMinus $A(s_cod) $A(tip)] -bd 0 \
                       -bg [SotUnz:Tbl:RowColor $color1 $color2 $i]
            bind $wtbl.b$i <1> "SotUnz:Tbl:Bind:Lbl $wdd $wtbl $i"
            $wtbl window configure $i,1 -window $wtbl.b$i -sticky wens
            ProgressIncr SOTUNZK(progress) [incr i] 20
        }
    }        
        
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [expr $i + $titrows]
    }
    AfterQuery SOTUNZK
}

proc SotUnz:Tbl:RowColor { color1 color2 row } {
    if { [expr $row % 2] == 0 } {
        return $color1
    }
    return $color2
}

proc SotUnz:Tbl:Bind:Lbl { wdd w row } {
    global ${wdd}SOTUNZ_DATA
    if ![IsBe ${wdd}SOTUNZ(WaitReturn)] {
        set ${wdd}SOTUNZ(WaitReturn) 1
        set oldrow [$w tag row CurrentRow]
        $w tag row CurrentRow $row
        $w.b$row configure -bg [option get $w currentBackground Table]
        $w activate $row,1
        if [IsBe oldrow] {
            if { $oldrow != $row } {
                $w tag row [TkTableRowTagCmd $oldrow] $oldrow
                $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
            }
        }
        if [IsBe ${wdd}SOTUNZ_DATA($row,s_cod)] {
            SotUnz:Del $wdd $w $row
        } else {
            SotUnz:Ins $wdd $w $row
        }
        set ${wdd}SOTUNZ(WaitReturn) {}
    }
}

proc SotUnz:Ins { wdd w row } {
    global ${wdd}SOTUNZ_DATA MAIN SOTUNZK
    Lindexes [SotUnz:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    BeforeQuery SOTUNZK "   ... "
    
    set query "select sotunz_ins('$sot_cod', '[subst $${wdd}SOTUNZ_DATA($row,un_cod)]') as cod"
    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}SOTUNZ_DATA($row,s_cod) [subst $${wdd}SOTUNZ_DATA($row,un_cod)]
        incr SOTUNZK(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [SotUnz:ImgPlusMinus 1 [subst $${wdd}SOTUNZ_DATA($row,tip)]]
        $w tag row CurrentRow $row
    }
    AfterQuery SOTUNZK
}

proc SotUnz:Del { wdd w row } {
    global ${wdd}SOTUNZ_DATA MAIN SOTUNZK
    Lindexes [SotUnz:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    BeforeQuery SOTUNZK "   ... "
    set query "select sotunz_del('$sot_cod', '[subst $${wdd}SOTUNZ_DATA($row,un_cod)]') as cod"
    
    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}SOTUNZ_DATA($row,s_cod) {}
        incr SOTUNZK(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [SotUnz:ImgPlusMinus 0 [subst $${wdd}SOTUNZ_DATA($row,tip)]]
        $w tag row CurrentRow $row
    }
    AfterQuery SOTUNZK
}

proc SotUnz:ImgPlusMinus { cod tip } {
    set img minus
    set clr R
    if { $cod > 0 }  { set img plus }
    if { $tip == 1 } { set clr G }
    return $img$clr
}

proc SotUnz:Shablon { tpl wdd } {
    global ${wdd}SOTUNZ MAIN SOTUNZK
    if ![MessageDlg $SOTUNZK(tpl).dlg -buttons { } -icon question -type user \
            -message "      ?" -default 0] {
        BeforeQuery SOTUNZK "     ... "
        set wmcl [subst $${wdd}SOTUNZ(mclwindow)]
        pg_exec $MAIN(iddbs) "begin work"
        set err 0
        for { set i 0 } { $i < [$wmcl index end] } { incr i } {
            set sot_cod [lindex [$wmcl get $i] 2]    
            foreach j [Shablonunz:Get $tpl] {
                Lindexes $j un_cod s_cod radio
                if [IsBe s_cod] {
                    set query "select sotunz_shabins($sot_cod, $un_cod) as cod"
                    set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {}]
                    ProgressIncr SOTUNZK(progress) $i 20
                    if { $err == -1 } break
                } else {
                    if $radio {
                        set query "select sotunz_shabdel($sot_cod, $un_cod) as cod"
                        set err [dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {}]
                        ProgressIncr SOTUNZK(progress) $i 20
                        if { $err == -1 } break
                    }
                    
                }
            }
            if { $err == -1 } break
        }
        if { $err != -1 } {
            pg_exec $MAIN(iddbs) "commit work"
        } else {
            pg_exec $MAIN(iddbs) "rollback work"
        }
        SotUnz:UnSel $wdd
        AfterQuery SOTUNZK
    }
}

proc SotUnz:Print { } {
    global MAIN SOTUNZK
    set wdd $SOTUNZK(wddz)
    global ${wdd}SOTUNZK ${wdd}SOTUNZ
    Lindexes [SotUnz:Get:YMPdrSot $wdd] y m pdr_cod sot_cod
    set wmcl [subst $${wdd}SOTUNZ(mclwindow)]
    foreach i [$wmcl column names] {
        if { [$wmcl column cget $i -foreground] == "magenta4" } { set sort $i }
    }
    if ![MessageDlg $SOTUNZK(tpl).dlg -buttons { } -icon question -type user -message "    \n [subst $${wdd}SOTUNZK(head_pdr_nam)] ?" -default 0] {
        BeforeQuery SOTUNZK "   ... "
        report start sotunz
        set i 0
        set query "select distinct a.tn, a.fio, e.nam as un_nam
                       from sot a, sotdol b, dol c, sotunz d, un e
                       where a.cod = b.sot_cod and
                             b.dol_cod = c.cod and
                             c.pdr_cod = $pdr_cod and
                             a.cod = d.sot_cod and
                             d.un_cod = e.cod and
                             b.dt < '[GetFirstDayNextMonth $m $y]' and
                             ( b.du is null or b.du > '01.$m.$y' )
                       order by a.$sort"
        dpg_select $SOTUNZK(tpl) $MAIN(iddbs) $query A {
            report output [subst $${wdd}SOTUNZK(head_pdr_nam)] \
                   $A(tn) [cnvs $A(fio)] [cnvs $A(un_nam)]
            ProgressIncr SOTUNZK(progress) [incr i] 20
        }
        PrintDoc $SOTUNZK(tpl) " " [report stop]
        AfterQuery SOTUNZK
    }
}
