proc Stat {} {
    global STAT STAT_DATA
    if [winfo exists .stat] { destroy .stat }
    Unset STAT
    toplevel .stat
    wm withdraw .stat
    wm title .stat ""

    LoadWhileCreateWindow .stat
    
    # MainFrame ####################################################################
    set mf [MainFrame .stat.mf -textvariable STAT(status) -progressvar STAT(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .stat STAT" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # MAIN ########################################################################
    
    pack [label $mff.l1 -text "  " \
        -font [option get $mff bigFont Frame] -fg black]
    
    pack [table $mff.tbl -width 2 -height 6 -cols 2 -rows 6 -relief flat \
        -browsecommand { Stat:Tbl:Browsecommand %W } \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable STAT_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -colorigin -1]
        
    TkTableInitTag $mff.tbl
    TkTableInitBind $mff.tbl
    
    $mff.tbl width -1 30  0 30
    $mff.tbl tag col TitleCol2 -1
    
    bind $mff.tbl <KeyPress-Down> {}
    DynamicHelp::register $mff.tbl balloon "     "
    set STAT(tblwindow) $mff.tbl
    
    bind .stat <Escape> "$tb.bb2 invoke 0"
    
    BWidget::place .stat 0 0 center
    wm deiconify .stat
    
    focus $mff.tbl
    
    Stat:Sel
    $mff.tbl activate 0,0
}

proc Stat:Tbl:Browsecommand { w } {
    global STAT STAT_DATA STAT_OLDDATA
    set active [$w index active]
    if ![IsBe STAT(oldactive)] { set STAT(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $STAT(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col
    
    # after un_nam
    if { $oldcol == 0 && [info exists STAT_DATA($oldrow,0)] } {
        if { ![info exists STAT_OLDDATA($oldrow,0)] ||
             $STAT_DATA($oldrow,0) != $STAT_OLDDATA($oldrow,0) } {
            set heret [He STAT $w -width 30 -find $STAT_DATA($oldrow,0) -side top \
                             -deltay [expr 18 + 17 * $oldrow] -anchor e \
                             -title " /" \
                             -query "select a.nam, a.cod from un a \
                                        where \[Construct a.nam \${wdd}HE(find)\] \
                                        order by a.nam"]
            set STAT_DATA($oldrow,0)      [lindex $heret 0]
            set STAT_DATA($oldrow,un_cod) [lindex $heret 1]
        }
    }

    set idxwrt [$w index $oldactive row]
    if { [$w index $active row] != $idxwrt } {
        Stat:Ins $w $idxwrt
    }
    
    if { [$w tag row Error] != $oldrow } {
        $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    }
    $w tag row CurrentRow $row
    set STAT(oldactive) $active
}

