proc Strorg {} {
    global STRORG
    if [winfo exists .strorg] { destroy .strorg }
    Unset STRORG
    set STRORG(gowork) Ins
    toplevel .strorg
    wm withdraw .strorg
    wm title .strorg " "

    LoadWhileCreateWindow .strorg
    
    # MainFrame ####################################################################
    set mf [MainFrame .strorg.mf -textvariable STRORG(status) -progressvar STRORG(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "" } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .strorg STRORG" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # PanedWindow ##################################################################
    packef [frame $mff.f]
    packef [PanedWindow $mff.f.pw]
    set pw1 [$mff.f.pw add -minsize 100]
    set pw2 [$mff.f.pw add -minsize 100 -weight 0]

    # MAIN #########################################################################
    packef [TitleFrame $pw1.main -text " "] -side left
    set main [$pw1.main getframe]
    pack [scrollbar $main.sby -command "$main.tr yview"] -side right -fill y
    pack [scrollbar $main.sbx -command "$main.tr xview" -orient hor] -side bottom -fill x
    packef [Tree $main.tr -yscrollcommand "$main.sby set" -xscrollcommand "$main.sbx set" \
        -height 12 -width 38 \
        -opencmd  "Strorg:Tree:Open  $main" \
        -closecmd "Strorg:Tree:Close $main" \
        -linesfill magenta3]
    DynamicHelp::register $main.tr balloon "   "
    
    bind $main    <FocusIn>  "Strorg:Activate:TF   $pw1.main"
    bind $main    <FocusOut> "Strorg:DeActivate:TF $pw1.main"
    bind $main.tr <1>        { focus %W }
    bind $main.tr <3>        { %W selection clear }
    bind $main.tr <Down>     "Strorg:Tree:UpDown $main +1"
    bind $main.tr <Up>       "Strorg:Tree:UpDown $main -1"
    bind $main.tr <Return>   { 
        if ![IsBe STRORG(WaitReturn)] {
            set STRORG(WaitReturn) 1
            set anode [%W selection get] 
            if [%W exists $anode] {
                if { [%W nodes $anode] == "" } {
                    %W opentree $anode
                } else {
                    %W closetree $anode
                }
            }
            set STRORG(WaitReturn) {}
        }
    }
    $main.tr bindText  <1>   [list Strorg:Import:Attr $main]
    $main.tr bindImage <1>   [list Strorg:Import:Attr $main]

    $tb.bb1 itemconfigure 0 -command "Strorg:Print $main"

    # ATTRIBUTE ####################################################################
    pack [TitleFrame $pw2.attr -text " "]
    set attr [$pw2.attr getframe]
    pack [LabelEntry $attr.nam -helptext "    " \
             -side top -label "  " -textvariable STRORG(nam) -width 30]
    
    $attr.nam bind  <Return>   "Strorg:Attr:Bind $main"
    bind $attr      <FocusIn>  "Strorg:Activate:TF $pw2.attr"
    bind $attr      <FocusOut> "Strorg:DeActivate:TF $pw2.attr"
    
    pack [frame $attr.fr -bd 2 -relief groove] -pady 2
    foreach { i j k } { Ins  F7   Upd  F6   Del  F8 } {
        pack [radiobutton $attr.fr.rb$i -value $i -variable STRORG(gowork) -takefocus 0 \
                          -width 0 -state disabled] -side left -pady 5
        bind $attr.fr.rb$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.rb$i balloon " $j,     <ENTER> "
        pack [button $attr.fr.b$i -text "$j" -takefocus 0 -command "Strorg:$i $main" \
                     -state disabled] -side left
        bind $attr.fr.b$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.b$i balloon " $j  <$k> "
        $attr.nam bind <$k> "Strorg:$i $main"
        
    }
    
    
    # CHAILD #######################################################################
    pack [TitleFrame $mff.chaild -text " "]
    set chaild [$mff.chaild getframe]
    
    Dol $mff.chaild $chaild

    bind .strorg <Escape> "$tb.bb2 invoke 0"
    bind .strorg <F4>     "$tb.bb1 invoke 0"
    
    BWidget::place .strorg 0 0 center
    wm deiconify .strorg
    
    Strorg:Sel0 $main
}

proc Strorg:Tree:UpDown { main ic } {
    set w $main.tr
    set anode [$w selection get]
    set lnode [Tree:AllNodes $w root]
    set idx [lsearch $lnode $anode]
    if { [incr idx $ic] < [llength $lnode] && 
        $idx >= 0 } {
        set node [lindex $lnode $idx]
        Strorg:Import:Attr $main $node
    }
}

proc Strorg:Tree:Open { w cod } {
    Strorg:SelL $w $cod
}

proc Strorg:Tree:Close { w cod } {
    $w.tr delete [$w.tr nodes $cod 0 end]
}

proc Strorg:Import:Attr { w cod } {
    global STRORG
    tonull STRORG(cod) STRORG(nam) STRORG(lvl)
    if [$w.tr exists $cod] {
        set nam [$w.tr itemcget $cod -text]
        set lvl [$w.tr itemcget $cod -data]
        foreach i { cod nam lvl } {
            set STRORG($i) [subst $$i]
        }
        $w.tr selection set $cod
        $w.tr see $cod
    }
    Dol:Sel
}

proc Strorg:Attr:Bind { w } {
    global STRORG
    Strorg:$STRORG(gowork) $w
}

proc Strorg:Activate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state normal
            }
        }
    }
}

proc Strorg:DeActivate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}
