proc Pdr:Sel { var } {
    global MAIN
    upvar $var vr
    
    BeforeQuery vr "   ... "
    set vr(lpdr_nam) ""
    set vr(lpdr_cod) ""
    set query "select distinct c.cod, c.nam \
                   from sotdol a, dol b, strorg c \
                   where a.dol_cod = b.cod and \
                         b.pdr_cod = c.cod \
                   order by c.nam"
    
    set i 0
    pg_select $MAIN(iddbs) $query A {
        lappend vr(lpdr_nam) [cnvs $A(nam)]
        lappend vr(lpdr_cod) $A(cod)
        if { $i == 0 } {
            set vr(head_pdr_nam) [cnvs $A(nam)]
        }
        ProgressIncr vr(progress) [incr i] 2
    }
    AfterQuery vr
}

proc Strorg:Sel0 { main } {
    global MAIN STRORG
    set w $main.tr
    BeforeQuery STRORG "   ... "
    tonull STRORG(cod) STRORG(nam) STRORG(lvl)
    
    set i 0
    set query "select * from strorg a \
                   where a.lvl = 1 \
                   order by a.nam"
    dpg_select .strorg $MAIN(iddbs) $query A {
        if { $i == 0 } { set acod $A(cod) }
        $w insert end root $A(cod) -text [cnvs $A(nam)] -drawcross allways \
            -image [Bitmap::get openfold] -data $A(lvl)
        ProgressIncr STRORG(progress) [incr i] 3
    }
    if [IsBe acod] { Strorg:Import:Attr $main $acod }
    AfterQuery STRORG
    focus $w
}

proc Strorg:SelL { main strorg_cod } {
    global MAIN STRORG
    set w $main.tr
    BeforeQuery STRORG "   ... "
    $w delete [$w nodes $strorg_cod 0 end]
    set lvl [$w itemcget $strorg_cod -data]
    
    set fl 0
    set i 0
    set query "select * from strorg a 
                  where a.cod in (select b.s_cod from strorglink b \
                                      where b.m_cod = $strorg_cod ) and \
                        a.lvl = [expr $lvl + 1] \
                  order by a.nam"
    dpg_select .strorg $MAIN(iddbs) $query A {
        $w insert end $strorg_cod $A(cod) -text [cnvs $A(nam)] -drawcross allways \
            -image [Bitmap::get openfold] -data $A(lvl)
        set fl 1
        ProgressIncr STRORG(progress) [incr i] 3
    }
    if { $fl == 0 } { $w itemconfigure $strorg_cod -drawcross never }
    AfterQuery STRORG
}

proc Strorg:Ins { main } {
    global MAIN STRORG
    set w $main.tr
    if [IsBe STRORG(nam)] {
        set pnode [$w selection get]
        if { $pnode == "" } { set pnode root }
        BeforeQuery STRORG "   ... "
        set strorg_cod 0
        if { $pnode != "root" } { set strorg_cod $STRORG(cod) }
        
        set query "select strorg_ins('$strorg_cod','[cnvi $STRORG(nam)]') as lst"
        dpg_select .strorg $MAIN(iddbs) $query A {
            set cod [lindex $A(lst) 0]
            set lvl [lindex $A(lst) 1]
            $w insert end $pnode $cod -text $STRORG(nam) -drawcross never \
                -image [Bitmap::get openfold] -data $lvl
            if { $pnode != "root" } {
                $w itemconfigure $pnode -drawcross allways
                $w opentree $pnode
            }
            $w see $cod
            incr STRORG(progress)
        }
        AfterQuery STRORG
    }
}

proc Strorg:Upd { main } {
    global MAIN STRORG
    set w $main.tr
    if [IsBe STRORG(cod)] {
        if ![MessageDlg .strorg.dlg -buttons { } -icon question -type user -message " ?\n\"$STRORG(nam)\"" -default 0] {
            BeforeQuery STRORG "   ... "        
            set query "select strorg_upd('$STRORG(cod)','[cnvi $STRORG(nam)]')"
            dpg_select .strorg $MAIN(iddbs) $query A {
                $w itemconfigure $STRORG(cod) -text $STRORG(nam)
                incr STRORG(progress)
            }
            AfterQuery STRORG
        }
    }
}

proc Strorg:Del { main } {
    global MAIN STRORG
    set w $main.tr
    if [IsBe STRORG(cod)] {
        if ![MessageDlg .strorg.dlg -buttons { } -icon question -type user -message " ?\n\"$STRORG(nam)\"" -default 0] {
            BeforeQuery STRORG "   ... "        
            set query "select strorg_del('$STRORG(cod)')"
            dpg_select .strorg $MAIN(iddbs) $query A {
                set lnode [Tree:AllNodes $w root]
                set oldidx [lsearch $lnode $STRORG(cod)]
                $w delete [$w nodes $STRORG(cod)] $STRORG(cod)
                set lnode [Tree:AllNodes $w root]
                set llng [expr [llength $lnode] - 1]
                if { $oldidx >  $llng } { set oldidx $llng }
                incr STRORG(progress)
                Strorg:Import:Attr $main [lindex $lnode $oldidx]
            }
            AfterQuery STRORG
        }
    }
}

proc Strorg:Print { main } {
    global MAIN STRORG
    if ![MessageDlg .strorg.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        BeforeQuery STRORG "   ... "
        set w $main.tr
        
        report start strorg
        set pnode [$w selection get]
        if { $pnode == "" } { 
            set query "select strorgtree('0 {} 0') as lsttree"
        } else {
            set query "select strorgtree('$STRORG(cod) {} $STRORG(lvl)') as lsttree"
        }
        set i 0
        set lstpdr {}
        
        dpg_select .strorg $MAIN(iddbs) "select distinct pdr_cod from dol" A {    
            lappend lstpdr $A(pdr_cod)
            ProgressIncr STRORG(progress) [incr i] 4
        }
        
        dpg_select .strorg $MAIN(iddbs) $query A {    
            set lsttree [cnvs $A(lsttree)]
            ProgressIncr STRORG(progress) [incr i] 4
        }
        
        set flg1 0
        set flg2 0
        foreach el $lsttree {
            Lindexes $el cod nam lvl
            if { $lvl == 1 } { 
                set flg1 1 
            } else {
                set flg1 0
            }
            set sp ""
            for { set j 1 } { $j < $lvl } { incr j } { set sp "$sp    " }
            report output $flg1 $flg2 $sp$nam
            if { [lsearch -exact $lstpdr $cod] >= 0 } {
                set flg2 1
                set query "select a.nam as dolnam, b.nam as rnnam, a.kold, a.kolv, \
                                  a.oklad, a.tarif, a.kom \
                               from dol a, rn b \
                               where a.rn_cod = b.cod and a.pdr_cod = $cod"
                dpg_select .strorg $MAIN(iddbs) $query A {
                    report output $flg1 $flg2 $sp$nam [cnvs $A(dolnam)] [cnvs $A(rnnam)] $A(kold) $A(kolv) $A(oklad) $A(tarif) $A(kom)
                    ProgressIncr STRORG(progress) [incr i] 10
                }
                set flg2 0
            }
            ProgressIncr STRORG(progress) [incr i] 4
        }
        
        PrintDoc .strorg " " [report stop]
        AfterQuery STRORG
    }
}
