proc Tabel {} {
    global TABEL TABELSOT_DATA TABELUN_DATA MAIN
    Unset TABEL
    if [winfo exists .tabel] { destroy .tabel }
    toplevel .tabel
    wm withdraw .tabel
    wm title .tabel ""

    LoadWhileCreateWindow .tabel

    # MainFrame ####################################################################
    set mf [MainFrame .tabel.mf -textvariable TABEL(status) \
            -progressvar TABEL(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" "" } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command Tabel:Print
    }
    pack [Separator $tb.sep1 -orient vertical] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .tabel TABEL" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # Head #########################################################################

    pack [frame $mff.head]
    
    Pdr:Sel TABEL
    set TABEL(head_tmonth_year) $MAIN(tmonthyear)

    pack [set hf0 [frame $mff.head.f0]] -side right -fill y
    pack [set hf0_1 [frame $hf0.f1 -bd 2 -relief groove]]
    pack [Button $hf0_1.b -text "" -command Tabel:AutoCreate \
        -takefocus 0 \
        -helptext "     \n    \n      "] -padx 2 -pady 2
    pack [Separator $mff.head.sep -orient vertical] -side right -fill y -padx 5
    
    pack [set hf1 [frame $mff.head.f1]]
    pack [label $hf1.l1 -text  -font [option get $hf1 bigFont Frame] \
        -fg black] -side left
    pack [ComboBox $hf1.monthyear -editable 0 -label "  " -width 13 -height 13 \
        -values [YearAmongMonth $TABEL(head_tmonth_year)] -modifycmd Tabel:Sel \
        -textvariable TABEL(head_tmonth_year) \
        -helptext "   "] -side left
    pack [ComboBox $hf1.pdr -editable 0 -label "   " -width 30 \
        -values $TABEL(lpdr_nam) -modifycmd Tabel:Sel \
        -textvariable TABEL(head_pdr_nam) \
        -helptext "   "] -side left

    set TABEL(monthyearwindow) $hf1.monthyear
    set TABEL(pdrwindow)       $hf1.pdr

    pack [set hf2 [frame $mff.head.f2]]
    pack [label $hf2.l1      -text "  "] -side left
    pack [label $hf2.fio     -textvar TABEL(head_fio) -width 50 -relief sunken \
        -anchor w -fg black] -side left
    pack [label $hf2.l2      -text "  .N "] -side left
    pack [label $hf2.tn      -textvar TABEL(head_tn) -width 5 -relief sunken \
        -anchor e -fg black] -side left
    
    pack [set hf3 [frame $mff.head.f3]]
    pack [label $hf3.l1      -text " "] -side left
    pack [label $hf3.dol_nam -textvar TABEL(head_dol_nam) -width 30 -relief sunken \
        -anchor w -fg black] -side left
    pack [label $hf3.l2      -text "   "] -side left
    pack [label $hf3.dt      -textvar TABEL(head_dt) -width 10 -relief sunken \
        -anchor w -fg black] -side left
    pack [label $hf3.l3      -text "   "] -side left
    pack [label $hf3.du      -textvar TABEL(head_du) -width 10 -relief sunken \
        -anchor w -fg red2] -side left
    #pack [label $hf3.l3      -text " "] -side left

    pack [set hf4 [frame $mff.head.f4 -bd 2 -relief groove]]
    pack [set hf4_1 [frame $hf4.f1]]
    pack [label $hf4_1.l1      -text "  "] -side left
    pack [label $hf4_1.oklad -textvar TABEL(head_oklad) -width 8 -relief sunken \
        -anchor e -fg gold4 -bg grey90] -side left
    pack [label $hf4_1.l2      -text "  "] -side left
    pack [label $hf4_1.tarif   -textvar TABEL(head_tarif) -width 7 -relief sunken \
        -anchor e -fg gold4 -bg grey90] -side left
    pack [label $hf4_1.l3      -text "  "] -side left
    pack [label $hf4_1.kom     -textvar TABEL(head_kom) -width 5 -relief sunken \
        -anchor e -fg gold4 -bg grey90] -side left
    pack [label $hf4_1.l4      -text "%"] -side left
    
    pack [set hf4_2 [frame $hf4.f2]]
    pack [label $hf4_2.l1      -text "   "] -side left
    pack [label $hf4_2.d       -textvar TABEL(head_d) -width 5 -relief sunken \
        -anchor e -fg magenta4 -bg grey93] -side left
    pack [label $hf4_2.l2      -text "  "] -side left
    pack [label $hf4_2.h       -textvar TABEL(head_h) -width 6 -relief sunken \
        -anchor e -fg magenta4 -bg grey93] -side left
    pack [label $hf4_2.l3      -text "   "] -side left
    pack [label $hf4_2.rn_nam  -textvar TABEL(head_rn_nam) -width 30 -relief sunken \
        -anchor w -fg black] -side left

    # Main ########################################################################
    
    pack [set main [frame $mff.main -bd 1 -relief sunken]] -anchor sw  -pady 2 -padx 3
    pack [scrollbar $main.sby -command "$main.tblun yview"] -side right -fill y
    pack [scrollbar $main.sbx -command "$main.tblun xview" -orient hor] \
        -side bottom -fill x
    pack [table $main.tblsot -height 19 -rows 19 -width 1 -cols 1 -relief flat \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable TABELSOT_DATA \
        -titlerows 3 -state disabled \
        -highlightthickness 0 \
        -roworigin -3] -side left
    
    TkTableInitTag $main.tblsot
    $main.tblsot spans -3,0 3,1
    $main.tblsot width 0 13
    $main.tblsot tag col TitleCol2 0
    bindtags $main.tblsot nothing
    
    pack [table $main.tblun -height 19 -rows 19 -width 9 -cols 9 -relief flat \
        -yscrollcommand "Tabel:TblUn:ScrollY $main.tblsot $main.tblun $main.sby" \
        -xscrollcommand "$main.sbx set" \
        -browsecommand " Tabel:Tbl:Browsecommand $main.tblun " \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable TABELUN_DATA \
        -titlerows 3 \
        -highlightthickness 0 \
        -roworigin -3 ] -side left
    TkTableInitTag $main.tblun
    TkTableInitBind $main.tblun

    $main.tblun width 0 6  1 11  2 9  3 6  4 11  5 9  6 6  7 11  8 9
    $main.tblun spans -3,0 1,2  -3,3 1,2  -3,6 1,2
    
    set TABEL(tblsotwindow) $main.tblsot
    set TABEL(tblunwindow)  $main.tblun
    
    bind $main.tblun <KeyPress-Down>       {}
    
    bind $main.tblun <3> {
        set row [%W index @%x,%y row]
        set col [%W index @%x,%y col]
        if { [expr $col %% 3] == 2 && [IsBe TABELSOT_DATA($row,sot_cod)] } {
            %W activate $row,[expr $col - 1]
            set TABELUN_DATA($row,[expr $col - 2]) $TABEL(head_d)
            set TABELUN_DATA($row,[expr $col - 1]) $TABEL(head_h)
            %W activate $row,$col
        }
    }
    bind $main.tblun <F8>      "Tabel:Del {} {}"
    bind $main.tblun <FocusIn> {
        [winfo parent %W] configure -bg blue4
    }
    bind $main.tblun <FocusOut> {
        [winfo parent %W] configure -bg grey85
    }
    bind $main.tblun <KeyRelease-Return>   { Tabel:Bind:Tbl:KeyRE %W }
    bind $main.tblun <KeyRelease-KP_Enter> { Tabel:Bind:Tbl:KeyRE %W }
    bind $main.tblun <Double-Button-3> {
        set row  [%W index active row]
        set col  [%W index active col]
        set idx2 [lindex [TkTableAmongCellsRow $row $col 3] 2]
        if { "$row,$col" == "$idx2" } { Tabel:Write $row $col }
    }
    
    DynamicHelp::register $main.tbl balloon "     "

    bind .tabel <Escape> "$tb.bb2 invoke 0"
    bind .tabel <F4>     "$tb.bb1 invoke 0"
    
    BWidget::place .tabel 0 0 center
    wm deiconify .tabel

    focus $main.tblun
    Tabel:Sel
}

proc Tabel:Bind:Tbl:KeyRE { w } {
    regsub -all "\n|\r" [$w curvalue] "" str
    catch    [$w set active $str]
    set row  [$w index active row]
    set col  [$w index active col]
    set idx0 [lindex [TkTableAmongCellsRow $row $col 3] 0]
    set idx1 [lindex [TkTableAmongCellsRow $row $col 3] 1]
    set idx2 [lindex [TkTableAmongCellsRow $row $col 3] 2]
    if { "$row,$col" == "$idx2" } {
        Tabel:Write $row $col
        event generate $w <KeyPress-Left>
        event generate $w <KeyPress-Left>
        event generate $w <KeyPress-Down>
    } else {
        event generate $w <KeyPress-Right>
    }
}

proc Tabel:TblUn:ScrollY { wtblsot wtblun wsby args } {
    eval $wsby set $args
    $wtblsot yview [$wtblun index topleft row]
}

proc Tabel:Tbl:Browsecommand { w } {
    global TABEL TABELUN_DATA TABELSOT_DATA
    set active [$w index active]
    if ![IsBe TABEL(oldactive)] { set TABEL(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $TABEL(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col

    Tabel:Visual:Head $row

    # after tarif
    if { [expr $oldcol % 3] == 1 && [expr $col % 3] == 2 } {
        if { [IsBe TABELSOT_DATA($row,sot_cod)] &&
             [IsBe TABELUN_DATA(un_cod,$col)] && 
             ![IsBe TABELUN_DATA($row,$col)] && 
             [IsBe TABELUN_DATA($row,[expr $col - 2])] &&
             [IsBe TABELUN_DATA($row,[expr $col - 1])] } {
            set TABELUN_DATA($row,$col) [Tabel:Raschet $TABELUN_DATA(un_cod,$col) \
                                            $TABELSOT_DATA($row,oklad) \
                                            $TABELSOT_DATA($row,tarif) \
                                            $TABELSOT_DATA($row,kom) \
                                            $TABELSOT_DATA($row,d) \
                                            $TABELSOT_DATA($row,h) \
                                            $TABELUN_DATA($row,[expr $col - 2]) \
                                            $TABELUN_DATA($row,[expr $col - 1])]
        }
    }
    
    $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    $TABEL(tblsotwindow) tag row [TkTableRowTagCmd $oldrow] $oldrow
    $w tag row CurrentRow $row
    $TABEL(tblsotwindow) tag row CurrentRow $row
    
    #   
    if { [$w tag cell Error] == "" } {
        eval $w tag cell null [$w tag cell CurrentCells]
        eval $w tag cell CurrentCells [TkTableAmongCellsRow $row $col 3]
    }
    set TABEL(oldactive) $active
}

proc Tabel:Visual:Head { row } {
    global TABEL TABELSOT_DATA
    set lfield "fio tn dol_nam dt du oklad tarif kom d h rn_nam"
    foreach i $lfield { set TABEL(head_$i) "" }
    if [IsBe TABELSOT_DATA($row,sot_cod)] {
        foreach i $lfield { set TABEL(head_$i) $TABELSOT_DATA($row,$i) }
    } else {
        foreach i $lfield { set TABEL(head_$i) "" }
    }
}
