proc Tabel:Sel {} {
    global TABEL MAIN TABELSOT_DATA TABELUN_DATA TABELUN_OLDDATA
    
    Unset TABELSOT_DATA TABELUN_DATA TABELUN_OLDDATA
    
    if { [set idx [$TABEL(pdrwindow) getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex $TABEL(lpdr_cod) $idx]
    }
    
    set m [GetMonthInt [lindex $TABEL(head_tmonth_year) 0]]
    set y [lindex $TABEL(head_tmonth_year) 1]

    set w1 $TABEL(tblsotwindow)
    set w2 $TABEL(tblunwindow)
    set TABELSOT_DATA(-3,0) "\n\n"
    BeforeQuery TABEL "    ... "
    set i 0
    set TABEL(query) "select a.cod as sot_cod, a.tn, a.fio,
                      b.cod as un_cod, b.nam as un_nam,
                      c.dol_cod, d.nam as dol_nam, c.dt, c.du,
                      d.oklad, d.tarif, d.kom,
                      f.d, f.h, e.nam as rn_nam,
                      g.d as dtabel, g.h as htabel, g.summa, g.cod as tabel_cod
                   from sot a join un as b on b.tip = 1 and
                                   b.vid = 't'
                              join sotdol as c on a.cod = c.sot_cod and
                                   c.dt < '[GetFirstDayNextMonth $m $y]' and
                                   ( c.du is null or c.du > '01.$m.$y' )
                              join dol as d on c.dol_cod = d.cod and
                                   d.pdr_cod = $pdr_cod
                              join rn  as e on d.rn_cod = e.cod
                              join cal as f on f.rn_cod = e.cod and
                                   f.dat = '01.$m.$y'
                              left outer join tabel as g on g.sot_cod = a.cod and
                                   g.un_cod = b.cod and
                                   g.dol_cod = c.dol_cod and
                                   g.dat = '01.$m.$y'
                   order by a.fio, c.dol_cod, c.dt, b.nam"
    
    set oldsot_cod -1
    set olddol_cod -1
    set cntnach 0
    set cntsot 0
    dpg_select .rn $MAIN(iddbs) $TABEL(query) A {
        if { $oldsot_cod == $A(sot_cod) && $olddol_cod == $A(dol_cod)} { 
            incr cntnach 
        } else {
            #  
            foreach x { sot_cod tn dol_cod dt du oklad tarif kom d h } {
                set TABELSOT_DATA($cntsot,$x) $A($x)
            }
            foreach y { fio dol_nam rn_nam } {
                set TABELSOT_DATA($cntsot,$y) [cnvs $A($y)]
            }
            set TABELSOT_DATA($cntsot,0)       [cnvs $A(fio)]
            
            set cntnach 0
            incr cntsot
        }
        #  ..
        set TABELUN_DATA(-3,[expr $cntnach * 3]) [cnvs $A(un_nam)]
        for { set z [expr $cntnach * 3] } { $z < [expr $cntnach * 3 + 3] } { incr z } {
            set TABELUN_DATA(un_cod,$z) $A(un_cod)
            set TABELUN_DATA(-3,$z)     [cnvs $A(un_nam)]
            set cs [expr $cntsot - 1]
            set TABELUN_DATA($cs,$z,tabel_cod) $A(tabel_cod)
            if { [expr $z % 3] == 0 } { set TABELUN_DATA($cs,$z) $A(dtabel) }
            if { [expr $z % 3] == 1 } { set TABELUN_DATA($cs,$z) $A(htabel) }
            if { [expr $z % 3] == 2 } { set TABELUN_DATA($cs,$z) $A(summa) }
        }
        ProgressIncr TABEL(progress) [incr i] 20
        
        set oldsot_cod $A(sot_cod)
        set olddol_cod $A(dol_cod)
    }

    #    tktable
    set lstcolsnum "0 1 2"
    set lstcolslng "6 11 9"
    set widthcfg {}
    set lcurrspans {}
    set allcols {}
    set lhead1 {  }
    set lhead2 {  }
    for { set i 0 } { $i <= $cntnach } { incr i } {
        set currcols "[lmath_incr $lstcolsnum [expr 3 * $i]] "
        append allcols " $currcols"
        foreach j $currcols {
            if [IsBe TABELUN_DATA(un_cod,$j)] {
                if { [Stat:Get $TABELUN_DATA(un_cod,$j)] == 2 } {
                    set TABELUN_DATA(-1,$j) [lindex $lhead2 [expr $j % 3]]
                } else {
                    set TABELUN_DATA(-1,$j) [lindex $lhead1 [expr $j % 3]]
                }
            }
        }
        append widthcfg "  [list_merge $currcols $lstcolslng]"
        #regsub -all -- "\[0-9]* " $currcols "-2,& 1,0 " currspans
        append lcurrspans " -3,[expr 3 * $i] 1,2"    
    }
    set cols [expr [llength $widthcfg] / 2]
    
    set titrows [$w1 cget -titlerows]
    if { $cntsot > [expr [$w1 cget -height] - $titrows] } {
        set rows [expr $cntsot + $titrows]
    } else {
        set rows [$w1 cget -height]
    }
    $w1 configure -rows $rows
    $w2 configure -rows $rows
    if { $cols > 9 } {
        $w2 configure -cols $cols
        eval $w2 width $widthcfg
        eval $w2 spans $lcurrspans
    }
    eval $w2 tag col AnchorE $allcols
    
    array set TABELUN_OLDDATA [array get TABELUN_DATA]
    $TABEL(monthyearwindow) configure -values [YearAmongMonth $TABEL(head_tmonth_year)]
    Tabel:Visual:Head [$w2 index active row]
    TkTableCellTagErrorNull $w2
    AfterQuery TABEL
    
}

proc Tabel:Raschet { un_cod oklad tarif kom dnorma hnorma dtabel htabel } {
    set summa 0
    switch -exact -- [Stat:Get $un_cod] {
        #   
        0 {
            set summa [expr $htabel * $oklad / $hnorma]
        }
        #   
        1 {
            set summa [expr $htabel * $tarif]
        }
        # 
        2 {
            set summa [expr $htabel * $kom / 100]
        }
        default {
            if { $tarif != 0 } {
                set summa [expr $htabel * $tarif]
            }
            if { $oklad != 0 } {
                set summa [expr $htabel * $oklad / $hnorma]
            }
        }
    }
    Lindexes [Un:GetFormula $un_cod $summa] c1 c2 c3 c4
    return [format "%.2f" [expr ($summa - $c1) * $c4 / 100 + $c3]]
}

proc Tabel:Write { row col } {
    global TABELUN_DATA TABELUN_OLDDATA TABELSOT_DATA
    
    set cold [expr $col - 2]
    set colh [expr $col - 1]

    if { [IsBe TABELSOT_DATA($row,sot_cod)] && [IsBe TABELUN_DATA(un_cod,$col)] && 
         [IsBe TABELUN_DATA($row,$cold)]    && [IsBe TABELUN_DATA($row,$colh)] && 
         [IsBe TABELUN_DATA($row,$col)] } {
        if ![IsBe TABELUN_DATA($row,$col,tabel_cod)] {
            Tabel:Ins $row $cold $colh $col
        } else {
            if { $TABELUN_DATA($row,$cold) != $TABELUN_OLDDATA($row,$cold) ||
                 $TABELUN_DATA($row,$colh) != $TABELUN_OLDDATA($row,$colh) ||
                 $TABELUN_DATA($row,$col)  != $TABELUN_OLDDATA($row,$col) } {
                Tabel:Upd $row $cold $colh $col
            }
        }
    } elseif { [IsBe TABELSOT_DATA($row,sot_cod)] && [IsBe TABELUN_DATA(un_cod,$col)] && 
               ![IsBe TABELUN_DATA($row,$cold)] && [IsBe TABELUN_OLDDATA($row,$cold)] &&
               ![IsBe TABELUN_DATA($row,$colh)] && [IsBe TABELUN_OLDDATA($row,$colh)] &&
               ![IsBe TABELUN_DATA($row,$col)]  && [IsBe TABELUN_OLDDATA($row,$col)] } {
        Tabel:Del $row $col
    }
}

proc Tabel:Ins { row cold colh col } {
    global TABEL TABELUN_DATA TABELUN_OLDDATA TABELSOT_DATA MAIN
    set w $TABEL(tblunwindow)

    set m [GetMonthInt [lindex $TABEL(head_tmonth_year) 0]]
    set y [lindex $TABEL(head_tmonth_year) 1]    
    
    BeforeQuery TABEL "   $row ... "
    set query "select tabel_ins($TABELSOT_DATA($row,sot_cod),
                                $TABELSOT_DATA($row,dol_cod),
                                $TABELUN_DATA(un_cod,$col),
                                $y, $m,
                                $TABELUN_DATA($row,$cold),
                                $TABELUN_DATA($row,$colh),
                                $TABELUN_DATA($row,$col)
                               ) as cod"
    set err [dpg_select .tabel $MAIN(iddbs) $query A {
        set TABELUN_DATA($row,$cold,tabel_cod) $A(cod)
        set TABELUN_DATA($row,$colh,tabel_cod) $A(cod)
        set TABELUN_DATA($row,$col,tabel_cod)  $A(cod)
        incr TABEL(progress)
    }]
    if { $err == -1 } {
        eval $w tag cell Error $row,$cold $row,$colh $row,$col
    } else {
        foreach j "$cold $colh $col" {
            set TABELUN_OLDDATA($row,$j)           $TABELUN_DATA($row,$j)
            set TABELUN_OLDDATA($row,$j,tabel_cod) $TABELUN_DATA($row,$j,tabel_cod)
        }
        eval $w tag cell null [$w tag cell Error]
    }
    AfterQuery TABEL
}

proc Tabel:Upd { row cold colh col } {
    global TABEL TABELUN_DATA TABELUN_OLDDATA TABELSOT_DATA MAIN
    set w $TABEL(tblunwindow)

    if ![MessageDlg .tabel.dlg -buttons { } -icon question -type user -message "  \n $TABELUN_DATA(-3,$col) \n  $TABELSOT_DATA($row,0) ?" -default 0] {
        BeforeQuery TABEL "   $row ... "
        set query "select tabel_upd($TABELUN_DATA($row,$col,tabel_cod),
                                    $TABELUN_DATA($row,$cold),
                                    $TABELUN_DATA($row,$colh),
                                    $TABELUN_DATA($row,$col)
                                   ) as cod"
        set err [dpg_select .tabel $MAIN(iddbs) $query A {
            incr TABEL(progress)
        }]
        if { $err == -1 } {
            eval $w tag cell Error $row,$cold $row,$colh $row,$col
        } else {
            foreach j "$cold $colh $col" {
                set TABELUN_OLDDATA($row,$j)           $TABELUN_DATA($row,$j)
            }
            eval $w tag cell null [$w tag cell Error]
        }
        AfterQuery TABEL
    }
}

proc Tabel:Del { row col } {
    global TABELUN_DATA TABEL TABELUN_OLDDATA MAIN TABELSOT_DATA
    set w $TABEL(tblunwindow)
    if ![IsBe row] { set row [$w index active row] }
    if ![IsBe col] { set col [$w index active col] }

    if [IsBe TABELUN_DATA($row,$col,tabel_cod)] {
        if ![MessageDlg .tabel.dlg -buttons { } -icon question -type user -message " \n $TABELUN_DATA(-3,$col) \n  $TABELSOT_DATA($row,0) ?" -default 0] {
            BeforeQuery TABEL "  ... "
            set query "select tabel_del($TABELUN_DATA($row,$col,tabel_cod))"
            set err [dpg_select .strorg $MAIN(iddbs) $query A {
                incr TABEL(progress)
            }]
            if { $err == -1 } {
                eval $w tag cell Error [TkTableAmongCellsRow $row $col 3]
            } else {
                eval $w tag cell null [$w tag cell Error]
                foreach i [TkTableAmongCellsRow $row $col 3] {
                    set TABELUN_DATA($i) ""
                    Unset TABELUN_DATA($i) TABELUN_OLDDATA($i) 
                    Unset TABELUN_DATA($i,tabel_cod) TABELUN_OLDDATA($i,tabel_cod)
                }
            }
            AfterQuery TABEL
        }
    }
}

proc Tabel:Print { } {
    global MAIN TABEL
    if ![MessageDlg .tabel.dlg -buttons { } -icon question -type user -message "    \n $TABEL(head_pdr_nam) ?" -default 0] {
        BeforeQuery TABEL "   ... "
        report start tabel
        set i 0
        dpg_select .tabel $MAIN(iddbs) $TABEL(query) A {
            if { $A(summa) > 0 } {
                set du $A(du)
                if { $du != "" } { set du " $A(du)" }
                report output $TABEL(head_tmonth_year) $TABEL(head_pdr_nam) \
                            [cnvs $A(fio)]   [cnvs $A(dol_nam)] \
                            $A(oklad)         $A(tarif)          $A(kom) \
                            $A(d)             $A(h)        [cnvs $A(un_nam)] \
                            $A(dtabel)        $A(htabel)         $A(summa) \
                            $A(dt)            $du
                ProgressIncr TABEL(progress) [incr i] 20
            }
        }
        PrintDoc .tabel "" [report stop]
        AfterQuery TABEL
    }
}

proc Tabel:AutoCreate {} {
    global TABEL MAIN
    if ![MessageDlg .tabel.dlg -buttons { } -icon question -type user \
        -message "     \n $TABEL(head_pdr_nam) \n  $TABEL(head_tmonth_year)  \n      ? " -default 0] {
        BeforeQuery TABEL "    ... "
        set i 0
        set m [GetMonthInt [lindex $TABEL(head_tmonth_year) 0]]
        set y [lindex $TABEL(head_tmonth_year) 1]
        
        pg_exec $MAIN(iddbs) "begin work"
        
        dpg_select .tabel $MAIN(iddbs) $TABEL(query) A {
            set c0 [Stat:Get $A(un_cod)]
            set c1 [Stat:Get $A(un_cod)]
            #    
            if { $c0 == 0 && $A(oklad) > 0 } {
                set summa [Tabel:Raschet $A(un_cod) $A(oklad) $A(tarif) \
                                         $A(kom)    $A(d)     $A(h) \
                                         $A(d)      $A(h)]
                # 
                set query "select tabel_auto('$A(tabel_cod)', $A(sot_cod), $A(dol_cod), 
                                             $A(un_cod),  $y,    $m,  $A(d),
                                             $A(h),       $summa) as cod"
                set err [dpg_select .tabel $MAIN(iddbs) $query B {
                    ProgressIncr TABEL(progress) [incr i] 10
                }]
                if { $err == -1 } break
            }
            #   
            if { $c1 == 1 && $A(tarif) > 0 } {
                set summa [Tabel:Raschet $A(un_cod) $A(oklad) $A(tarif) \
                                         $A(kom)    $A(d)     $A(h) \
                                         $A(d)      $A(h)]
                # 
                set query "select tabel_auto('$A(tabel_cod)', $A(sot_cod), $A(dol_cod), 
                                             $A(un_cod),  $y,   $m,   $A(d),
                                             $A(h),       $summa) as cod"
                set err [dpg_select .tabel $MAIN(iddbs) $query C {
                    ProgressIncr TABEL(progress) [incr i] 10
                }]
                if { $err == -1 } break
            }
        }
        
        if { $err != -1 } {
            pg_exec $MAIN(iddbs) "commit work"
        } else {
            pg_exec $MAIN(iddbs) "rollback work"
        }
        Tabel:Sel
    }
}
