proc Un { tip } {
    global UN
    if [winfo exists .un] { destroy .un }
    Unset UN
    set UN(tip) $tip
    set UN(tipnam) [Case UN(tip) -1 1  ]
    
    toplevel .un
    wm withdraw .un
    wm title .un "${UN(tipnam)}"

    LoadWhileCreateWindow .un
    
    # MainFrame ####################################################################
    set mf [MainFrame .un.mf -textvariable UN(status) -progressvar UN(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" Un:Print } {
        $tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    pack [Separator $tb.sep1 -orient vertical -relief groove] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .un UN" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # NoteBook #####################################################################
    pack [NoteBook $mff.nb] -expand yes -fill both
    foreach { i j } [Case UN(tip) -1 1 " podoh  zavis  konkr  barter  vidac " \
                        " tabel  zavis  konkr  period  stag"] {
        $mff.nb insert end $j -text $i
        Un:Un [$mff.nb getframe $j] [Case i       \
                                              n z k b v t p s]
    }
    $mff.nb compute_size
    $mff.nb raise [Case UN(tip) -1 1 podoh tabel]
    bind .un <Escape>   "$tb.bb2 invoke 0"
    bind .un <F4>       "$tb.bb1 invoke 0"
    
    BWidget::place .un 0 0 center
    wm deiconify .un
}

proc Un:Un { w vid } {
    set wdd [DelDot $w]
    global UN ${wdd}UN
    Unset ${wdd}UN
    set UN(vid) $vid
    set ${wdd}UN(gowork) Ins

    # PanedWindow ##################################################################
    packef [PanedWindow $w.pw]
    set pw1 [$w.pw add -minsize 100]
    set pw2 [$w.pw add -minsize 100 -weight 0]

    # MAIN #########################################################################
    packef [TitleFrame $pw1.main -text " ${UN(tipnam)}"]
    set main [$pw1.main getframe]
    pack [scrollbar $main.sby -command "$main.mcl yview"] -side right -fill y
    packef [mclistbox $main.mcl -width 30 -height 25 -yscrollcommand "$main.sby set"]
    $main.mcl column add nam -label " ${UN(tipnam)}" -width 30
    $main.mcl column add cod -visible no
    $main.mcl column add kod -visible no
    
    bind $main.mcl  <ButtonRelease-1> "focus $main.mcl; Un:Import:Attr $w $wdd $main.mcl $vid"
    bind $main.mcl  <KeyRelease-Up>   "Un:Import:Attr $w $wdd $main.mcl $vid"
    bind $main.mcl  <KeyRelease-Down> "Un:Import:Attr $w $wdd $main.mcl $vid"
    bind $main      <FocusIn>         "Un:Activate:TF $pw1.main; set ${wdd}UN(lastfocus) $main.mcl"
    bind $main      <FocusOut>        "Un:DeActivate:TF $pw1.main"

    lappend UN(mainmcl_lst) $main.mcl
    lappend UN(wdd_lst) $wdd
    lappend UN(vid_lst) $vid

    # ATTRIBUTE ####################################################################
    TitleFrame $pw2.attr -text " ${UN(tipnam)}"
    pack $pw2.attr -side top
    set attr [$pw2.attr getframe]
    pack [LabelEntry $attr.nam -helptext "   ${UN(tipnam)} " \
            -label "  " -textvariable ${wdd}UN(nam) -width 30] -anchor w
    bind $attr      <FocusIn>   "Un:Activate:TF $pw2.attr; set ${wdd}UN(lastfocus) $attr.nam"
    bind $attr      <FocusOut>  "Un:DeActivate:TF $pw2.attr"
    
    if { $UN(tip) == -1 && [VarIn vid n k v] } {
        $attr.nam bind  <Return> { focus [Widget::focusNext %W] }
        
        set lelbl " "
        set lehlp "    \n <> -     \n 03 -   \n 04 -  \n 05 -   \n 06 -   \n 07 -    \n 08 -    ... \n 09 -     "
        if { [VarIn vid n k] } {
            set lelbl " "
            set lehlp "       \n 01 -    \n 02 -    \n 03 -    \n 04 - 15   \n 05 - 50%   \n ... "
        }
        pack [LabelEntry $attr.kod -helptext $lehlp -label "   $lelbl " \
            -textvariable ${wdd}UN(kod) -width 2] -anchor w
        $attr.kod bind  <Return>    "Un:Attr:Bind $w $wdd $main.mcl $vid; focus $attr.nam"
        bind $attr      <FocusIn>   "Un:Activate:TF $pw2.attr; set ${wdd}UN(lastfocus) $attr.kod"
        bind $attr      <FocusOut>  "Un:DeActivate:TF $pw2.attr"
    } else {
        $attr.nam bind  <Return>    "Un:Attr:Bind $w $wdd $main.mcl $vid"
    }
    
    set ${wdd}UN(find) [Construct a.nam ${wdd}UN(nam)]
    
    pack [frame $attr.fr -bd 2 -relief groove] -pady 2
    foreach { i j k } { Ins  F7   Upd  F6   Del  F8  Find  F5 } {
        pack [radiobutton $attr.fr.rb$i -value $i -variable ${wdd}UN(gowork) -takefocus 0 \
                          -width 0 -state disabled] -side left -pady 5
        bind $attr.fr.rb$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.rb$i balloon " $j,     <ENTER> "
        pack [button $attr.fr.b$i -text "$j" -takefocus 0 -command "Un:$i $w $wdd $main.mcl $vid" \
                     -state disabled] -side left
        bind $attr.fr.b$i <1> "focus $attr.nam"
        DynamicHelp::register $attr.fr.b$i balloon " $j ${UN(tipnam)} <$k> "
        if [winfo exists $attr.kod] {
            $attr.kod bind <$k> "Un:$i $w $wdd $main.mcl $vid"
        }
        $attr.nam bind <$k> "Un:$i $w $wdd $main.mcl $vid"
    }
    
    # Chaild #####################################################################
    TitleFrame $pw2.chaild -text ""
    if ![VarIn vid k b] {
        pack $pw2.chaild -side bottom
    }
    set chaild [$pw2.chaild getframe]
        
    pack [NoteBook $chaild.nb]
    set ${wdd}UN(notebook) $chaild.nb
    foreach { i j } {  Unr  Unz } {
        $chaild.nb insert end $j -text $i
        set wfrm [$chaild.nb getframe $j]
        $j $pw2.chaild $wdd $wfrm $vid
        set UN(wdd_${wdd}$j) [DelDot $wfrm]
    }
    if [VarIn vid t v] { $chaild.nb delete Unz }
    $chaild.nb bindtabs <1> "Un:Un:NoteBook:Tabs $chaild.nb $wdd $vid"
    $chaild.nb compute_size
    $chaild.nb raise Unr
    
    ##############################################################################
    
    bind $main.mcl <Return>  "focus $attr.nam"
    bind $w        <Map>     "Un:Sel $w $main.mcl $vid"
}

proc Un:Un:NoteBook:Tabs { w wdd vid page } {
    global ${wdd}UN UN
    $page:Sel $wdd $UN(wdd_${wdd}$page) $vid
}

proc Un:Import:Attr { w wdd mcl vid } {
    global ${wdd}UN UN
    tonull ${wdd}UN(nam) ${wdd}UN(cod) ${wdd}UN(kod)
    if { [set idx [$mcl curselection]] >= 0 } { 
        $mcl activate $idx
        set ${wdd}UN(nam) [lindex [$mcl get $idx] 0]
        set ${wdd}UN(cod) [lindex [$mcl get $idx] 1]
        set ${wdd}UN(kod) [lindex [$mcl get $idx] 2]
    }
    set raisenb [[subst $${wdd}UN(notebook)] raise]
    $raisenb:Sel $wdd $UN(wdd_${wdd}$raisenb) $vid
}

proc Un:Attr:Bind { w wdd mcl vid } {
    global ${wdd}UN
    Un:[subst $${wdd}UN(gowork)] $w $wdd $mcl $vid
}

proc Un:Activate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w activeBackground TitleFrame] -relief ridge
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state normal
            }
        }
    }
}

proc Un:DeActivate:TF { w } {
    if [winfo exists $w] {
        $w configure -fg [option get $w deactiveBackground TitleFrame] -relief groove
        foreach i [ChildrenWindow $w] {
            if { [set wcl [winfo class $i]] == "Button" || $wcl == "Radiobutton" } {
                $i configure -state disabled
            }
        }
    }
}
