proc Un:HeSel { tip vid var } {
    global MAIN
    upvar $var vr
    
    BeforeQuery vr "   ... "
    set vr(lun_nam) ""
    set vr(lun_cod) ""
    set query "select distinct a.cod, a.nam \
                   from un a \
                   where a.tip = $tip and \
                         a.vid = '$vid' \
                   order by a.nam"
    
    set i 0
    pg_select $MAIN(iddbs) $query A {
        lappend vr(lun_nam) [cnvs $A(nam)]
        lappend vr(lun_cod) $A(cod)
        if { $i == 0 } {
            set vr(head_un_nam) [cnvs $A(nam)]
        }
        ProgressIncr vr(progress) [incr i] 2
    }
    AfterQuery vr
}

proc Un:Sel { w mcl vid } {
    set wdd [DelDot $w]
    global UN MAIN ${wdd}UN
    BeforeQuery UN "   ... "
    $mcl delete 0 end
    tonull ${wdd}UN(cod) ${wdd}UN(nam)
    set i 0
    
    set query "select a.cod, a.nam, a.kod
                  from un a \
                  where [cnvi [subst $${wdd}UN(find)]] and \
                        a.tip = '$UN(tip)' and \
                        a.vid = '$vid'
                  order by a.nam"
    
    dpg_select .un $MAIN(iddbs) $query A {
        $mcl insert end [list [cnvs $A(nam)] $A(cod) $A(kod)]
        ProgressIncr UN(progress) [incr i] 20
    } 
    
    AfterQuery UN
    SelectionActivateSee $mcl 0
    Un:Import:Attr $w $wdd $mcl $vid
    if [info exists ${wdd}UN(lastfocus)] {
        focus [subst $${wdd}UN(lastfocus)]
    } else {
        focus $mcl
    }
}

proc Un:Ins { w wdd mcl vid } {
    set wdd [DelDot $w]
    global UN MAIN ${wdd}UN
    if [IsBe ${wdd}UN(nam)] {
        BeforeQuery UN "   ... "
        set query "select un_ins('[cnvi [subst $${wdd}UN(nam)]]',
                                 '[subst $${wdd}UN(kod)]',
                                 '$UN(tip)',
                                 '$vid') as cod"
        dpg_select .un $MAIN(iddbs) $query A {
            $mcl insert end [list [subst $${wdd}UN(nam)] $A(cod) [subst $${wdd}UN(kod)]]
            incr UN(progress)
            SelectionActivateSee $mcl end
            Un:Import:Attr $w $wdd $mcl $vid
        }
        AfterQuery UN
    }
}

proc Un:Del { w wdd mcl vid } {
    set wdd [DelDot $w]
    global UN MAIN ${wdd}UN
    if [IsBe ${wdd}UN(cod)] {
        if ![MessageDlg .un.dlg -buttons { } -icon question -type user -message " ?\n\"[subst $${wdd}UN(nam)]\"" -default 0] {
            BeforeQuery UN "   ... "
            set query "select un_del('[subst $${wdd}UN(cod)]') as cod"
            set idx [$mcl index active]
            dpg_select .un $MAIN(iddbs) $query A {
                $mcl delete $idx $idx
                incr UN(progress)
                SelectionActivateSee $mcl active
                Un:Import:Attr $w $wdd $mcl $vid
            }
            AfterQuery UN
        }
    }
}

proc Un:Upd { w wdd mcl vid } {
    set wdd [DelDot $w]
    global UN MAIN ${wdd}UN
    if ![MessageDlg .un.dlg -buttons { } -icon question -type user -message " ?\n\"[subst $${wdd}UN(nam)]\"" -default 0] {
        BeforeQuery UN "   ... "
        set query "select un_upd('[subst $${wdd}UN(cod)]',
                                 '[cnvi [subst $${wdd}UN(nam)]]',
                                 '[subst $${wdd}UN(kod)]') as cod"
        set idx [$mcl index active]
        dpg_select .un $MAIN(iddbs) $query A {
            $mcl delete $idx $idx
            $mcl insert $idx [list [subst $${wdd}UN(nam)] [subst $${wdd}UN(cod)] [subst $${wdd}UN(kod)]]
            incr UN(progress)
            SelectionActivateSee $mcl $idx
        }
        AfterQuery UN
    }
}

proc Un:Find { w wdd mcl vid } {
    set wdd [DelDot $w]
    global ${wdd}UN
    if ![MessageDlg .un.dlg -buttons { } -icon question -type user \
        -message "  \n\"[subst $${wdd}UN(nam)]\" ?" -default 0] {
        set ${wdd}UN(find) [Construct a.nam ${wdd}UN(nam)]
        Un:Sel $w $mcl $vid
    }
}

proc Un:Print {} {
    global UN
    if ![MessageDlg .un.dlg -buttons { } -icon question -type user -message "  ?" -default 0] {
        set idx 0
        foreach i $UN(mainmcl_lst) {
            if [winfo ismapped $i] break
            incr idx
        }
        set wdd [lindex $UN(wdd_lst) $idx]
        set vid [lindex $UN(vid_lst) $idx]
        global MAIN ${wdd}UN
        BeforeQuery UN "   ... "
        set namr "[Case vid t z k p v     ] \
                  [Case UN(tip) -1 1  ]"
        report start unr
        set query "select a.nam, b.c1, b.c2, b.c3, b.c4 \
                      from un a left outer join unr as b on a.cod = b.un_cod \
                      where [cnvi [subst $${wdd}UN(find)]] and \
                            a.tip = '$UN(tip)' and \
                            a.vid = '$vid'
                      order by a.nam"
        set i 0
        dpg_select .un $MAIN(iddbs) $query A {    
            if { $A(c1) == "" } { set A(c1) 0 }
            if { $A(c2) == "" } { set A(c2) 0 }
            if { $A(c3) == "" } { set A(c3) 0 }
            if { $A(c4) == "" } { set A(c4) 0 }
            report output $namr [cnvs $A(nam)] $A(c1) $A(c2) $A(c3) $A(c4)
            ProgressIncr UN(progress) [incr i] 10
        }
        set lst [report stop]
        
        report start unz
        set query "select a.nam as nam1, c.nam as nam2 \
                      from un a, unz b, un c \
                      where [cnvi [subst $${wdd}UN(find)]] and \
                            a.tip = '$UN(tip)' and \
                            a.vid = '$vid' and \
                            a.cod = b.m_cod and \
                            b.s_cod = c.cod \
                      order by a.nam"
        set i 0
        dpg_select .un $MAIN(iddbs) $query A {    
            report output $namr [cnvs $A(nam1)] [cnvs $A(nam2)]
            ProgressIncr UN(progress) [incr i] 10
        }
        PrintDoc .un " $namr" "$lst [report stop]"
        AfterQuery UN
    }
}

proc Un:GetFormula { un_cod summa } {
    global MAIN
    set c3 0
    set c4 0
    set query "select distinct c1, c2, c3, c4 from unr \
                   where un_cod = $un_cod and \
                         c1::numeric <  ${summa}::numeric and
                         c2::numeric >= ${summa}::numeric"
                   
    dpg_select .un $MAIN(iddbs) $query A {    
        set c1 $A(c1)
        set c2 $A(c2)
        set c3 $A(c3)
        set c4 $A(c4)
    }
    if ![IsBe c1] { set c1 0 }
    if ![IsBe c2] { set c2 0 }
    if ![IsBe c3] { set c3 0 }
    if ![IsBe c4] { set c4 0 }
    return "$c1 $c2 $c3 $c4"
}
