proc UnSotk:Get:YMPdrUn { wdd } {
    global ${wdd}UNSOTZK ${wdd}UNSOTK
    set m [GetMonthInt [lindex [subst $${wdd}UNSOTZK(head_tmonth_year)] 0]]
    set y [lindex [subst $${wdd}UNSOTZK(head_tmonth_year)] 1]
    if { [set idx [[subst $${wdd}UNSOTZK(pdrwindow)] getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex [subst $${wdd}UNSOTZK(lpdr_cod)] $idx]
    }
    if { [set idx [[subst $${wdd}UNSOTK(mclwindow)] curselection]] >= 0 } { 
        set un_cod [lindex [[subst $${wdd}UNSOTK(mclwindow)] get $idx] 1]
        set un_tip [lindex [[subst $${wdd}UNSOTK(mclwindow)] get $idx] 2]
    } else {
        set un_cod -1
        set un_tip -1
    }
    return "$y $m $pdr_cod $un_cod $un_tip"
}

proc UnSotk:SotSel { wdd } {
    global MAIN ${wdd}UNSOTK ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA
    global ${wdd}UNSOTZK UNSOTZK
    
    BeforeQuery UNSOTZK "    ... "

    Unset ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA
    
    set ${wdd}UNSOTK_DATA(-1,0) ""
    set ${wdd}UNSOTK_DATA(-1,1)  ""
    set wtbl [subst $${wdd}UNSOTK(tblwindow)]
    
    Lindexes [UnSotk:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip 
    
    set titrows [$wtbl cget -titlerows]
    set i 0
    set query "select distinct a.cod as sot_cod, a.fio as fio, d.cod as sotunk_cod,
                              d.summa
                   from sot a join sotdol as b on a.cod = sot_cod and
                                   b.dt < '[GetFirstDayNextMonth $m $y]' and
                                   ( b.du is null or b.du > '01.$m.$y' )
                              join dol as c on b.dol_cod = c.cod and
                                   c.pdr_cod = $pdr_cod
                              left outer join sotunk as d on a.cod = d.sot_cod and
                                   d.dat = '01.$m.$y' and
                                   d.un_cod = $un_cod
                   order by a.fio"
    
    dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}UNSOTK_DATA($i,sot_cod)    $A(sot_cod)
        set ${wdd}UNSOTK_DATA($i,0)          [cnvs $A(fio)]
        set ${wdd}UNSOTK_DATA($i,sotunk_cod) $A(sotunk_cod)
        set ${wdd}UNSOTK_DATA($i,1)          $A(summa)
        ProgressIncr UNSOTZK(progress) [incr i] 4
    }
    
    array set ${wdd}UNSOTK_OLDDATA [array get ${wdd}UNSOTK_DATA]
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [$wtbl cget -height]
    }
    TkTableRowTagErrorNull $wtbl
    AfterQuery UNSOTZK
}

proc UnSotk:Write { wdd row } {
    global ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA
    if [IsBe ${wdd}UNSOTK_DATA($row,sotunk_cod)] {
        if { [IsBe ${wdd}UNSOTK_DATA($row,1)] && [IsBe ${wdd}UNSOTK_OLDDATA($row,1)] &&
             [subst $${wdd}UNSOTK_DATA($row,1)] != [subst $${wdd}UNSOTK_OLDDATA($row,1)] } {
            UnSotk:Upd $wdd $row
        } elseif { ![IsBe ${wdd}UNSOTK_DATA($row,1)] && [IsBe ${wdd}UNSOTK_OLDDATA($row,1)] } {
            UnSotk:Del $wdd $row
        }
    } else {
        if [IsBe ${wdd}UNSOTK_DATA($row,1)] {
            UnSotk:Ins $wdd $row
        }
    }
}

proc UnSotk:Ins { wdd row } {
    global UNSOTZK ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA MAIN 
    global ${wdd}UNSOTK ${wdd}UNSOTZK
    
    set wtbl [subst $${wdd}UNSOTK(tblwindow)]
    Lindexes [UnSotk:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    if { [IsBe ${wdd}UNSOTK_DATA($row,sot_cod)] && $un_cod > 0 } {
        BeforeQuery UNSOTZK "   $row ... "
        set query "select sotunk_ins([subst $${wdd}UNSOTK_DATA($row,sot_cod)],
                                     $un_cod,
                                     '$y','$m','[subst $${wdd}UNSOTK_DATA($row,1)]') as cod"
        set err [dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
            set ${wdd}UNSOTK_DATA($row,sotunk_cod) $A(cod)
            incr UNSOTZK(progress)
        }]
        if { $err == -1 } {
            $wtbl tag row Error $row
        } else {
            set ${wdd}UNSOTK_OLDDATA($row,sotunk_cod) [subst $${wdd}UNSOTK_DATA($row,sotunk_cod)]
            set ${wdd}UNSOTK_OLDDATA($row,1)          [subst $${wdd}UNSOTK_DATA($row,1)]
            $wtbl tag row [TkTableRowTagCmd $row] $row
        }
        AfterQuery UNSOTZK
    }
}

proc UnSotk:Upd { wdd row } {
    global UNSOTZK ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA MAIN 
    global ${wdd}UNSOTK ${wdd}UNSOTZK
    
    set wtbl [subst $${wdd}UNSOTK(tblwindow)]
    BeforeQuery UNSOTZK "   $row ... "
    set query "select sotunk_upd('[subst $${wdd}UNSOTK_DATA($row,sotunk_cod)]',
                                 '[subst $${wdd}UNSOTK_DATA($row,1)]') as cod"
    set err [dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
        incr UNSOTZK(progress)
    }]
    if { $err == -1 } {
        $wtbl tag row Error $row
    } else {
        set ${wdd}UNSOTK_OLDDATA($row,1) [subst $${wdd}UNSOTK_DATA($row,1)]
        $wtbl tag row [TkTableRowTagCmd $row] $row
    }
    AfterQuery UNSOTZK
}

proc UnSotk:Del { wdd row } {
    global UNSOTZK ${wdd}UNSOTK_DATA ${wdd}UNSOTK_OLDDATA MAIN 
    global ${wdd}UNSOTK ${wdd}UNSOTZK
    
    set wtbl [subst $${wdd}UNSOTK(tblwindow)]
    if ![IsBe row] { set row [$wtbl index active row] }

    if [IsBe ${wdd}UNSOTK_DATA($row,sotunk_cod)] {
        if ![MessageDlg $UNSOTZK(tpl).dlg -buttons { } -icon question -type user -message "  $row ?" -default 0] {
            BeforeQuery UNSOTZK "   $row ... "
            set query "select sotunk_del('[subst $${wdd}UNSOTK_DATA($row,sotunk_cod)]') as cod"
            set err [dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
                incr UNSOTZK(progress)
            }]
            if { $err == -1 } {
                $wtbl tag row Error $row
            } else {
                set ${wdd}UNSOTK_DATA($row,1) ""
                Unset ${wdd}UNSOTK_DATA($row,sotunk_cod) ${wdd}UNSOTK_DATA($row,1)
                $wtbl tag row CurrentRow $row
            }
            AfterQuery UNSOTZK
        }
    }
}

proc UnSotk:Print { } {
    global MAIN UNSOTZK
    set wdd $UNSOTZK(wddk)
    global ${wdd}UNSOTZK ${wdd}UNSOTK
    Lindexes [UnSotk:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    if ![MessageDlg $UNSOTZK(tpl).dlg -buttons { } -icon question -type user -message "    \n [subst $${wdd}UNSOTZK(head_pdr_nam)] ?" -default 0] {
        BeforeQuery UNSOTZK "   ... "
        report start unsotk
        set i 0
        set query "select distinct a.tn, a.fio, e.nam as un_nam, d.summa
                       from sot a, sotdol b, dol c, sotunk d, un e
                       where a.cod = b.sot_cod and
                             b.dol_cod = c.cod and
                             c.pdr_cod = $pdr_cod and
                             a.cod = d.sot_cod and
                             d.un_cod = e.cod and
                             b.dt < '[GetFirstDayNextMonth $m $y]' and
                             ( b.du is null or b.du > '01.$m.$y' )
                       order by e.nam, a.fio"
        dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
            report output [subst $${wdd}UNSOTZK(head_tmonth_year)] \
                   [subst $${wdd}UNSOTZK(head_pdr_nam)] \
                   [cnvs $A(un_nam)] $A(tn) [cnvs $A(fio)]  $A(summa)
            ProgressIncr UNSOTZK(progress) [incr i] 20
        }
        PrintDoc $UNSOTZK(tpl) " " [report stop]
        AfterQuery UNSOTZK
    }
}
