proc UnSotz:Get:YMPdrUn { wdd } {
    global ${wdd}UNSOTZK ${wdd}UNSOTZ
    set m [GetMonthInt [lindex [subst $${wdd}UNSOTZK(head_tmonth_year)] 0]]
    set y [lindex [subst $${wdd}UNSOTZK(head_tmonth_year)] 1]
    if { [set idx [[subst $${wdd}UNSOTZK(pdrwindow)] getvalue]] == -1 } {
        set pdr_cod -1
    } else {
        set pdr_cod [lindex [subst $${wdd}UNSOTZK(lpdr_cod)] $idx]
    }
    if { [set idx [[subst $${wdd}UNSOTZ(mclwindow)] curselection]] >= 0 } { 
        set un_cod [lindex [[subst $${wdd}UNSOTZ(mclwindow)] get $idx] 1]
        set un_tip [lindex [[subst $${wdd}UNSOTZ(mclwindow)] get $idx] 2]
    } else {
        set un_cod -1
        set un_tip -1
    }
    return "$y $m $pdr_cod $un_cod $un_tip"
}

proc UnSotz:Init:UNSOTZ_DATA { wdd } {
    global ${wdd}UNSOTZ_DATA ${wdd}UNSOTZ
    Unset ${wdd}UNSOTZ_DATA
    set ${wdd}UNSOTZ_DATA(-2,0) ""
    set ${wdd}UNSOTZ_DATA(-2,1) "+  - "
    for { set i 0 } { $i <= [[subst $${wdd}UNSOTZ(tblwindow)] index end row] } { incr i } {
        destroy [subst $${wdd}UNSOTZ(tblwindow)].b$i
    }
}

proc UnSotz:SotSel { wdd } {
    global ${wdd}UNSOTZ_DATA UNSOTZK ${wdd}UNSOTZ MAIN
    UnSotz:Init:UNSOTZ_DATA $wdd
    
    set wtbl [subst $${wdd}UNSOTZ(tblwindow)]
    Lindexes [UnSotz:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    set titrows [$wtbl cget -titlerows]
    BeforeQuery UNSOTZK "   ... "
    set i 0
    if { $un_cod > 0 } {
        set color1 [option get $wtbl rowOne Table]
        set color2 [option get $wtbl rowTwo Table]
        
        set query "select distinct a.cod as sot_cod, a.fio as fio, d.sot_cod as s_cod,
                              d.sot_cod/d.sot_cod as sort
                   from sot a join sotdol as b on a.cod = sot_cod and
                                   b.dt < '[GetFirstDayNextMonth $m $y]' and
                                   ( b.du is null or b.du > '01.$m.$y' )
                              join dol as c on b.dol_cod = c.cod and
                                   c.pdr_cod = $pdr_cod
                              left outer join sotunz as d on a.cod = d.sot_cod and
                                   d.un_cod = $un_cod
                   order by sort, a.fio"
        
        dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
            set ${wdd}UNSOTZ_DATA($i,sot_cod) $A(sot_cod)
            set ${wdd}UNSOTZ_DATA($i,s_cod)   $A(s_cod)
            set ${wdd}UNSOTZ_DATA($i,0)       [cnvs $A(fio)]
            $wtbl configure -rows [expr $i + $titrows + 1]
            catch [destroy $wtbl.b$i]
            label $wtbl.b$i -image [UnSotz:ImgPlusMinus $A(s_cod) $un_tip] -bd 0 \
                       -bg [UnSotz:Tbl:RowColor $color1 $color2 $i]
            bind $wtbl.b$i <1> "UnSotz:Tbl:Bind:Lbl $wdd $wtbl $i"
            $wtbl window configure $i,1 -window $wtbl.b$i -sticky wens
            ProgressIncr UNSOTZK(progress) [incr i] 20
        }
    }        
        
    if { $i > [expr [$wtbl cget -rows] - $titrows] } {
        $wtbl configure -rows [expr $i + $titrows]
    } else {
        $wtbl configure -rows [expr $i + $titrows]
    }
    AfterQuery UNSOTZK
}

proc UnSotz:Tbl:RowColor { color1 color2 row } {
    if { [expr $row % 2] == 0 } {
        return $color1
    }
    return $color2
}

proc UnSotz:Tbl:Bind:Lbl { wdd w row } {
    global ${wdd}UNSOTZ_DATA
    if ![IsBe ${wdd}UNSOTZ(WaitReturn)] {
        set ${wdd}UNSOTZ(WaitReturn) 1
        set oldrow [$w tag row CurrentRow]
        $w tag row CurrentRow $row
        $w.b$row configure -bg [option get $w currentBackground Table]
        $w activate $row,1
        if [IsBe oldrow] {
            if { $oldrow != $row } {
                $w tag row [TkTableRowTagCmd $oldrow] $oldrow
                $w.b$oldrow configure -bg [option get $w [TkTableRowTagCmd $oldrow] Table]
            }
        }
        if [IsBe ${wdd}UNSOTZ_DATA($row,s_cod)] {
            UnSotz:Del $wdd $w $row
        } else {
            UnSotz:Ins $wdd $w $row
        }
        set ${wdd}UNSOTZ(WaitReturn) {}
    }
}

proc UnSotz:Ins { wdd w row } {
    global ${wdd}UNSOTZ_DATA MAIN UNSOTZK
    Lindexes [UnSotz:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    BeforeQuery UNSOTZK "   ... "
    
    set query "select sotunz_ins([subst $${wdd}UNSOTZ_DATA($row,sot_cod)],$un_cod) as cod"
    set err [dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}UNSOTZ_DATA($row,s_cod) [subst $${wdd}UNSOTZ_DATA($row,sot_cod)]
        incr UNSOTZK(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [UnSotz:ImgPlusMinus 1 $un_tip]
        $w tag row CurrentRow $row
    }
    AfterQuery UNSOTZK
}

proc UnSotz:Del { wdd w row } {
    global ${wdd}UNSOTZ_DATA MAIN UNSOTZK
    Lindexes [UnSotz:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    BeforeQuery UNSOTZK "   ... "
    
    set query "select sotunz_del([subst $${wdd}UNSOTZ_DATA($row,sot_cod)], $un_cod) as cod"
    set err [dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
        set ${wdd}UNSOTZ_DATA($row,s_cod) {}
        incr UNSOTZK(progress)
    }]
    
    if { $err == -1 } {
        $w tag row Error $row
    } else {
        $w.b$row configure -image [UnSotz:ImgPlusMinus 0 $un_tip]
        $w tag row CurrentRow $row
    }
    AfterQuery UNSOTZK
}

proc UnSotz:ImgPlusMinus { cod tip } {
    set img minus
    set clr R
    if { $cod > 0 }  { set img plus }
    if { $tip == 1 } { set clr G }
    return $img$clr
}

proc UnSotz:Print { } {
    global MAIN UNSOTZK
    set wdd $UNSOTZK(wddz)
    global ${wdd}UNSOTZK ${wdd}UNSOTZ
    Lindexes [UnSotz:Get:YMPdrUn $wdd] y m pdr_cod un_cod un_tip
    if ![MessageDlg $UNSOTZK(tpl).dlg -buttons { } -icon question -type user -message "    \n [subst $${wdd}UNSOTZK(head_pdr_nam)] ?" -default 0] {
        BeforeQuery UNSOTZK "   ... "
        report start unsotz
        set i 0
        set query "select distinct a.tn, a.fio, e.nam as un_nam
                       from sot a, sotdol b, dol c, sotunz d, un e
                       where a.cod = b.sot_cod and
                             b.dol_cod = c.cod and
                             c.pdr_cod = $pdr_cod and
                             a.cod = d.sot_cod and
                             d.un_cod = e.cod and
                             b.dt < '[GetFirstDayNextMonth $m $y]' and
                             ( b.du is null or b.du > '01.$m.$y' )
                       order by e.nam, a.fio"
        dpg_select $UNSOTZK(tpl) $MAIN(iddbs) $query A {
            report output [subst $${wdd}UNSOTZK(head_pdr_nam)] \
                   [cnvs $A(un_nam)] $A(tn) [cnvs $A(fio)] 
            ProgressIncr UNSOTZK(progress) [incr i] 20
        }
        PrintDoc $UNSOTZK(tpl) " " [report stop]
        AfterQuery UNSOTZK
    }
}
