proc Vidano {} {
    global VIDANO VIDANOSOT_DATA VIDANOUN_DATA MAIN VIDANOITOG_DATA
    Unset VIDANO
    if [winfo exists .vidano] { destroy .vidano }
    toplevel .vidano
    wm withdraw .vidano
    wm title .vidano ""

    LoadWhileCreateWindow .vidano

    menu .vidano.menu
    .vidano.menu add command -label " " -command Vidano:PrintBuh
    .vidano.menu add command -label " " -command Vidano:PrintPlat
    .vidano.menu add command -label " " -command Vidano:PrintBank
    .vidano.menu add separator
    .vidano.menu add command -label ""

    # MainFrame ####################################################################
    set mf [MainFrame .vidano.mf -textvariable VIDANO(status) \
            -progressvar VIDANO(progress) -progresstype infinite -progressmax 100]
    packef $mf
    $mf showstatusbar progression
    set tb [$mf addtoolbar]
    set mff [$mf getframe]
    
    # ToolBar ######################################################################
    pack [ButtonBox $tb.bb1 -spacing 0] -side left
    foreach { i j k } { printer "   <F4>" Vidano:WPrint } {
        set VIDANO(button,$i) [$tb.bb1 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k]
    }
    pack [Separator $tb.sep1 -orient vertical] -side left -fill y -padx 2
    pack [ButtonBox $tb.bb2 -spacing 0 ] -side right
    foreach { i j k } { quit "  <Esc> " "Escape .vidano VIDANO" } {
        $tb.bb2 add -image $i -helptext $j -relief link -takefocus 0 \
            -highlightthickness 0 -command $k
    }
    
    # Head #########################################################################

    packef [frame $mff.head]
    
    Pdr:Sel VIDANO
    Un:HeSel -1 v VIDANO
    set VIDANO(head_vtmonth_year) $MAIN(tmonthyear)
    set VIDANO(head_ptmonth_year) $MAIN(ptmonthyear)
    set VIDANO(shablon_dat)       $MAIN(day)
    set VIDANO(shablon_summa)     0

    if { [Stat:Get [lindex $VIDANO(lun_cod) 0]] == 3 } {
        set VIDANO(head_ptmonth_year) $VIDANO(head_vtmonth_year)
    }

    packef [TitleFrame $mff.head.shbl -text ""] -side right
    set shbl [$mff.head.shbl getframe]
    pack [LabelEntry $shbl.dat   -label " " -textvariable VIDANO(shablon_dat) \
        -width 2 \
        -helptext "     \n    "] -anchor w
    $shbl.dat bind <FocusIn> {
        if ![IsBe VIDANO(shablon_dat)] {
            set VIDANO(shablon_dat) $MAIN(day)
        }
    }
    pack [LabelEntry $shbl.summa -label " " -textvariable VIDANO(shablon_summa) \
        -width 8 \
        -helptext "     \n    "] -anchor w
    pack [Button $shbl.b2 -text " " -command Vidano:AutoCreate \
        -helptext "       \n    "] \
        -padx 3 -pady 3
    pack [Separator $mff.head.sep -orient vertical] -side right -fill y -padx 5
    
    pack [set hf1 [frame $mff.head.f1]]
    pack [label $hf1.l1 -text  -font [option get $hf1 bigFont Frame] \
        -fg black] -side left
    pack [ComboBox $hf1.un -editable 0 -label "  " -width 30 \
        -values $VIDANO(lun_nam) -modifycmd Vidano:Sel \
        -textvariable VIDANO(head_un_nam) \
        -helptext "   "] -side left
    
    pack [set hf10 [frame $mff.head.f10]]
    pack [ComboBox $hf10.pmonthyear -editable 0 -label "  " -width 13 -height 14 \
        -modifycmd Vidano:Sel \
        -textvariable VIDANO(head_ptmonth_year) \
        -helptext "   \n     "] -side left
    set VIDANO(pmonthyearwindow) $hf10.pmonthyear
    Vidano:ListPTMonthYear        
    pack [ComboBox $hf10.vmonthyear -editable 0 -label "  " -width 13 -height 13 \
        -values [YearAmongMonth $VIDANO(head_vtmonth_year)] -modifycmd Vidano:Sel \
        -textvariable VIDANO(head_vtmonth_year) \
        -helptext "   \n     "] -side left
    set VIDANO(vmonthyearwindow) $hf10.vmonthyear    
    
    pack [set hf11 [frame $mff.head.f11]]
    pack [ComboBox $hf11.pdr -editable 0 -label "   " -width 30 \
        -values $VIDANO(lpdr_nam) -modifycmd Vidano:Sel \
        -textvariable VIDANO(head_pdr_nam) \
        -helptext "   "] -side left

    set VIDANO(unwindow)         $hf1.un
    set VIDANO(pdrwindow)        $hf11.pdr

    pack [set hf2 [frame $mff.head.f2]]
    pack [label $hf2.l1      -text " "] -side left
    pack [label $hf2.fio     -textvar VIDANO(head_fio) -width 50 -relief sunken \
        -anchor w -fg black] -side left
    pack [label $hf2.l2      -text "  .N "] -side left
    pack [label $hf2.tn      -textvar VIDANO(head_tn) -width 5 -relief sunken \
        -anchor e -fg black] -side left
    
    # Main ########################################################################
    
    pack [set main [frame $mff.main -bd 1 -relief sunken]] \
        -pady 2 -padx 3 -anchor s -fill y
    pack [scrollbar $main.sby -command "$main.tblun yview"] -side right -fill y
    pack [scrollbar $main.sbx -command "$main.tblun xview" -orient hor] \
        -side bottom -fill x
    
    # Itog ##
    pack [table $main.tblitog -height 1 -rows 1 -width 8 -cols 8 -relief flat \
        -variable VIDANOITOG_DATA \
        -titlerows 0 -state disabled \
        -titlecols 2 \
        -titlerows 1 \
        -highlightthickness 0 \
        -colorigin -2 \
        -roworigin -1] -side bottom -anchor e
    
    TkTableInitTag $main.tblitog
    $main.tblitog width -2 33  -1 11  0 8  1 8  2 8  3 8  4 8  5 8
#    $main.tblitog tag row TitleCol -1
    bindtags $main.tblitog nothing
    
    # Sot ##
    pack [table $main.tblsot -height 19 -rows 19 -width 2 -cols 2 -relief flat \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable VIDANOSOT_DATA \
        -titlerows 3 -state disabled \
        -highlightthickness 0 \
        -roworigin -3] -side left
    
    TkTableInitTag $main.tblsot
    $main.tblsot spans -3,0 3,0 -3,1 3,0
    $main.tblsot width 0 33 1 11
    $main.tblsot tag col TitleCol2 0 1
    bindtags $main.tblsot nothing
    
    # Un ##
    pack [table $main.tblun -height 19 -rows 19 -width 6 -relief flat \
        -yscrollcommand "Vidano:TblUn:ScrollY $main.tblsot  $main.tblun $main.sby" \
        -xscrollcommand "Vidano:TblUn:ScrollX $main.tblitog $main.tblun $main.sbx" \
        -browsecommand " Vidano:Tbl:Browsecommand $main.tblun " \
        -rowtagcommand { TkTableRowTagCmd } \
        -variable VIDANOUN_DATA \
        -titlerows 3 \
        -highlightthickness 0 \
        -roworigin -3 ] -side left
    TkTableInitTag $main.tblun
    TkTableInitBind $main.tblun
    $main.tblun width 0 8  1 8  2 8  3 8  4 8  5 8
    $main.tblun spans -3,0 0,6 -2,0 1,0 -2,1 1,0 -2,2 1,0 -2,3 1,0 -2,4 1,0 -2,5 1,0

    set VIDANO(tblsotwindow)  $main.tblsot
    set VIDANO(tblunwindow)   $main.tblun
    set VIDANO(tblitogwindow) $main.tblitog
    
    bind $main.tblun <KeyPress-Down>       {}
    bind $main.tblun <F8>      "Vidano:Del {} {}"
    bind $main.tblun <FocusIn> {
        [winfo parent %W] configure -bg blue4
    }
    bind $main.tblun <FocusOut> {
        [winfo parent %W] configure -bg grey85
    }
    bind $main.tblun <KeyRelease-Return>   { Vidano:Bind:Tbl:KeyRE %W }
    bind $main.tblun <KeyRelease-KP_Enter> { Vidano:Bind:Tbl:KeyRE %W }
    
    DynamicHelp::register $main.tbl balloon "     "

    bind .vidano <Escape> "$tb.bb2 invoke 0"
    bind .vidano <F4>     "$tb.bb1 invoke 0"
    bind .vidano <3>      [list VidanoSot .vidano %x %y %X %Y]
    
    BWidget::place .vidano 0 0 center
    wm deiconify .vidano

    Vidano:Sel
}

proc Vidano:Bind:Tbl:KeyRE { w } {
    regsub -all "\n|\r" [$w curvalue] "" str
    catch    [$w set active $str]
    set row  [$w index active row]
    set col  [$w index active col]
    Vidano:Write $row $col
    event generate $w <KeyPress-Down>
}

proc Vidano:TblUn:ScrollY { wtblsot wtblun wsby args } {
    eval $wsby set $args
    $wtblsot yview [$wtblun index topleft row]
}

proc Vidano:TblUn:ScrollX { wtblitog wtblun wsbx args } {
    eval $wsbx set $args
    $wtblitog xview [$wtblun index topleft col]
}

proc Vidano:Tbl:Browsecommand { w } {
    global VIDANO VIDANOUN_DATA VIDANOSOT_DATA
    set active [$w index active]
    if ![IsBe VIDANOUN_DATA(oldactive)] { set VIDANOUN_DATA(oldactive) $active }
    scan [TkTableNotActiveDisabled $w $VIDANOUN_DATA(oldactive) $active] \
         "%s%s%s%s%s%s" oldactive active oldrow row oldcol col

    Vidano:Visual:Head $row

    $w tag row [TkTableRowTagCmd $oldrow] $oldrow
    $VIDANO(tblsotwindow) tag row [TkTableRowTagCmd $oldrow] $oldrow
    $w tag row CurrentRow $row
    $VIDANO(tblsotwindow) tag row CurrentRow $row
    
    set VIDANOUN_DATA(oldactive) $active
}

proc Vidano:Visual:Head { row } {
    global VIDANO VIDANOSOT_DATA
    set lfield "fio tn"
    foreach i $lfield { set VIDANO(head_$i) "" }
    if [IsBe VIDANOSOT_DATA($row,sot_cod)] {
        foreach i $lfield { set VIDANO(head_$i) $VIDANOSOT_DATA($row,$i) }
    } else {
        foreach i $lfield { set VIDANO(head_$i) "" }
    }
}

proc Vidano:WPrint {} {
    global VIDANO
    set w $VIDANO(button,printer)
    .vidano.menu post [expr [winfo rootx $w] + 3] \
                    [expr [winfo rooty $w] + [winfo height $w]]
    focus .vidano.menu
    .vidano.menu activate 0
}

proc Vidano:ListPTMonthYear {} {
    global VIDANO
    set VIDANO(allperiod) " "
    $VIDANO(pmonthyearwindow) configure -values "{$VIDANO(allperiod)} [YearAmongMonth $VIDANO(head_ptmonth_year)]"
}
