proc Vidano:Get:UnPdrYM {} {
    global VIDANO
    set un_cod -1
    if { [set idx [$VIDANO(unwindow) getvalue]] != -1 } {
        set un_cod [lindex $VIDANO(lun_cod) $idx]
    }
    set pdr_cod -1
    if { [set idx [$VIDANO(pdrwindow) getvalue]] != -1 } {
        set pdr_cod [lindex $VIDANO(lpdr_cod) $idx]
    }
    
    set pm [GetMonthInt [lindex $VIDANO(head_ptmonth_year) 0]]
    set py [lindex $VIDANO(head_ptmonth_year) 1]
    
    set vm [GetMonthInt [lindex $VIDANO(head_vtmonth_year) 0]]
    set vy [lindex $VIDANO(head_vtmonth_year) 1]

    set pfirstdaynm [GetFirstDayNextMonth $pm $py]
    set vfirstdaynm [GetFirstDayNextMonth $vm $vy]
    return "$un_cod $pdr_cod $py $pm $vy $vm $pfirstdaynm $vfirstdaynm"
}

proc Vidano:Sel {} {
    global VIDANO MAIN VIDANOSOT_DATA VIDANOUN_DATA VIDANOUN_OLDDATA VIDANOITOG_DATA
    
    set w1 $VIDANO(tblsotwindow)
    set w2 $VIDANO(tblunwindow)
    set w3 $VIDANO(tblitogwindow)
    eval destroy [ChildrenWindow $w2]
    Unset VIDANOSOT_DATA VIDANOUN_DATA VIDANOUN_OLDDATA VIDANOITOG_DATA
    
    focus $w2
    set rowwtag [$w2 tag row CurrentRow]
    if { $rowwtag != "" } {
        eval $w2 tag row null $rowwtag
        eval $w1 tag row null $rowwtag
        eval $w2 tag row [TkTableRowTagCmd $rowwtag] $rowwtag
    }
    $w2 activate 0,0
    $w2 tag row CurrentRow 0
    $w1 tag row CurrentRow 0
    set VIDANOUN_DATA(oldactive) 0,0
    
    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
    if [regexp $py $VIDANO(allperiod)] {
        set allperiod1 1=1
        set allperiod2 "'01.$vm.$vy'"
        set allperiod3 1=1
    } else {
        set allperiod1 "b.datperiod = '01.$pm.$py'"
        set allperiod2 "'01.$pm.$py'"
        set allperiod3 "b.datperiod = g.datperiod"
    }
    set VIDANOSOT_DATA(-3,0)   "  "
    set VIDANOSOT_DATA(-3,1)   "  \n    \n $vfirstdaynm"
    set VIDANOUN_DATA(-3,0)    " "
    set VIDANOITOG_DATA(-1,-1) ":"

    BeforeQuery VIDANO "     ... "
    set i 0

    set VIDANO(query) "select distinct a.cod as sot_cod, a.tn, a.fio, 
                              date_part('day',b.datvidano) as dayvidano,
                              g.summa, g.cod as vidano_cod, 
                              sotsaldonm(a.cod,$vy,$vm) as saldo,
                              max(d.oklad) as oklad, max(d.tarif) as tarif, 
                              max(d2.d) as d, max(d2.h) as h
                   from sot a left outer join vidano as b on
                                   b.un_cod = $un_cod and
                                   $allperiod1 and
                                   b.datvidano >= '01.$vm.$vy' and
                                   b.datvidano < '$vfirstdaynm'
                              join sotdol as c on 
                                   a.cod = c.sot_cod and
                                   c.dt < '$pfirstdaynm' and
                                   ( c.du is null or c.du > $allperiod2 )
                              join dol as d on 
                                   c.dol_cod = d.cod and
                                   d.pdr_cod = $pdr_cod
                              join cal as d2 on
                                   d.rn_cod = d2.rn_cod and
                                   d2.dat = $allperiod2
                              left outer join vidano as g on 
                                   g.sot_cod = a.cod and
                                   $allperiod3 and
                                   b.datvidano = g.datvidano and
                                   g.un_cod = $un_cod
                   group by a.cod, a.tn, a.fio, b.datvidano, g.summa, g.cod
                   order by a.fio, dayvidano"
    
    set oldsot_cod -1
    set olddol_cod -1
    set cntnach 0
    set cntsot 0
    dpg_select .vidano $MAIN(iddbs) $VIDANO(query) A {
        if { $oldsot_cod == $A(sot_cod) } { 
            incr cntnach 
        } else {
            #  
            foreach x { sot_cod tn } {
                set VIDANOSOT_DATA($cntsot,$x) $A($x)
            }
            set VIDANOSOT_DATA($cntsot,fio) [cnvs $A(fio)]
            set VIDANOSOT_DATA($cntsot,0)   [cnvs $A(fio)]
            set VIDANOSOT_DATA($cntsot,1)   [format "%11.2f" $A(saldo)]
            set cntnach 0
            incr cntsot
        }
        #  
        set VIDANOUN_DATA(-2,$cntnach) $A(dayvidano)
        set cs [expr $cntsot - 1]
        set VIDANOUN_DATA($cs,$cntnach,vidano_cod) $A(vidano_cod)
        set VIDANOUN_DATA($cs,$cntnach) $A(summa)
        Vidano:Incr:Itog $cntnach + $A(summa)
        ProgressIncr VIDANO(progress) [incr i] 20
        set oldsot_cod $A(sot_cod)
    }

    set cols [expr $cntnach + 2]
    if { $cols < 6 } { set cols 6 }
    #    tktable
    for { set i 0 } { $i < $cols } { incr i } {
        append widthcfg " $i 8"
        append allcols "$i "
    }

    set titrows [$w1 cget -titlerows]
    if { $cntsot > [expr [$w1 cget -height] - $titrows] } {
        set rows [expr $cntsot + $titrows]
    } else {
        set rows [$w1 cget -height]
    }
    set efg [option get $w2 titleForeground Table]
    set ebg [$w2 tag cget title -bg]
    
    $w1 configure -rows $rows
    $w2 configure -cols $cols -rows $rows
    $w3 configure -cols [expr $cols + 2]
    if { $cols > 6 } {
        eval $w2 width $widthcfg
        eval $w3 width $widthcfg
        regsub -all "\[0-9]* " $allcols "-2,& 1,0 " allspans
        eval $w2 spans $allspans -3,0 0,[expr $cntnach + 1]
    }
    eval $w2 tag col AnchorE $allcols
    
    #  entry  
    foreach i $allcols {
        frame $w2.f$i -bg $ebg -bd 1 -relief raised
        DynamicHelp::register $w2.f$i balloon "    "
        pack [entry $w2.f$i.e#$i -width 3 -justify center \
            -textvar VIDANOUN_DATA(-2,$i) -bd 2 -relief groove -fg $efg -bg $ebg \
            -takefocus 0 -highlightthickness 0] -pady 5
        bindtags $w2.f$i.e#$i "Entry $w2.f$i.e#$i .vidano all"
        bind $w2.f$i.e#$i <FocusIn>  {
            %W configure -bg grey95 -fg black
            regsub ".*#" %W "" col
            set VIDANOUN_OLDDATA(-2,$col) $VIDANOUN_DATA(-2,$col)
            if ![IsBe VIDANOUN_DATA(-2,$col)] {
                set VIDANOUN_DATA(-2,$col) $MAIN(day)
            }
        }
        bind $w2.f$i.e#$i <FocusOut> [list %W configure -bg $ebg -fg $efg]
        bind $w2.f$i.e#$i <KeyRelease-Return>   [list Vidano:Bind:Tbl:Entry %W $w2 ]
        bind $w2.f$i.e#$i <KeyRelease-KP_Enter> [list Vidano:Bind:Tbl:Entry %W $w2 ]
        bind $w2.f$i      <1>        "focus $w2.f$i.e#$i"
        $w2 window configure -2,$i -window $w2.f$i -sticky wens
    }

    array set VIDANOUN_OLDDATA [array get VIDANOUN_DATA]
    Vidano:ListPTMonthYear
    $VIDANO(vmonthyearwindow) configure -values [YearAmongMonth $VIDANO(head_vtmonth_year)]
    Vidano:Visual:Head [$w2 index active row]
    TkTableCellTagErrorNull $w2
    AfterQuery VIDANO
}

proc Vidano:Incr:Itog { col zn s } {
    global VIDANOITOG_DATA
    if ![IsBe VIDANOITOG_DATA(-1,$col)] { set VIDANOITOG_DATA(-1,$col) 0 }
    if { $s > 0 } {
        set VIDANOITOG_DATA(-1,$col) [expr $VIDANOITOG_DATA(-1,$col) $zn $s]
    }
}

proc Vidano:Bind:Tbl:Entry { w wtbl } {
    global VIDANOUN_DATA VIDANOUN_OLDDATA
    focus $wtbl
    regsub ".*#" $w "" col
    if { ![IsBe VIDANOUN_DATA(-2,$col)] && [IsBe VIDANOUN_OLDDATA(-2,$col)] } {
        set VIDANOUN_DATA(-2,$col) $VIDANOUN_OLDDATA(-2,$col)
    }
    if { [IsBe VIDANOUN_DATA(-2,$col)] && [IsBe VIDANOUN_OLDDATA(-2,$col)] &&
         $VIDANOUN_DATA(-2,$col) != $VIDANOUN_OLDDATA(-2,$col) } {
        Vidano:UpdD $col
    }
}

proc Vidano:UpdD { col } {
    global VIDANOSOT_DATA VIDANOUN_DATA MAIN VIDANO
    if ![MessageDlg .vidano.dlg -buttons { } -icon question -type user \
        -message "   \n   ? " -default 0] {
        BeforeQuery VIDANO "    ... "

        Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
        pg_exec $MAIN(iddbs) "begin work"
        
        #   
        set oldsotcod -1
        set err 0
        set i 0
        set err [dpg_select .vidano $MAIN(iddbs) $VIDANO(query) A {
            if { $oldsotcod != $A(sot_cod) } {    
                if [IsBe VIDANOUN_DATA($i,$col,vidano_cod)] {
                    set query "select vidano_updd($VIDANOUN_DATA($i,$col,vidano_cod),
                                   '$VIDANOUN_DATA(-2,$col).$vm.$vy') as cod"
                    set err [dpg_select .vidano $MAIN(iddbs) $query B {}]
                    if { $err == -1 } break
                }
                ProgressIncr VIDANO(progress) [incr i] 20
            }
            set oldsotcod $A(sot_cod)
        }]
        
        if { $err != -1 } {
            pg_exec $MAIN(iddbs) "commit work"
        } else {
            pg_exec $MAIN(iddbs) "rollback work"
        }
        Vidano:Sel
    }
}

proc Vidano:Write { row col } {
    global VIDANOUN_DATA VIDANOUN_OLDDATA VIDANOSOT_DATA
    
    if { [IsBe VIDANOSOT_DATA($row,sot_cod)] && 
         [IsBe VIDANOUN_DATA($row,$col)] } {
        if ![IsBe VIDANOUN_DATA($row,$col,vidano_cod)] {
            Vidano:Ins $row $col
        } else {
            if { $VIDANOUN_DATA($row,$col) != $VIDANOUN_OLDDATA($row,$col) } {
                Vidano:Upd $row $col
            }
        }
    } elseif { [IsBe VIDANOSOT_DATA($row,sot_cod)] && [IsBe VIDANOUN_DATA(-2,$col)] && 
               ![IsBe VIDANOUN_DATA($row,$col)]  && [IsBe VIDANOUN_OLDDATA($row,$col)] } {
        Vidano:Del $row $col
    }
}

proc Vidano:Ins { row col } {
    global VIDANO VIDANOUN_DATA VIDANOUN_OLDDATA VIDANOSOT_DATA MAIN
    
    set w $VIDANO(tblunwindow)
    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
    if ![regexp $py $VIDANO(allperiod)] {
        if [IsBe VIDANOUN_DATA(-2,$col)] {
            BeforeQuery VIDANO "   $row ... "
            Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm

            set query "select vidano_ins($VIDANOSOT_DATA($row,sot_cod),
                                         $un_cod,
                                         '01.$pm.$py',
                                         '$VIDANOUN_DATA(-2,$col).$vm.$vy',
                                         $VIDANOUN_DATA($row,$col)) as cod"
            set err [dpg_select .vidano $MAIN(iddbs) $query A {
                set VIDANOUN_DATA($row,$col,vidano_cod)  $A(cod)
                incr VIDANO(progress)
            }]
            if { $err == -1 } {
                eval $w tag cell Error $row,$col
            } else {
                set VIDANOSOT_DATA($row,1) [format "%11.2f" [expr $VIDANOSOT_DATA($row,1) - \
                                                 $VIDANOUN_DATA($row,$col)]]
                set VIDANOUN_OLDDATA($row,$col)            $VIDANOUN_DATA($row,$col)
                set VIDANOUN_OLDDATA($row,$col,vidano_cod) $VIDANOUN_DATA($row,$col,vidano_cod)
                Vidano:Incr:Itog $col + $VIDANOUN_DATA($row,$col)
                eval $w tag cell null [$w tag cell Error]
            }
            AfterQuery VIDANO
        } else {
            MessageDlg .vidano.dlg -type ok -icon warning -message "    !!!"
        }
    } else {
        MessageDlg .vidano.dlg -type ok -icon warning -message "     < > !!! \n  ,     ."
    }
}

proc Vidano:Upd { row col } {
    global VIDANO VIDANOUN_DATA VIDANOUN_OLDDATA VIDANOSOT_DATA MAIN
    set w $VIDANO(tblunwindow)

    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm

    if ![MessageDlg .vidano.dlg -buttons { } -icon question -type user -message "  \n  01.$pm.$py \n  $VIDANOUN_DATA(-2,$col).$vm.$vy \n  $VIDANOSOT_DATA($row,0) ?" -default 0] {
        BeforeQuery VIDANO "   $row ... "
        set query "select vidano_upd($VIDANOUN_DATA($row,$col,vidano_cod),
                                    $VIDANOUN_DATA($row,$col)
                                   ) as cod"
        set err [dpg_select .vidano $MAIN(iddbs) $query A {
            incr VIDANO(progress)
        }]
        if { $err == -1 } {
            eval $w tag cell Error $row,$col
        } else {
            set VIDANOSOT_DATA($row,1) [format "%11.2f" [expr $VIDANOSOT_DATA($row,1) + \
                                             $VIDANOUN_OLDDATA($row,$col) - \
                                             $VIDANOUN_DATA($row,$col)]]
            Vidano:Incr:Itog $col - $VIDANOUN_OLDDATA($row,$col)
            Vidano:Incr:Itog $col + $VIDANOUN_DATA($row,$col)
            set VIDANOUN_OLDDATA($row,$col) $VIDANOUN_DATA($row,$col)
            eval $w tag cell null [$w tag cell Error]
        }
        AfterQuery VIDANO
    }
}

proc Vidano:Del { row col } {
    global VIDANOUN_DATA VIDANO VIDANOUN_OLDDATA MAIN VIDANOSOT_DATA
    set w $VIDANO(tblunwindow)
    if ![IsBe row] { set row [$w index active row] }
    if ![IsBe col] { set col [$w index active col] }

    if [IsBe VIDANOUN_DATA($row,$col,vidano_cod)] {
        if ![MessageDlg .vidano.dlg -buttons { } -icon question -type user -message " \n $VIDANOUN_DATA(-2,$col) \n  $VIDANOSOT_DATA($row,0) ?" -default 0] {
            BeforeQuery VIDANO "  ... "
            set query "select vidano_del($VIDANOUN_DATA($row,$col,vidano_cod))"
            set err [dpg_select .strorg $MAIN(iddbs) $query A {
                incr VIDANO(progress)
            }]
            if { $err == -1 } {
                eval $w tag cell Error $row,$col
            } else {
                set VIDANOSOT_DATA($row,1) [format "%11.2f" [expr $VIDANOSOT_DATA($row,1) + \
                                                $VIDANOUN_OLDDATA($row,$col)]]
                eval $w tag cell null [$w tag cell Error]
                Vidano:Incr:Itog $col - $VIDANOUN_OLDDATA($row,$col)
                set VIDANOUN_DATA($row,$col) ""
                Unset VIDANOUN_DATA($row,$col) VIDANOUN_OLDDATA($row,$col) 
                Unset VIDANOUN_DATA($row,$col,vidano_cod) VIDANOUN_OLDDATA($row,$col,vidano_cod)
            }
            AfterQuery VIDANO
        }
    }
}

proc Vidano:PrintPlat {} {
    global VIDANO VIDANOUN_DATA
    set col [$VIDANO(tblunwindow) index active col]
    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
    if ![IsBe VIDANOUN_DATA(-2,$col)] {
        MessageDlg .vidano.dlg -type ok -icon warning -message "    !!!\n        ."
    } else {
        set where   "c.pdr_cod = $pdr_cod and
                     b.dt < '[GetFirstDayNextMonth $vm $vy]' and
                     ( b.du is null or b.du > '01.$vm.$vy' )"
        set unwhere "c.cod = $un_cod"
        Platve:Report .vidano VIDANO $VIDANO(head_vtmonth_year) $vy $vm \
            $VIDANOUN_DATA(-2,$col) $where $unwhere
    }
}

proc Vidano:PrintBank {} {
    global VIDANO VIDANOUN_DATA
    set col [$VIDANO(tblunwindow) index active col]
    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
    if ![IsBe VIDANOUN_DATA(-2,$col)] {
        MessageDlg .vidano.dlg -type ok -icon warning -message "    !!!\n        ."
    } else {
        set where   "c.pdr_cod = $pdr_cod and
                     b.dt < '[GetFirstDayNextMonth $vm $vy]' and
                     ( b.du is null or b.du > '01.$vm.$vy' )"
        set unwhere "c.cod = $un_cod"
        Bankve:Report .vidano VIDANO $VIDANO(head_vtmonth_year) $vy $vm \
            $VIDANOUN_DATA(-2,$col) $where $unwhere
    }
}

proc Vidano:PrintBuh { } {
    global MAIN VIDANO
    if ![MessageDlg .vidano.dlg -buttons { } -icon question -type user -message "    \n $VIDANO(head_pdr_nam) ?" -default 0] {
        BeforeQuery VIDANO "   ... "
        report start vidano
        set i 0
        set kredit 0
        set debet 0
        set oldsotcod -1
        dpg_select .vidano $MAIN(iddbs) $VIDANO(query) A {
            if { $A(summa) > 0 } {
                if { $oldsotcod != $A(sot_cod) } {
                    if { $A(saldo) > 0 } {
                        set kredit [expr $kredit + $A(saldo)]
                    }
                    if { $A(saldo) < 0 } {
                        set debet [expr $debet - $A(saldo)]
                    }
                }
                report output $VIDANO(head_un_nam) \
                              $VIDANO(head_vtmonth_year) \
                              $VIDANO(head_pdr_nam) \
                              $A(tn) \
                              [cnvs $A(fio)] \
                              $A(saldo) \
                              $A(dayvidano) \
                              $A(summa) \
                              $kredit \
                              $debet \
                              $VIDANO(head_ptmonth_year)
                ProgressIncr VIDANO(progress) [incr i] 20
                set oldsotcod $A(sot_cod)
            }
        }
        PrintDoc .vidano "" [report stop]
        AfterQuery VIDANO
    }
}

proc Vidano:AutoCreate {} {
    global VIDANO MAIN VIDANOSOT_DATA VIDANOUN_DATA
    

    Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
    if ![regexp $py $VIDANO(allperiod)] {
        if { [IsBe VIDANO(shablon_dat)] && [IsBe VIDANO(shablon_summa)] } {
            if ![MessageDlg .vidano.dlg -buttons { } -icon question -type user \
                -message "  !!!\n     ,\n    01.$pm.$py  $VIDANO(shablon_dat).$vm.$vy\n\n    ? " -default 0] {
                BeforeQuery VIDANO "     ... "

                Lindexes [Vidano:Get:UnPdrYM] un_cod pdr_cod py pm vy vm pfirstdaynm vfirstdaynm
                set i 0
                
                pg_exec $MAIN(iddbs) "begin work"
                
                #    ( )    
                set col -1
                set aget [array get VIDANOUN_DATA -2,*]
                regsub -all -- "^0" $VIDANO(shablon_dat) "" VIDANO(shablon_dat)
                set idx [lsearch $aget $VIDANO(shablon_dat)]
                if { $idx >= 0 } {
                    scan [lindex $aget [incr idx -1]] "%\[^,]%*c%s" row col
                }
                
                #   
                set oldsotcod -1
                set err 0
                set flgavans 0
                if { [Stat:Get $un_cod] == 3 } { set flgavans 1 }
                set err [dpg_select .vidano $MAIN(iddbs) $VIDANO(query) A {
                    if { $oldsotcod != $A(sot_cod) } {    
                        if ![IsBe VIDANOUN_DATA($i,$col,vidano_cod)] {
                            if { $VIDANO(shablon_summa) == 0 } {
                                #  
                                if $flgavans { 
                                    set summa [Tabel:Raschet $un_cod $A(oklad) $A(tarif) 0 \
                                                $A(d) $A(h) $A(d) $A(h)]
                                } else {
                                    set summa $VIDANOSOT_DATA($i,1)
                                    Lindexes [Un:GetFormula $un_cod $summa] c1 c2 c3 c4
                                    set summa [expr ($summa - $c1) * $c4 / 100 + $c3]
                                }
                            } else {
                                set summa $VIDANO(shablon_summa)
                            }
                            set query "select vidano_ins($A(sot_cod),
                                                         $un_cod,
                                                         '01..$pm.$py',
                                                         '$VIDANO(shablon_dat).$vm.$vy',
                                                         $summa) as cod"
                            if { $summa > 0 } {
                                set err [dpg_select .vidano $MAIN(iddbs) $query B {}]
                            }
                            if { $err == -1 } break
                        }
                        ProgressIncr VIDANO(progress) [incr i] 20
                    }
                    set oldsotcod $A(sot_cod)
                }]
                
                if { $err != -1 } {
                    pg_exec $MAIN(iddbs) "commit work"
                } else {
                    pg_exec $MAIN(iddbs) "rollback work"
                }
                Vidano:Sel
            }
        } else {
            MessageDlg .vidano.dlg -type ok -icon warning -message "   !!!"
        }
    } else {
        MessageDlg .vidano.dlg -type ok -icon warning -message "     < > !!! \n  ,     ."
    }
}
