proc VidanoSot { tpl x y X Y } {
    global VIDANOSOT VIDANO VIDANOSOT_DATA
    
    set row [$VIDANO(tblunwindow) index @$x,$y row]
    set col [$VIDANO(tblunwindow) index @$x,$y col]

    if [IsBe VIDANOSOT_DATA($row,sot_cod)] {
        Unset VIDANOSOT
        set w $tpl.vidanosot
        set VIDANOSOT(tpl) $w
        if [winfo exists $w] { destroy $w }
        toplevel $w
        wm transient $w $tpl
        wm withdraw $w
        wm title $w "  "
        wm resizable $w 0 0

        pack [set f1 [frame $w.f1 -bd 2 -relief groove]] -fill x
        pack [label $f1.l1 -text " " -bd 0 -highlightthickness 0] -pady 0
        pack [label $f1.l2 -text $VIDANOSOT_DATA($row,0) \
            -bd 0 -highlightthickness 0] -pady 0
        pack [label $f1.l3 -text " $VIDANO(head_vtmonth_year)" \
            -bd 0 -highlightthickness 0] -pady 0

        bind $w      <Escape> [list destroy $w]
        bind $w      <B3-ButtonRelease>      [list destroy $w]
        packef [set sw [ScrolledWindow $w.sw -scrollbar vertical -relief sunken]]
        set sf [ScrollableFrame $sw.f -height 200 -width 260]
        $sw setwidget $sf
        set sff [$sf getframe]
        VidanoSot:Sel $sff $VIDANOSOT_DATA($row,sot_cod)
        wm geometry $w +[expr $X + 6]+[expr $Y + 12]
        wm deiconify $w 
        grab $w
    }
}

proc VidanoSot:Ud { w n un_nam} {
    global VIDANOSOT
    pack [frame $w.${n}f -bd 1 -relief sunken] -pady 2 -fill x
    pack [label $w.${n}f.l -text " $un_nam " -bg grey75 -fg blue2] -pady 1 -anchor w
    pack [mclistbox $w.${n}f.mcl -width 30 -height 0]
        
    $w.${n}f.mcl column add datperiod  -label ""      -width 8  -foreground magenta4
    $w.${n}f.mcl column add datvidano  -label " " -width 12
    $w.${n}f.mcl column add summa      -label ""       -width 10
    
    $w.${n}f.mcl label bind datperiod  <ButtonPress-1> "Mclistbox:Sort %W datperiod"
    $w.${n}f.mcl label bind datvidano  <ButtonPress-1> "Mclistbox:Sort %W datvidano"
    $w.${n}f.mcl label bind summa      <ButtonPress-1> "Mclistbox:Sort %W summa"
    
    bind $w.${n}f.mcl <B3-ButtonRelease>      [list destroy $VIDANOSOT(tpl)]
    return $w.${n}f.mcl
}

proc VidanoSot:Sel { tpl sot_cod } {
    global VIDANOSOT VIDANO MAIN
    Lindexes [Vidano:Get:UnPdrYM] fuf fuf py pm vy vm pfirstdaynm vfirstdaynm
    BeforeQuery VIDANO "     ... "
    
    set oldunnam ""
    set query "select distinct b.cod, a.datperiod, 
                      date_part('month',a.datperiod) as pm,
                      date_part('year',a.datperiod) as py,
                      a.datvidano, b.nam, a.summa
                from vidano a, un b
                where a.un_cod = b.cod and
                      a.sot_cod = $sot_cod and
                      date_part('month',a.datvidano) = $vm and
                      date_part('year', a.datvidano) = $vy
                order by b.nam, a.datperiod, a.datvidano"

    set lwmcl ""
    dpg_select $tpl $MAIN(iddbs) $query A {
        if { $oldunnam != $A(nam) } {
            set wmcl [VidanoSot:Ud $tpl $A(cod) [cnvs $A(nam)]]
            lappend lwmcl $wmcl
        }
        $wmcl insert end [list [format %8.8s $A(pm).$A(py)] \
                            [format %12.12s $A(datvidano)] \
                            [format %9.9s $A(summa)]]
        incr VIDANO(progress)
        set oldunnam $A(nam)
    }
    
    foreach i $lwmcl {
        set idx [$i index end]
        $i configure -height [incr idx]
    }
    
    AfterQuery VIDANO
}
